// pdawrdoc.cpp : implementation of the CPdawrapDoc class
//

#include "stdafx.h"
//#include "common.h"
#include "mysamp.h"
#include "mysamdoc.h"
#include "mysamvw.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


#define  ID_TITLE	100
#define  ID_SUBTITLE	101
#define  ID_RH1		102
#define  ID_RH2		103
#define  ID_RH3		104
#define  ID_RH4		108
#define  ID_CH1		105
#define  ID_CH2		106
#define  ID_CH3		107
#define  ID_R1C1	300
#define  ID_R2C1	301
#define  ID_R3C1	302
#define  ID_R4C1	303
#define  ID_R1C2	400
#define  ID_R2C2	401
#define  ID_R3C2	402
#define  ID_R4C2	403
#define  ID_R1C3	500
#define  ID_R2C3	501
#define  ID_R3C3	502
#define  ID_R4C3	503
#define  BOX		999


BOOL PUBLIC InitDataCallBacks(HINSTANCE hInst, GraphPtr pGraph,INT16 Rows, INT16 Cols );
VOID PUBLIC FiniDataCallBacks(GraphPtr pGraph);

#define MaxStringSz	64

int   StringID [12] =  {ID_TITLE,
								ID_SUBTITLE,
							   ID_RH1,ID_RH2,ID_RH3,ID_RH4,
								ID_CH1,ID_CH2,ID_CH3,
								0,0,0};

char	StringData[12][MaxStringSz] = {"PG Sample Chart",
												 "by Three |D| Graphics",
												 "Dan", "Elmer","Jon","Mark",
												 "May", "June", "July",
												 "The Row Title", "The Column Title",
												 "A footnote"};

int   NumData [4][3] = {{200,300,400},
								{300,400,500},
								{400,500,600},
								{500,600,700}};


INT16 CALLBACK EXPORT  
VDM_GetStringCallback(
	INT16						nWhich,						
	char FAR *			   lpBuffer,						
	INT16						nDimBuffer,					
	INT32						lClientData						
)
{
	switch (nWhich)
	  {
	  case gsTITLE:
	    lstrcpy (lpBuffer,StringData[0]);	
		 break;
	  case gsSUBTITLE:					
	    lstrcpy (lpBuffer,StringData[1]);
		 break;
	  case gsFOOTNOTE:							
	    lstrcpy (lpBuffer,StringData[11]);
		 break;
	  case gsSERIESTITLE:						
	    lstrcpy (lpBuffer,StringData[10]);
		 break;
	  case gsGROUPSTITLE:						
	    lstrcpy (lpBuffer,StringData[9]);
		 break;
	  default:									
	    lstrcpy (lpBuffer,"XXXX");
	  }
	return TRUE;
}



	INT16 CALLBACK EXPORT  VDM_GetLabelCallback(
	INT16						nCol,			
	INT16						nRow,			 
	char FAR *		   	lpBuffer,		
	INT16						nDimBuffer,		
	INT32						lClientData		
)
{
	int i;
	
	if (nCol == -1) 	
	  i = 2 + nRow;
	else
	  i = 6 + nCol; 
	
	lstrcpy (lpBuffer,StringData[i]);	
	
	return TRUE;
}



INT16 CALLBACK EXPORT
VDM_GetDataCallback(
	INT16						nDataPt,							
	INT16						nSeries,							
	REAL64 FAR *		   prVal,							
	INT32						lClientData					
)
{    
	*prVal = (REAL64) NumData [nDataPt][nSeries];      
	return TRUE;
}



INT16 CALLBACK EXPORT
VDM_RealToStrCallback(
	REAL64					rVal,						
	char FAR *			lpszResult,						
	INT16						nDimBuffer,				
	INT16						nFmtCode,				
	INT32						lClientData				
)
{
	wsprintf(lpszResult,"%d",(int) rVal);	 		
	return TRUE;
}


INT16 CALLBACK EXPORT
VDM_SetPageCallback(
	INT16						nPage,						
	INT32						lClientData					
)
{
	return FALSE;
}		   

/////////////////////////////////////////////////////////////////////////////
// CPdawrapDoc

IMPLEMENT_DYNCREATE(CMysampDoc, CDocument)

BEGIN_MESSAGE_MAP(CMysampDoc, CDocument)
	//{{AFX_MSG_MAP(CPdawrapDoc)
	//ON_COMMAND(ID_APP_EXIT, OnAppExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPdawrapDoc construction/destruction

CMysampDoc::CMysampDoc()
{
	// TODO: add one-time construction code here
	m_pGraph   = NULL;

}

CMysampDoc::~CMysampDoc()
{
	if (m_pGraph)
	{
		FiniDataCallBacks(m_pGraph);	/* LOCAL PROC - CLEAN UP THUNKS */
		FreeGraphPtr(m_pGraph);		/* PG - FREE MEMORY USED BY THIS POINTER */
	}
}

BOOL CMysampDoc::OnNewDocument()
{
  	if (!CDocument::OnNewDocument())
		return FALSE;

													/* PG- LOAD A BAR GRAPH TEMPLATE AS DEFAULT */
	if ( !(m_pGraph = AllocGraphPtr()) ) /* PG - ALLOCATE A GRAPH POINTER */
	{
		AfxMessageBox("Can't allocate graph pointer!");
		return FALSE;
	}
							
	// THE NEXT CALL IS A LOCAL PROC THAT CALLS THE PG ROUTINES FOR
	// HOOKING UP A LOCAL DATA SOURCE TO THE PG LIBRARY
	InitDataCallBacks(AfxGetInstanceHandle(), m_pGraph,3,3);  
    
    // now actually read the graph
//		nStatus = TDIReadGraph(pGraphRec->gpGraph, REQUEST_TDC, "\\PGSDK\\DEFAULT.TDC");
	int nStatus = TDIReadGraph(m_pGraph, REQUEST_TDL, "\\PGSDK\\DEFAULT.TDL");
//	int nStatus = TDIReadGraph(m_pGraph, REQUEST_TDC, "\\PGSDK\\DUCWRAP.TDC");
	if (nStatus != E00_OK)
	{
		char msg[256];
		sprintf(msg, "TDI Error %d.", nStatus);
		AfxMessageBox(msg);
		return FALSE;
	}

	return TRUE;


//	m_strData = "Sample data String";
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

}

/////////////////////////////////////////////////////////////////////////////
// CPdawrapDoc serialization

void CMysampDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPdawrapDoc diagnostics

#ifdef _DEBUG
void CMysampDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMysampDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPdawrapDoc commands



BOOL PUBLIC InitDataCallBacks(HINSTANCE hInst, GraphPtr pGraph, INT16 Rows, INT16 Cols)
{
	GraphDataInfo		graphData;
	
	GetGraphDataInfo(pGraph, &graphData);
	
	if (!graphData.lpfnGetData)
	   { 
	//	graphData.lpfnGetString    = (LPFNGetStringCallBack)    MakeProcInstance((FARPROC) VDM_GetStringCallback, hInst);
// 		graphData.lpfnGetLabel     = (LPFNGetLabelCallBack)     MakeProcInstance((FARPROC) VDM_GetLabelCallback,  hInst);
//		graphData.lpfnGetData      = (LPFNGetDataCallBack)      MakeProcInstance((FARPROC) VDM_GetDataCallback,   hInst);
//		graphData.lpfnSetPage      = (LPFNSetPageCallBack)      MakeProcInstance((FARPROC) VDM_SetPageCallback,   hInst);
//		graphData.lpfnRealToString = (LPFNRealToStringCallBack) MakeProcInstance((FARPROC) VDM_RealToStrCallback, hInst);
		graphData.lpfnGetString    = (LPFNGetStringCallBack)VDM_GetStringCallback;
 		graphData.lpfnGetLabel     = (LPFNGetLabelCallBack)VDM_GetLabelCallback;
		graphData.lpfnGetData      = (LPFNGetDataCallBack)VDM_GetDataCallback;
		graphData.lpfnSetPage      = NULL;
		graphData.lpfnRealToString = NULL;
	  
	  
	   } 
   
	graphData.nPages      = 1;	 	
	graphData.nRows       = 4;	//4 series, this should be one for DUC and the number of data columns selected for PDA	
	graphData.nCols       = 3;	//3 columns 	
	graphData.lClientData = (UINT32) pGraph;	
	graphData.nDataIFMode = DATAIF_CALLBACK;

	return SetGraphDataInfo(pGraph, &graphData);
} 


/*BOOL InitDataCallBacks(HINSTANCE hInst,GraphPtr pGraph, INT16 Rows, INT16 Cols)
{
   GraphDataInfo           graphData;
  
   GetGraphDataInfo(pGraph, &graphData);
   graphData.lpfnGetString    = NULL;
   graphData.lpfnGetLabel     = NULL;
   graphData.lpfnGetData      = NULL;
   graphData.lpfnSetPage      = NULL;
   graphData.lpfnRealToString = NULL;
   graphData.lpfnGetRawLimits = NULL;
   graphData.nDataIFMode  = DATAIF_SENDDATA;
  
   graphData.nPages      = 1;              
//   graphData.nRows       = Rows;   
//   graphData.nCols       = Cols;  
   graphData.nRows       = 3;   
   graphData.nCols       = 3; 
  
   graphData.lClientData = (INT32) pGraph;
  
   return SetGraphDataInfo(pGraph, &graphData);
} */


VOID PUBLIC FiniDataCallBacks(GraphPtr pGraph)
{
	GraphDataInfo		graphData;
	
/*	GetGraphDataInfo(pGraph, &graphData);

	if (graphData.lpfnGetString) 
	  {
		FreeProcInstance( (FARPROC) graphData.lpfnGetString    );
		FreeProcInstance( (FARPROC) graphData.lpfnGetLabel     );
		FreeProcInstance( (FARPROC) graphData.lpfnGetData      );
		FreeProcInstance( (FARPROC) graphData.lpfnSetPage      );
		FreeProcInstance( (FARPROC) graphData.lpfnRealToString );
	  }	  */
	
}



