// pdawrvw.cpp : implementation of the CPdawrapView class
//

#include "stdafx.h"
#include "mysamp.h"
#include "mysamdoc.h"
#include "mysamvw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


//void SetRect(PRECT, RECT);
//BOOL InitDataCallBacks(GraphPtr, INT16, INT16);
/////////////////////////////////////////////////////////////////////////////
// CPdawrapView
#define	IDM_BAR		1

USHORT winID = 0;

IMPLEMENT_DYNCREATE(CMysampView, CView)

BEGIN_MESSAGE_MAP(CMysampView, CView)
	//{{AFX_MSG_MAP(CPdawrapView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_WM_CREATE()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPdawrapView construction/destruction

CMysampView::CMysampView()
{
	// TODO: add construction code here
	m_GraphValid = TRUE;
	m_Bounds.SetRect(0,0,0,0);
	m_pDrawEnv = NULL;
	m_GraphType = IDM_BAR;

}

CMysampView::~CMysampView()
{
if (m_pDrawEnv)
	FreeDrawEnvPtr(m_pDrawEnv);

}


int CMysampView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if ( !(m_pDrawEnv = AllocDrawEnvPtr((PORTWINDOW) GetSafeHwnd(), DE_PORT_NORMAL)) )	
	{
		AfxMessageBox("Can't allocate draw environment!");
		return -1;
	}
	
	return 0;
}


void CMysampView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (GetCapture() != this)
		return; // If this window (view) didn't capture the mouse,
				// then the user isn't drawing in this window.
    
	ReleaseCapture();   // Release the mouse capture established at
						// the beginning of the mouse drag.
    
 

	Invalidate(TRUE);
}



void CMysampView::OnInitialUpdate()
{
}

/////////////////////////////////////////////////////////////////////////////
void CMysampView::OnDraw(CDC* pDC)
{
	CMysampDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	Rect r;
    //SetFocus();
	GetClientRect(m_Bounds);
    SetRect(&r, m_Bounds.left, m_Bounds.top, m_Bounds.right, m_Bounds.bottom);
	if (m_GraphValid && !m_Bounds.IsRectEmpty())
	{
		/*PG - SET THE CHART'S SIZE & LOCATION IN WINDOW */
		DESetDestRect(m_pDrawEnv, &r);

   		/*PG - SET DRAWING MODE TO NORMAL, ON-SCREEN */
		DESetPortInfo(m_pDrawEnv, (PORTWINDOW) pDC->GetSafeHdc(), DE_PORT_NORMAL);

	   	/*PG - DRAW THE GRAPH */
		DrawBegin(m_pDrawEnv);
		DrawTheGraph(m_pDrawEnv, pDoc->m_pGraph, TRUE, TRUE, TRUE);
		DrawEnd(m_pDrawEnv);
	}
}













/////////////////////////////////////////////////////////////////////////////
// CPdawrapView printing

BOOL CMysampView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMysampView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMysampView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPdawrapView diagnostics

#ifdef _DEBUG
void CMysampView::AssertValid() const
{
	CView::AssertValid();
}

void CMysampView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMysampDoc* CMysampView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMysampDoc)));
	return (CMysampDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPdawrapView message handlers
