#pragma pack(2)
#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************
* from COMDEF.H
************************************************************************/

/************************************************************************
* Pointer Modifiers
************************************************************************/
#if defined(applec) || defined(THINK_C)
#define FAR
#define HUGE
#define PUBLIC
#define NEARBY
#define CALLBACK

#elif defined(_WINDOWS_NT) || defined(WIN32)
#ifndef FAR
#define FAR
#endif

#define HUGE
#define NEARBY near pascal

#define PUBLIC __declspec(dllexport)

#elif defined(_WINDOWS)
#ifndef FAR
#define FAR far
#endif

#define HUGE huge
#define NEARBY near pascal

// scott need to define PUBLIC as _export for Visual C++ for Windows 3.1
#if defined(TDI_SDK)
	#define PUBLIC far 
#else
	#define PUBLIC far pascal 
#endif

#elif defined(MSDOS)
#define FAR
#define HUGE
#define PUBLIC
#define NEARBY

#endif


/************************************************************************
* Common Types
*
* Note: For the currently supported compilers (MPW 3.x, Think C 4.x,
*				MSC 6.x) common definitions for the INT16/INT32 types
*				work. Be careful if other compilers/platforms are added
*				in the future.
************************************************************************/
//typedef char	 			INT8;				/* 8-bit integer */
#if !defined(_WINDOWS)
typedef char	 			BYTE;				/* Name conflict under WINDOWS. */
#endif

typedef short int 						INT16;				/* 16-bit signed integer */
typedef long  int							INT32;				/* 32-bit signed integer */
typedef unsigned char					UCHAR;				/* 8-bit unsigned char */
typedef unsigned short int 		UINT16;				/* 16-bit unsigned integer */
typedef unsigned long  int		UINT32;				/* 32-bit unsigned integer */
// scott changed BOOLEAN to BOOLEAN16 for _windows_nt
typedef short int							BOOLEAN16;			/* the choice between veracity and fallacy */

typedef INT32 FIXED32, FAR * PFIXED32;

/************************************************************************
* Common Pointers
************************************************************************/
typedef INT16 FAR * 		PINT16;					/* 16-bit signed integer */
typedef INT32 FAR * 		PINT32;					/* 32-bit signed integer */
typedef char FAR *			PCHAR;					/* 8-bit signed char */
typedef UCHAR FAR * 		PUCHAR;					/* 8-bit unsigned char */
typedef UINT16 FAR * 		PUINT16;				/* 16-bit unsigned integer */
typedef UINT32 FAR * 		PUINT32;				/* 32-bit unsigned integer */
typedef BOOLEAN16 FAR * 	PBOOLEAN16;				/* the choice between veracity and fallacy */

// scott added for _windows_nt
typedef struct _Rect16 {
	INT16	left;
	INT16	top;
	INT16	right;
	INT16	bottom;
}	Rect16, *Rect16Ptr;		

typedef struct _Point16 {
	INT16	x;
	INT16	y;
}	Point16, *Point16Ptr;		
// end scott added for _windows_nt		


/************************************************************************
* Common Data Structures
************************************************************************/
typedef struct _Point2D {
	INT16 					x;
	INT16 					y;
} Point2D, FAR * Point2DPtr;

typedef struct _Point3D {
	INT16 					x;
	INT16 					y;
	INT16 					z;
} Point3D, FAR * Point3DPtr;

/*
** variable length array type
*/
typedef struct {
	UINT16					uEntrySize;						/* # of bytes in each entry */
	UINT16					uGrow;								/* # of entries to grow */
	UINT16					uMax;									/* # of entries alloc'd */
	UINT16					uCount;								/* # of entries in-use */
	UCHAR						ucbData[1];						/* the actual data */
} VTable, FAR * VTablePtr;


/*
** linked list -- item type
*/
typedef struct _LLITEMREC {
	void FAR *			pNext;								/* PTR to next item */
	UINT16					uItemSize;						/* size of this item */

} LLITEMREC, FAR * LLITEMPTR;

/* %%TDIEND%%*/

/*
** linked list -- list type
*/
typedef struct _LLLISTREC {
	INT16 (FAR  * lpfnOnAlloc) (		/* PTR to alloc fn */
		struct _LLLISTREC FAR * pList,
		LLITEMPTR			pItem
	);
	
	void  (FAR  * lpfnOnFree) (			/* PTR to free fn */
		struct _LLLISTREC FAR * pList,
		LLITEMPTR			pItem
	);

	UINT16					uListSize;						/* # of bytes in list struct */
	UINT16					uItemCount;						/* # of items in list */
	void FAR *			pHead;								/* PTR to first item */

} LLLISTREC, FAR * LLLISTPTR;

/* %%TDIBEGIN%%*/

/************************************************************************
* Common Memory Definitions
************************************************************************/
typedef UINT32 			MEMSIZE;

#if defined(THINK_C)
typedef	void *			MEMPTR;
typedef MEMPTR *		MEMHDL;

#elif defined (applec)
typedef	void *			MEMPTR;
typedef MEMPTR *		MEMHDL;

#elif defined (_WINDOWS_NT)	|| defined (WIN32)
typedef void FAR *		MEMPTR;
typedef MEMPTR FAR *	MEMHDL;						/* Windows HANDLE */

#elif defined (_WINDOWS)
typedef void far *		MEMPTR;
typedef unsigned int	MEMHDL;						/* Windows HANDLE */

#elif defined (MSDOS)
typedef void FAR *		MEMPTR;
typedef void FAR *		MEMHDL;

#endif

#if defined(TDI_SDK)

#define HVA	HVARARRAY

typedef MEMPTR LLLISTPTR;

#else

typedef unsigned int	TDIHDL;						/* Windows HANDLE */
typedef unsigned int	TEXTHDL;					/* Windows HANDLE */
typedef INT16 CONTROL;
typedef MEMHDL HVA;
typedef MEMHDL VarArray;
typedef UINT32	VPSIZE;

#endif

typedef	TDIHDL /*%%struct tagSFXRecord%%*/	SFXHDL;

/************************************************************************
* File I/O Equates
************************************************************************/
#if defined(applec) || defined(THINK_C)
typedef short COOKIE;										/* this be a refNum for the mac */

#elif defined(_WINDOWS)
typedef int COOKIE;											/* this is a DOS file handle (17may90/ksk) */

#elif defined(MSDOS)
typedef FILE FAR *COOKIE;								/* this is a C file stream ptr (17may90/ksk) */

#endif


/************************************************************************
* Limit Constants
************************************************************************/
#define MIN_INT16 ((INT16) 0x8000)
#define MAX_INT16 ((INT16) 0x7fff)

#define MIN_INT32 ((INT32) 0x80000000)
#define MAX_INT32 ((INT32) 0x7fffffff)

#define MIN_UINT16 ((UINT16) 0x0000)
#define MAX_UINT16 ((UINT16) 0xffff)

#define MIN_UINT32 ((UINT32) 0x00000000)
#define MAX_UINT32 ((UINT32) 0xffffffff)


/************************************************************************
* Logic
************************************************************************/
#define FALSE		0
#define TRUE		1


/************************************************************************
* Useful Constants
************************************************************************/
#define	TWOPI	(3.14159265358979323846 * 2)
#define	PI		(3.14159265358979323846)
#define	PI2		(1.57079632679489661923)
#define	PI4		(0.78539816339744830966)
#define RADIAN 	(57.29577951)

/************************************************************************
* Useful Macros
************************************************************************/
#define ROUND(x) ((int) (((x) >= 0.0) ? (x+0.5) : (x-0.5)))
#define SQR(x) ((x)*(x))
#define FABS(x) (x >= 0.0 ? x : -x)

#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MIN(a,b) ((a) < (b) ? (a) : (b))

#define GETBIT(value,bitnumber) (((long) (value)) & ((0x00000001 << bitnumber)))
#define SETBIT(value,bitnumber) (((long) (value)) | ((0x00000001 << bitnumber)))
#define RESETBIT(value,bitnumber) (((long) (value)) & ((0x00000001 << bitnumber)^(0x00000000)))

#if defined(applec) || defined(THINK_C)
#define HIWORD(a) (HiWord ((long) a))
#define LOWORD(a) (LoWord ((long) a))
#endif


/************************************************************************
* Platform-dependent Equates
************************************************************************/
#if defined(THINK_C)
/*
 *  Think C 4.0 Defintions
 */
typedef double					REAL;						/* fastest floating point representation */
typedef short double		REAL64;					/* 64-bit floating point value */

typedef double FAR *		PREAL;					/* ptr to fastest floating point representation */
typedef short double *	PREAL64;				/* ptr to 64-bit floating point value */

#define MAX_REAL ((REAL) 1.7976931348623158e+308)
#define MIN_REAL ((REAL) 2.2250738585072014e-308)


/*
 *  The following are not defined in THINK C 4.0!
 */
#define volatile
#define const
//#define PASCAL


#elif defined(applec)
/*
 *  MPW C 3.0 Defintions
 */
typedef long double			REAL;						/* fastest floating point representation */
typedef double					REAL64;					/* 64-bit floating point value */

typedef long double *		PREAL;					/* ptr to fastest floating point representation */
typedef double FAR *		PREAL64;				/* ptr to 64-bit floating point value */

#define MAX_REAL ((REAL) 1.7976931348623158e+308)
#define MIN_REAL ((REAL) 2.2250738585072014e-308)

//#define PASCAL


#else
/*
 *  MSC 6.0 definitions
 */
typedef double			REAL;								/* fastest floating point representation */
typedef double			REAL64;							/* 64-bit floating point value */

typedef double FAR *	PREAL;						/* ptr to fastest floating point representation */
typedef double FAR *	PREAL64;					/* ptr to 64-bit floating point value */

#define MAX_REAL ((REAL) 1.7976931348623158e+308)
#define MIN_REAL ((REAL) 2.2250738585072014e-308)

#define MAX_REAL64 ((REAL) 1.7976931348623158e+308)
#define MIN_REAL64 ((REAL) 2.2250738585072014e-308)

#endif


/************************************************************************
* from STD_MEM.H
************************************************************************/
 
/*
 * Macro to get the number of elements allocated in a variable array.
 */
#define VAR_COUNT(v) (INT16)*((INT32*)((MEMPTR)((INT32*)LockHandle(v)+1))-1)

#define AllocHandle(size)      _AllocHandle(size, __FILE__, __LINE__)
#define AllocHandleClear(size) _AllocHandleClear(size, __FILE__, __LINE__)
#define FreeHandle(h) 				 _FreeHandle(h, __FILE__, __LINE__)

#define AllocPtr(size)      _AllocPtr(size, __FILE__, __LINE__)
#define AllocPtrClear(size) _AllocPtrClear(size, __FILE__, __LINE__)
#define FreePtr(p)					_FreePtr(p, __FILE__, __LINE__)

/* Allocate memory in a platform independent manner */
MEMHDL PUBLIC	
_AllocHandle(MEMSIZE size, char FAR * pFileName, int lineNo);

/* Allocate CLEARED memory in a platform independent manner */
MEMHDL PUBLIC	
_AllocHandleClear(MEMSIZE size, char FAR * pFileName, int lineNo);

/* Resize a previous memory allocation */
MEMHDL PUBLIC
ReAllocHandle(MEMHDL FAR *handle, MEMSIZE size);

/* Resize a previous memory allocation; If growing, zero new bytes */
MEMHDL PUBLIC
ReAllocHandleClear(MEMHDL FAR *handle, MEMSIZE size);

/* Grab and lockdown a particular section of allocated memory*/
MEMPTR PUBLIC			
LockHandle(MEMHDL handle);

/* Unlock a particular section of memory */
void PUBLIC				
UnlockHandle(MEMHDL handle);

/* Free  a particular section of allocated memory */
void PUBLIC				
_FreeHandle(MEMHDL handle, char FAR * pFileName, int lineNo);

/* returns the allocated size in bytes of the handle */
MEMSIZE PUBLIC
SizeOfHandle(MEMHDL handle);

/* Rearranges allocated memory to make sure that size-wanted */
/* are available for future allocations */
MEMSIZE PUBLIC
env_CompactMem(MEMSIZE size_wanted);

/*allocate a chunk of non-relocatable memory and return a pointer to it */
MEMPTR PUBLIC
_AllocPtr(MEMSIZE size, char FAR * fileName, int lineNo);

/*allocate a chunk of non-relocatable memory, clear it,  */
/* and return a pointer to it */
MEMPTR PUBLIC
_AllocPtrClear(MEMSIZE size, char FAR * fileName, int lineNo);

/*free up the memory associated with this pointer */
void PUBLIC	
_FreePtr(MEMPTR dPtr, char FAR * pFileName, int lineNo);

/* return the allocated size in bytes of a Ptr */
MEMSIZE PUBLIC
SizeOfPtr(MEMPTR p);

/* Copy to an existing handle the contents of a specific section of memory */
BOOLEAN16 PUBLIC
Ptr2XHandle(MEMPTR sPtr, MEMHDL FAR * HandAdr, MEMSIZE sLength);

/* Create a handle to a section of relocatable memory and copy the */
/* contents of another section of memory into it */
BOOLEAN16 PUBLIC
Ptr2Handle(MEMPTR sPtr, MEMHDL FAR * HandAdr, MEMSIZE sLength);

/* make a copy of a handle */
BOOLEAN16 PUBLIC
CloneHandle(MEMHDL FAR * HandAdr);

/* make a copy of a ptr */
BOOLEAN16 PUBLIC
ClonePtr(MEMPTR FAR * ppData);


/************************************************************************
* from STD_DRAW.H
************************************************************************/

#if defined(applec) || defined(THINK_C)
/************************************************************************
*  M A C I N T O S H
************************************************************************/

/************************************************************************
* Macros to deal with Points
************************************************************************/
#define PointX(pPt) 					((pPt)->h)
#define PointY(pPt) 					((pPt)->v)

#elif defined(_WINDOWS)
/************************************************************************
*  W I N D O W S
************************************************************************/
#define Point POINT
#define Rect  RECT
#define RgnHandle HRGN

#if !defined(MAKELONG)
#define NOGDICAPMASKS     // CC_*, LC_*, PC_*, CP_*, TC_*, RC_
#define NOVIRTUALKEYCODES // VK_*
#define NOWINMESSAGES     // WM_*, EM_*, LB_*, CB_*
#define NOWINSTYLES       // WS_*, CS_*, ES_*, LBS_*, SBS_*, CBS_*
#define NOSYSMETRICS      // SM_*
#define NOMENUS           // MF_*
#define NOICONS           // IDI_*
#define NOKEYSTATES       // MK_*
#define NOSYSCOMMANDS     // SC_*
#define NORASTEROPS       // Binary and Tertiary raster ops
#define NOSHOWWINDOW      // SW_*
#define OEMRESOURCE       // OEM Resource values
#define NOATOM            // Atom Manager routines
#define NOCLIPBOARD       // Clipboard routines
#define NOCOLOR           // Screen colors
#define NOCTLMGR          // Control and Dialog routines
#define NODRAWTEXT        // DrawText() and DT_*
#define NOGDI             // All GDI defines and routines
#define NOKERNEL          // All KERNEL defines and routines
//#define NOUSER            // All USER defines and routines
#define NOMB              // MB_* and MessageBox()
#define NOMEMMGR          // GMEM_*, LMEM_*, GHND, LHND, associated routines
#define NOMETAFILE        // typedef METAFILEPICT
#define NOMINMAX          // Macros min(a,b) and max(a,b)
#define NOMSG             // typedef MSG and associated routines
#define NOOPENFILE        // OpenFile(), OemToAnsi, AnsiToOem, and OF_*
#define NOSCROLL          // SB_* and scrolling routines
#define NOSOUND           // Sound driver routines
#define NOTEXTMETRIC      // typedef TEXTMETRIC and associated routines
#define NOWH              // SetWindowsHook and WH_*
#define NOWINOFFSETS      // GWL_*, GCL_*, associated routines
#define NOCOMM            // COMM driver routines
#define NOKANJI           // Kanji support stuff.
#define NOHELP            // Help engine interface.
#define NOPROFILER        // Profiler interface.
#include <windows.h>

#endif

/* %%TDIBEGIN%% */

#if !defined(LF_FACESIZE)
/*
 *  Define the LOGFONT struct here to avoid having to include all
 *  of the GDI-related symbols in WINDOWS.H.  (27dec90/ksk)
 */

/* Logical Font */
#define LF_FACESIZE	    32

typedef struct tagLOGFONT
	{
    int       lfHeight;
    int       lfWidth;
    int       lfEscapement;
    int       lfOrientation;
    int       lfWeight;
    BYTE      lfItalic;
    BYTE      lfUnderline;
    BYTE      lfStrikeOut;
    BYTE      lfCharSet;
    BYTE      lfOutPrecision;
    BYTE      lfClipPrecision;
    BYTE      lfQuality;
    BYTE      lfPitchAndFamily;
    BYTE      lfFaceName[LF_FACESIZE];
	} LOGFONT;

#endif

typedef struct MacPolygon
	{
	int		polySize;
	Rect	polyBBox;
	Point	polyPoints[1];
	} MacPolygon, FAR *PolyPtr;

typedef PolyPtr PolyHandle;

/* %%TDIEND%% */

/************************************************************************
* Macros to deal with Points
************************************************************************/
#define PointX(pPt) 					((pPt)->x)
#define PointY(pPt) 					((pPt)->y)

/************************************************************************
* Macros for sub-parts of a rectangle
************************************************************************/
#define topLeft(r) 	(*(Point *) &(r).left)
#define botRight(r)	(*(Point *) &(r).right)

#endif

/************************************************************************
*  Useful Constants
************************************************************************/
#define kForceBW		0
#define kUseFontInst	1

#define WANTPATTERNS 0
#define MAXSYSPATTERN 38
#define MAXGRAYPATTERN 64
#define GRAYPATTERNS 256

#define VirtualXMIN 		(-16383)
#define VirtualXMAX 		16383
#define VirtualYMIN 		(-16383)
#define VirtualYMAX 		16383

#define NULLAREA NULL
#define MAXPALETTE 256
#define FONTNAMEMAX 63
#define MAXSTRIPES 4

#define SQUARESIZE 32

#define NOFILL			9999								/* special value indicating transparency */

/* Bits in the nFlags field of FontInstRec, used by DrawLabel */
#define FONT_bBoxIsOK 1
#define FONT_bHotelText 2
#define FONT_bAntiAliased 4
#define FONT_bRotate90  8 			/*DW:(2/24/94) Added rotate modes */
#define FONT_bRotate180 16
#define FONT_bRotate270 32

/* Currently supported A_FONTORIENT values. */
#define FONTORIENT_NORMAL	0
#define FONTORIENT_HOTEL	1
#define FONTORIENT_ROTATE_90	2
#define FONTORIENT_ROTATE_180	3	/*DW:(2/24/94) Added rotate modes */
#define FONTORIENT_ROTATE_270	4

/*
 * Justification codes for text drawing functions in swi_text.c.
 */
#define JUST_LEFT   0
#define JUST_BOTTOM	0
#define JUST_CENTER 1
#define JUST_RIGHT  2
#define JUST_TOP    2
#define JUST_BOTH   3

#ifdef THINK_C
#define HiliteMode (char *) 0x00000938
#endif

#define IGNORE_ME 9999									/* special flag for InsertDetNode */

/************************************************************************
*  useful constants for passing null info to drawing calls.  these values
*  are currently outside of the range of possible object id's so that we
*  can hopefully detect bad sets of parameters (04feb90/ksk).
************************************************************************/
#define NULL_OBJECTID (-3)
#define NULL_SERIESID (-3)
#define NULL_GROUPID (-3)


/************************************************************************
*  StdDraw Port Types
************************************************************************/
enum _DE_PORT_TYPES {
	DE_PORT_NULL,
	DE_PORT_NORMAL,
	DE_PORT_OFFSCREEN,
	DE_PORT_PICTURE,
	DE_PORT_PIP,
	DE_PORT_PRINTING
};


/************************************************************************
*  StdDraw Bottleneck Proc Types
************************************************************************/
enum _StdDrawProcTypes {
	DE_PROCS_DEFAULT,
	DE_PROCS_DETECTION_ONLY,
	DE_PROCS_DRAWING_ONLY
};


/************************************************************************
*  IsVisible -- Determines visibility of a ColorInst
************************************************************************/
#define IsVisible(pColor) (((pColor)->nSpectrumBin != 	NOFILL) || (pColor)->useMaytag)


/************************************************************************
* InstType - Instance Types
************************************************************************/
enum _InstType{
	I_AREA,
	I_LINE,
	I_FONT
};


/************************************************************************
* WashBandTypes -
************************************************************************/
enum _WashBandTypes{
	WashBandLong,
	WashBandMed,
	WashBandShort,

	MAX_WASHBANDTYPES
};


/************************************************************************
* _NodeType -
************************************************************************/
enum _NodeType {
	ARROWOBJ,
	BALLOON,
	ELLIPSE,
	FREEHAND,
	GROUP,
	LINE,
	POLYGON,
	RECTANGLE,
	REGION,
	TEXT,
	TEXTBOX,
	TEXTCHART,
	WEDGE,
	WEDGECRUST,
	WEDGEFACE,
	DBLTBOX,
	THREEDTBOX,
	ARC,
	POLYLINE,
	ROTLABEL,
	ROUNDRECT,
  HOLLOW_ELLIPSE,
  HOLLOW_RECTANGLE,
  HOLLOW_POLYGON,

	MAX_NODETYPE
};


/************************************************************************
* FontQuality -
************************************************************************/
enum FontQuality {
	Stroke, Draft, Proof, Exact
};


/************************************************************************
* FontAlignType -- Types of Justification	(06feb90/ksk)
************************************************************************/
enum _FontAlignType {
	ALIGN_LEFT,
	ALIGN_CENTER,
	ALIGN_RIGHT,
	ALIGN_JUSTIFY
};


/************************************************************************
* PenModeTypes -
************************************************************************/
enum _DE_PEN_MODES {
	DE_PEN_NORMAL,
	DE_PEN_XOR
};

/************************************************************************
* QuickDraw Version - MAXIS
************************************************************************/
enum _QD_VERSION {
	QD_ORIGINAL,
	QD_COLOR,
	QD_COLOR32
};

/************************************************************************
* DE Drawing Modes - MAXIS
************************************************************************/
enum _DE_DRAW_MODES {
	DE_DRAW_RGB,
	DE_DRAW_RGBPATTERN,
	DE_DRAW_QDCOLOR,
	DE_DRAW_QDCOLORPATTERN,
	DE_DRAW_MONOCHROME,
	DE_DRAW_OUTLINE
};

/*%%TDIBEGIN%%*/

/************************************************************************
* LineInfoRec -
************************************************************************/
typedef struct {
	Point 					p0;
	Point 					p1;
	INT16 					thickness;
	PolyHandle			hPoly;
} LineInfoRec, FAR *LineInfoPtr;


/************************************************************************
* CrustInfoRec - Pie Crust Information Record
************************************************************************/
typedef struct _CrustInfoRec {
	Rect						bounds;
	FIXED32					lxOffset;
	FIXED32					lyOffset;
	INT16						xSize;
	INT16						ySize;
	INT16						nStart;
	INT16						nEnd;
	INT16						nHeight;
	INT16						bIsOuterCrust;
} CrustInfoRec, FAR * CrustInfoPtr;


/************************************************************************
* SliceInfoRec - Pie Slice Information Record
************************************************************************/
typedef struct _SliceInfoRec {
	Rect						bounds;
	FIXED32					lxOffset;
	FIXED32					lyOffset;
	INT16						xSize;
	INT16						ySize;
	INT16						nStart;
	INT16						nEnd;
	INT16						nRing;
	struct {
		Rect					bounds;
		FIXED32				lxOffset;
		FIXED32				lyOffset;
		INT16					xSize;
		INT16					ySize;
	} inner;		

} SliceInfoRec, FAR * SliceInfoPtr;


/************************************************************************
* WedgeInfoRec - Pie Wedge Information Record
************************************************************************/
typedef struct _WedgeInfoRec {
	Rect						bounds; 							/* bounds rectangle */
	Point						ptStart;							/* start point */
	Point						ptEnd;								/* end point */
	REAL						fStartAngle;					/* start angle (in rect radians) */
	REAL						fEndAngle; 						/* end angle	 (in rect radians) */
	INT16 					nRing;								/* ring percentage  */
	INT16 					nHeight;							/* 2.5D crust/ring height */
} WedgeInfoRec, FAR *WedgeInfoPtr;


/************************************************************************
* PolyInfoRec - Polygon Information Record
************************************************************************/
typedef struct {
	PolyHandle			hPoly;
} PolyInfoRec, FAR *PolyInfoPtr;


/************************************************************************
* RegionInfoRec - Region Information Record
************************************************************************/
typedef struct {
	RgnHandle 			hRgn;
} RegionInfoRec, FAR *RegionInfoPtr;


/************************************************************************
* TextInfoRec - Text Information Record
************************************************************************/
typedef struct {
	Rect						bounds;
	MEMHDL					hText;
} TextInfoRec, FAR *TextInfoPtr;


/************************************************************************
* RGB16 - Color Triplet Information Record
************************************************************************/
typedef struct {
	UINT16 					red;									/* must be 16-bit values! */
	UINT16 					green;
	UINT16 					blue;
} RGB16, FAR *RGB16Ptr;


/************************************************************************
* ColorInstRec - Color Instance Record
************************************************************************/
typedef struct {
	INT16 					useMaytag;						/* flag to enable SFX */
	SFXHDL					hMaytag;							/* handle to washing machine data */
	INT16 					nBin; 								/* palette entry # */
	INT16 					nSpectrumBin; 				/* bin from which RGB values
																				 * originated */
	UINT16 					nRed; 								/* RGB values */
	UINT16 					nGreen; 							/* RGB values */
	UINT16 					nBlue;								/* RGB values */
} ColorInstRec, FAR *ColorInstPtr;

/************************************************************************
* DropShadowInstRec - Drop Shadow Instance Record
************************************************************************/
typedef struct {
	INT16 					nXoff;								/* virtual x offset */
	INT16 					nYoff; 								/* virtual y offset */
	UINT16 					nRed; 								/* RGB values */
	UINT16 					nGreen; 							/* RGB values */
	UINT16 					nBlue;								/* RGB values */
} DropShadowInstRec, FAR *DropShadowInstPtr;

/************************************************************************
* LineInstRec - Line Instance Record
************************************************************************/
typedef struct {
	ColorInstRec		color;								/* standard color/sfx values */
	INT16 					nThick; 							/* line thickness (0..32767) */
	INT16 					nStyle; 							/* line style (0..255) */
	INT16 					nColor; 							/* line color (0..15) */
	INT16 					nBColor;							/* background color (0..15) */
} LineInstRec, FAR *LineInstPtr;

/************************************************************************
* AreaInstRec - Area Instance Record
************************************************************************/
typedef struct {
	ColorInstRec		color;								/* standard color/sfx values */
	INT16 					nPattern; 						/* interior pattern (0..255) */
	INT16 					nBRed; 								/* pattern's background color (0..65535) */
	INT16 					nBGreen;							/* pattern's background color (0..65535) */
	INT16 					nBBlue;								/* pattern's background color (0..65535) */
	DropShadowInstRec		drop;							/* %%NEW(5)%% DropShadow values DW 10/2/92 */ // TL:11/16/92
} AreaInstRec, FAR *AreaInstPtr;

/************************************************************************
* FontInstRec - Font Instance Record
************************************************************************/
typedef struct {
	ColorInstRec		color;								/* standard color/sfx values */
	INT16 					nFontIndex; 					/* font name index */
	INT16 					eQuality; 						/* stroke, draft or proof */
	INT16 					nSize;								/* virtual size (0..32767) */
	INT16 					nAngle; 							/* axis direction in degrees */
	INT16 					justH;								/* horizontal justification control */
	INT16 					justV;								/* vertical justification control */

	INT16 					textFont; 						/* font num */
	INT16 					textSize; 						/* font size mode */
	INT16 					textFace; 						/* font style */
	INT16 					textMode; 						/* font transfer mode */

	INT16						nFlags;								/* flags for rotated, hotel, anti-aliasing, etc */
	INT16						nPitchAndFamily;			/* %%NEW(2)%% font pitch and family */
	INT16						nCharSet;				      /* %%NEW(2)%% font character set */
	DropShadowInstRec		drop;							/* %%NEW(5)%% DropShadow values DW 10/2/92 */ // TL:11/16/92
} FontInstRec, FAR *FontInstPtr;


/************************************************************************
* BoxInstRec - Box Instance Record
************************************************************************/
typedef struct {
	INT16 					xULC, yULC; 					/* upper left corner (any INT16) */
	INT16 					xLRC, yLRC; 					/* lower right corner (any INT16) */
} BoxInstRec, FAR *BoxInstPtr;


/*%%TDIEND%%*/


/************************************************************************
* WashBandRec - Wash Band Record
************************************************************************/
typedef struct {
	INT16 					startBin;
	INT16 					endBin;
} WashBandRec, FAR *WashBandPtr;

/************************************************************************
*  FontMasterRec -- Keeper of font names
************************************************************************/
typedef struct _OldFontNameInfo {
	INT16						nFlags;								/*NOSAVE usage flag */
	INT32						oName;								/* offset to name */
} OldFontNameInfo, FAR * OldFontNameInfoPtr;


typedef struct _OldFontMasterRec {
	INT16						fontNameBufLen;
	INT16						fontNameBufFree;
	char FAR *			fontNameBuf;					/* Courier,0,Helvetica,0,Times,0,0 */

	INT16						fontNameInfoCount;
	OldFontNameInfoPtr	fontNameInfoTbl;

} OldFontMasterRec, FAR * OldFontMasterPtr;

/************************************************************************
*  FontMasterRec -- New Keeper of font names
*
* This record contains the new fontmaster. It keeps the name of the font
* and information about the font for substitition purpose.
*
* Note: the application will use the font specified in
*       the fontXXSubstitution field. If these fields are empty,
*       then the font specified in fontname will be used.
*
************************************************************************/

/*%%TDIBEGIN%%*/

typedef struct _FontNameInfo {

  char            fontName[LF_FACESIZE]; /* original font name */
  BYTE            pitchAndFamily;       /* pitch and family (for Windows only) */
  BYTE            charSet;              /* character set (for Windows only) */
	INT16						nFlags;								/* NOSAVE usage flag */

} FontNameInfo, FAR * FontNameInfoPtr;

typedef struct _FontMasterRec {

  VPSIZE           								fontInfoCount;
	/*%%VARPTR%%*/ FontNameInfoPtr	fontInfoTbl;

} FontMasterRec, FAR * FontMasterPtr;

/*%%TDITRANSFER(FontMasterRec)%%*/

/*%%TDIEND%%*/


/************************************************************************
* PORTWINDOW -- Platform Specific Window Ptr
************************************************************************/
#if defined(applec) || defined(THINK_C)
typedef void *PORTWINDOW;

#elif defined(_WINDOWS_NT) || defined (WIN32)
typedef unsigned long PORTWINDOW;

#elif defined(_WINDOWS) || defined(MSDOS)
typedef unsigned short PORTWINDOW;

#endif

typedef void FAR * DrawEnvPtr;

/************************************************************************
*  D e t L i s t
************************************************************************/
typedef MEMHDL DetListHdl;

typedef struct {
	UINT32					totalSize;						/* current size */
	UINT32					totalFree;						/* free space available */
	UINT32					firstFree;						/* offset to first free */
	UINT32					lastDetNode;					/* offset to last alloc'd detnode */
} DetListInfo, FAR * DetListPtr;

/************************************************************************
*  D e t N o d e R e f
************************************************************************/
typedef struct {
	INT16						layer;								/* layer found in */
	DetListHdl			hDetList;							/* DetList Handle */
	UINT32					offset;								/* offset into handle */
} DetNodeRef, FAR * DetNodeRefPtr;


/************************************************************************
* StdDraw Function Prototypes
************************************************************************/
DrawEnvPtr PUBLIC			AllocDrawEnvPtr			(PORTWINDOW port, INT16 nPortType);

INT16 PUBLIC					DEGetBackgroundRect	(DrawEnvPtr pDE, Rect FAR * pBounds);
INT16 PUBLIC					DEGetClientData			(DrawEnvPtr pDE, void FAR * FAR * pClientData);
INT16 PUBLIC					DEGetDestRect				(DrawEnvPtr pDE, Rect FAR * pBounds);
INT16 PUBLIC					DEGetDrawProcs			(DrawEnvPtr pDE, INT16 FAR * pIndex);
INT16 PUBLIC					DEGetFrameRect			(DrawEnvPtr pDE, Rect FAR * pBounds);
INT16 PUBLIC					DEGetPenMode				(DrawEnvPtr pDE, INT16 FAR * pPenMode);
INT16 PUBLIC					DEGetPortInfo				(DrawEnvPtr pDE, PORTWINDOW FAR * pPortWindow, INT16 FAR * pnPortType);
INT16 PUBLIC					DEGetVirtRect				(DrawEnvPtr pDE, Rect FAR * pRect);

INT16 PUBLIC					DESetBackgroundRect	(DrawEnvPtr pDE, Rect FAR * pRect);
INT16 PUBLIC					DESetClientData			(DrawEnvPtr pDE, void FAR * pClientData);
INT16 PUBLIC					DESetDestRect				(DrawEnvPtr pDE, Rect FAR * pRect);
INT16 PUBLIC					DESetDrawProcs			(DrawEnvPtr pDE, INT16 nIndex);
INT16 PUBLIC					DESetFrameRect			(DrawEnvPtr pDE, Rect FAR * pRect);
INT16 PUBLIC					DESetPenMode				(DrawEnvPtr pDE, INT16 nPenType);
INT16 PUBLIC					DESetPortInfo				(DrawEnvPtr pDE, PORTWINDOW port, INT16 nPortType);
INT16 PUBLIC					DESetVirtRect				(DrawEnvPtr pDE, Rect FAR * pRect);
INT16 PUBLIC					DEGetMeasurements		(DrawEnvPtr	pDE, INT16 FAR * pnHorz, INT16 FAR * pnVert);
INT16 PUBLIC					DESetMeasurements		(DrawEnvPtr	pDE, INT16 pnHorz, INT16 pnVert);

INT16 PUBLIC					DrawBegin						(DrawEnvPtr pDE);
INT16 PUBLIC					DrawEnd							(DrawEnvPtr pDE);

INT16 PUBLIC					FreeDrawEnvPtr			(DrawEnvPtr pDE);

INT16 PUBLIC
DrawArc(
	DrawEnvPtr			pDE,
	LineInstPtr 		pLine,
	Rect FAR *			pBounds,
	Point FAR *			pStartPt,
	Point FAR *			pEndPt,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawEllipse(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pAreaInst,
	LineInstPtr 		pLineInst,
	INT16 					xULC,
	INT16 					yULC,
	INT16 					xLRC,
	INT16 					yLRC,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawLabel(
	DrawEnvPtr			pDE,
	FontInstPtr 		pFontInst,
	BoxInstPtr			pBox,
	char FAR *			szText,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawLine(
	DrawEnvPtr			pDE,
	LineInstPtr 		pLine,
	INT16 					x0,
	INT16 					y0,
	INT16 					x1,
	INT16 					y1,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawPara(
	DrawEnvPtr			pDE,
	FontInstPtr 		pFontInst,
	BoxInstPtr			pBox,
	char FAR *			szText,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawPolygon(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	FontInstPtr 		pFont,
	INT16 					nPoints,
	INT16 FAR * 		xyPoint,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawPolyline(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	FontInstPtr 		pFont,
	INT16 					nPoints,
	INT16 FAR * 		xyPoint,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawRect(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pAreaInst,
	LineInstPtr 		pLineInst,
	INT16 					xULC,
	INT16 					yULC,
	INT16 					xLRC,
	INT16 					yLRC,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawRoundedRect(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pAreaInst,
	LineInstPtr 		pLineInst,
	Rect					 *pRect,
	INT16						xRound,
	INT16						yRound,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawRotLabel(
	DrawEnvPtr			pDE,
	FontInstPtr 		pFontInst,
	BoxInstPtr			pBox,
	char FAR *			szText,
	INT16						rotation,
	INT16						charTilt,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);


INT16 PUBLIC
DrawSlice(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	Rect FAR *			pBounds,
	Point FAR *			pStartPt,
	Point FAR *			pEndPt,
	INT16						nRing,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawSliceCrust(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	Rect FAR *			pBounds,
	Point FAR *			pStartPt,
	Point FAR *			pEndPt,
	INT16						nHeight,
	INT16						nRing,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawSliceFace(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	Rect FAR *			pBounds,
	Point FAR *			pStartPt,
	INT16						nHeight,
	INT16						nRing,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawSliceRing(
	DrawEnvPtr			pDE,
	AreaInstPtr 		pArea,
	LineInstPtr 		pLine,
	Rect FAR *			pBounds,
	Point FAR *			pStartPt,
	Point FAR *			pEndPt,
	INT16						nHeight,
	INT16						nRing,
	INT16 					nObjectID,
	INT16 					nSeriesID,
	INT16 					nGroupID,
	void FAR *			pInfo,
	INT16 					nInfoLen
);

INT16 PUBLIC
DrawCharacter(
	DrawEnvPtr			pDE,
	INT16 					x,
	INT16 					y,
	char 						c
);

INT16 PUBLIC
DrawExtText(
	DrawEnvPtr			pDE,
	INT16 					x,
	INT16 					y,
	UINT16					wOptions,
	Rect					 *pRect,
	char					 *pText,
	INT16						nChars,
	INT16					 *pnGaps
);

INT16 PUBLIC
SetFont(
	DrawEnvPtr			pDE,
	FontInstPtr			pFont,
	INT16 					rotation,
	INT16 					tilt
);

INT16 PUBLIC
SetFontColors(
	DrawEnvPtr			pDE,
	FontInstPtr			pFont
);

INT16 PUBLIC
SetAreaColors(
	DrawEnvPtr			pDE,
	AreaInstPtr			pArea
);

INT16 PUBLIC
SetLineColors(
	DrawEnvPtr			pDE,
	LineInstPtr			pLine
);

INT16 PUBLIC
GenericDrawFunction(
	DrawEnvPtr			pDE,
	INT16						nFuncID,
	void FAR *			pData1,
	void FAR *			pData2,
	void FAR *			pData3,
	void FAR *			pData4
);



/************************************************************************
* from STD_SDMM.H
************************************************************************/

INT16 PUBLIC
DERegisterCallbacks(DrawEnvPtr pDE,
										DrawEnvPtr (FAR *pMaybeSwitchDE) (
																DrawEnvPtr			pDEIn,
																INT16						nObjectID,
																INT16						nSeriesID,
																INT16						nGroupID,
																AreaInstPtr			pAreaInst,
																LineInstPtr			pLineInst,
																FontInstPtr			pFontInst,
																INT16					 *pbObjectsSelected	),

										INT16 			(FAR *pDoneWithSwitchedDE) (
																DrawEnvPtr			pDEUsed,
																INT16						nObjectID,
																INT16						nSeriesID,
																INT16						nGroupID,
																AreaInstPtr			pAreaInst,
																LineInstPtr			pLineInst,
																FontInstPtr			pFontInst,
																INT16						pbObjectsSelected ),

										INT16	 			(FAR *pDetNodeFilterProc) (
															 	DrawEnvPtr			pDE,
															 	INT16						nNodeType,
															 	INT16						nObjectID,
															 	INT16						nSeriesID,
															 	INT16						nGroupID,
															 	INT16						nInfoLen,
															 	void FAR *			pInfo,
															 	AreaInstPtr 		pArea,
															 	LineInstPtr 		pLine,
															 	FontInstPtr 		pFont,
															 	void FAR *			pData )
										);

INT16 PUBLIC
DESetActionProcs(DrawEnvPtr			pDE);


/************************************************************************
* from COM_FONT.H
************************************************************************/

typedef struct {
	INT16	nStructSize;
	BOOLEAN16		bUseGlobalFontInfo;		/* Use font mode in FontInstRec or not. */
	BOOLEAN16		bEnableFontScaling;		/* Allow scaling. N/A if above FALSE. */
	INT16			nGreekingSize;				/* Size at which font greeking will occur. */
} GlobalFontClass, FAR * GlobalFontPtr;


INT16 PUBLIC
DEGetGlobalFontInfo(
		DrawEnvPtr			pDE,				/* Draw enviroment referenced. */
		GlobalFontPtr		pGlobalFont	/* Requested data buffer. */
);

INT16 PUBLIC
DESetGlobalFontInfo(
		DrawEnvPtr			pDE,				/* Draw enviroment referenced. */
		GlobalFontPtr		pGlobalFont	/* Buffer from which to initialize pDE. */
);


/************************************************************************
* from COM_XLAT.H
************************************************************************/

/*
 * General utility routines
 */
void		PUBLIC			XchgINT16				(INT16 *p1, INT16 *p2);


/*
 * Point arithmetic
 */
void		PUBLIC			AddPoints				(Point FAR *sum, Point FAR *p1, Point FAR *p2);
void		PUBLIC			SubPoints				(Point FAR *dif, Point FAR *p1, Point FAR *p2);
void		PUBLIC			AbsPoint				(Point FAR *p);
void		PUBLIC			ScalePoint			(Point FAR *p, Point FAR *mul, Point FAR *div);


/*
 * Device to Virtual translation
 */
INT16		PUBLIC			dvScaleHeight		(DrawEnvPtr pDE, INT16 height);
INT16		PUBLIC			dvScaleWidth		(DrawEnvPtr pDE, INT16 width);
void		PUBLIC			dvCrust					(DrawEnvPtr pDE, CrustInfoPtr pCrust);
void		PUBLIC			dvPoint					(DrawEnvPtr pDE, Point FAR *p);
void		PUBLIC			dvPoly					(DrawEnvPtr pDE, PolyHandle hPoly);
void		PUBLIC			dvRect					(DrawEnvPtr pDE, Rect FAR *pRect);
void		PUBLIC			dvScalePoint		(DrawEnvPtr pDE, Point FAR *p);
void		PUBLIC			dvSlice					(DrawEnvPtr pDE, SliceInfoPtr pSlice);
void		PUBLIC			dvWedge					(DrawEnvPtr pDE, WedgeInfoPtr pWedge);
void		PUBLIC			dvPoint2D				(DrawEnvPtr pDE, Point2D FAR *p);
void		PUBLIC			dvScalePoint2D	(DrawEnvPtr pDE, Point2D FAR *p);


/*
 * Virtual to Device translation
 */
INT16		PUBLIC			vdScaleHeight		(DrawEnvPtr pDE, INT16 height);
INT16		PUBLIC			vdScaleWidth		(DrawEnvPtr pDE, INT16 width);
void		PUBLIC			vdCrust					(DrawEnvPtr pDE, CrustInfoPtr pCrust);
void		PUBLIC			vdPoint					(DrawEnvPtr pDE, Point FAR *p);
void		PUBLIC			vdPoly					(DrawEnvPtr pDE, PolyHandle hPoly);
void		PUBLIC			vdRect					(DrawEnvPtr pDE, Rect FAR *r);
void		PUBLIC			vdScalePoint		(DrawEnvPtr pDE, Point FAR *p);
void		PUBLIC			vdSlice					(DrawEnvPtr pDE, SliceInfoPtr pSlice);
void		PUBLIC			vdWedge					(DrawEnvPtr pDE, WedgeInfoPtr pWedge);
void		PUBLIC			vdPoint2D				(DrawEnvPtr pDE, Point2D FAR *p);
void		PUBLIC			vdScalePoint2D	(DrawEnvPtr pDE, Point2D FAR *p);


/*
 * Virtual / Physical translation
 */
INT16 	PUBLIC 			pvScaleWidth    (DrawEnvPtr	pDE, INT16 width);
INT16 	PUBLIC 			pvScaleHeight   (DrawEnvPtr	pDE, INT16 height);
INT16 	PUBLIC 			vpScaleWidth    (DrawEnvPtr	pDE, INT16 width);
INT16 	PUBLIC 			vpScaleHeight   (DrawEnvPtr	pDE, INT16 height);

/*
 * Device routines
 */
void		PUBLIC			dSetRect				(DrawEnvPtr pDE, Rect FAR *pRect, INT16 left, INT16 top, INT16 right, INT16 bottom);
void		PUBLIC			dCheckRect			(DrawEnvPtr pDE, Rect FAR *r);


/*
 * Virtual routines
 */
void		PUBLIC			vSetRect				(DrawEnvPtr pDE, Rect FAR *pRect, INT16 left, INT16 top, INT16 right, INT16 bottom);
void		PUBLIC			vCheckRect			(DrawEnvPtr pDE, Rect FAR *r);


/*
 *  Utility routines
 */
void		PUBLIC			xSetPt					(Point FAR *pPoint, INT16 x, INT16 y);

REAL		PUBLIC			xNormalizeDegrees	(REAL rAngle);
REAL		PUBLIC			xNormalizeRadians	(REAL rAngle);

REAL		PUBLIC			xPt2Degrees			(Point FAR *p, Rect FAR *pRect);
REAL		PUBLIC			xPt2Radians			(Point FAR *p, Rect FAR *pRect);

#define xDegrees2Radians(rAngle) 		((rAngle) * PI / 180.0)
#define xRadians2Degrees(rAngle) 		((rAngle) * 180.0 / PI)


/*
 *  Detection Routines
 */
BOOLEAN16	PUBLIC			xPtInEllipse		(Point FAR *p, Rect FAR *pRect);
BOOLEAN16	PUBLIC			xPtInPoly				(Point FAR *p, PolyHandle hPoly);
BOOLEAN16	PUBLIC			xPtInRect				(Point FAR *p, Rect FAR *pRect);
BOOLEAN16	PUBLIC			xPtInWedge			(Point FAR *p, WedgeInfoPtr pWedge);
BOOLEAN16 PUBLIC			xPtInSlice			(Point FAR *p, SliceInfoPtr pSlice);


/*
 *	Rectangle Manipulation.
 */
void		PUBLIC			xDefineRect			(Rect FAR *r, INT16 left , INT16 top,
																									INT16 right, INT16 bottom);
void		PUBLIC			xInsetRect			(Rect FAR *r, INT16 x, INT16 y);
void		PUBLIC			xOffsetRect			(Rect FAR *r, INT16 x, INT16 y);
void		PUBLIC			xIntersectRect	(Rect FAR *r, Rect FAR *cr);
BOOLEAN16 PUBLIC			xCompareRects		(Rect FAR *r1, Rect FAR *r2);
Rect		PUBLIC			xSumOfRects			(Rect FAR *r1, Rect FAR *r2);
INT16 	PUBLIC 			xWidthOfRect 		(Rect FAR *r);
INT16 	PUBLIC 			xHeightOfRect 	(Rect FAR *r);


/*
 *  Type conversion routines.
 */
void		PUBLIC 			xRectToBox			(BoxInstPtr pBox, Rect *pRect);
void		PUBLIC 			xBoxToRect			(Rect *pRect, BoxInstPtr pBox);
void		PUBLIC			xPointToPoint2D	(Point2D *np2D, Point *p);
void		PUBLIC			xPoint2DToPoint	(Point *p, Point2D *np2D);



/************************************************************************
* from STD_POLY.H
************************************************************************/

void PUBLIC					dump_PolyHandle		(PolyHandle hPoly);

PolyHandle	PUBLIC	AllocPolyHandle		(INT16 nPoints);
INT16				PUBLIC	AddPolyPoint			(PolyHandle FAR * hPoly, INT16 x, INT16 y, int isFirstPoint);
void				PUBLIC	ClosePolyHandle		(PolyHandle FAR * hPoly);
void				PUBLIC	FreePolyHandle		(PolyHandle hPoly);

PolyPtr			PUBLIC	LockPolyHandle		(PolyHandle hPoly);
void				PUBLIC	UnlockPolyHandle	(PolyHandle hPoly);

BOOLEAN16			PUBLIC	ClonePolyHandle		(PolyHandle FAR * phPoly);

INT16				PUBLIC	GetPolyPointCount	(PolyHandle hPoly);
void				PUBLIC	GetPolyBounds			(PolyHandle hPoly, Rect FAR * pRect);

INT16				PUBLIC	GetPolyPtrPointCount	(PolyPtr pPoly);
void				PUBLIC	GetPolyPtrBounds			(PolyPtr pPoly, Rect FAR * pRect);

PolyHandle 	PUBLIC	Points2Poly(Point *ptData,	INT16 nCount);

INT16 PUBLIC
GetPolyPoint(
	PolyHandle FAR *pPolyHdl,
	INT16						nIndex,
	PINT16 					pnX,
	PINT16 					pnY
);



/************************************************************************
* from COMMON.H
************************************************************************/

typedef void FAR * StoragePtr;
typedef void FAR * GraphPtr;
typedef void FAR * _GraphPtr;


#define MAXSTRLEN 			256
#define XYZ							3								/* Number of axes in 3D.*/

/************************************************************************
*  LayerType -- Constants for Each Layer of the Graph
************************************************************************/
typedef enum _LayerType {
	ANNOTATION_LAYER,
	GRAPH_LAYER,
	BACKGROUND_LAYER,

	MAX_LAYER
} LayerType;


/*************************
 *  E n g i n e T y p e  *
 *************************/
typedef enum {
	ENGINE_ROOT,
	ENGINE_2D,
	ENGINE_PIE,
	ENGINE_3D,
	ENGINE_ANA,
	ENGINE_TEXT,

	MAX_ENGINETYPE
} EngineType;


/************************************************************************
*  GraphTypes
************************************************************************/
typedef enum _GraphType {

	/*
	 * This table is in one to one correspondence with similar
	 * tables in the following files
	 *	sac_data.c	(Data models)
	 *  com_Util.c	(String to chart type mapping)
	 *  Cro_Menu.c	(Chart menu definitions)
	 */

	G_3D_BarType,
	G_3D_ColAreaType,
	G_3D_ColLineType,
	G_3D_ColStepType,
	G_3D_CubeType,
	G_3D_CutCornerType,
	G_3D_DiamondType,
	G_3D_HoneycombType,
	G_3D_ModelType,
	G_3D_OctagonType,
	G_3D_PyramidType,
	G_3D_RowAreaType,
	G_3D_RowLineType,
	G_3D_RowStepType,
	G_3D_ScatterType,
	G_3D_SquareType,
	G_3D_SurfaceType,

	G_Area,
	G_Bars,
	G_BoxPlot,
	G_BoxPlotTC,
	G_Bubble,
	G_ContourPlot,
	G_Gantt,
	G_HArea,
	G_HBars,
	G_HBoxPlot,
	G_HBoxPlotTC,
	G_HContourPlot,
	G_HHistogram,
	G_HLines,
	G_HScatter,
	G_Hinge,
	G_Histogram,
	G_Lines,
	G_MultPie,
	G_OHLClose,
	G_Pie,
	G_PieBar,
	G_Polar,
	G_Radar,
	G_Scatter,
	G_SpecMapCell,
	G_TableChart,
	G_TextChart,

	MAX_GRAPHTYPE
} GraphType;


/************************************************************************
* SubGraphType
*************************************************************************/
typedef enum _SubGraphType {						/* 2D BLA (bar, line, area) chart style. */
	Absolute,
	Stacked,
	SideBySide,
	Percent,

	NormalPie,
	PropPie,
	RingPie,
	RingPropPie,

	MAX_SUBGRAPHTYPE
} SubGraphType;


/************************************************************************
* Major Graph Preset Types
*************************************************************************/
typedef enum _TDG_GRAPH_TYPE {
	TDG_GRAPH_3D,													/* Change Graph Type to 3D */
	TDG_GRAPH_AREA,												/* Change Graph Type to Area */
	TDG_GRAPH_BARS,												/* Change Graph Type to Bar */
	TDG_GRAPH_LINES,											/* Change Graph Type to Line */
	TDG_GRAPH_PIE,												/* Change Graph Type to Pie */
	TDG_GRAPH_SPECIAL,										/* Change Graph Type to Special */
	TDG_GRAPH_TABLE,											/* Change Graph Type to Table */
	TDG_GRAPH_TEXT,												/* Change Graph Type to Textchart */

	MAX_TDG_GRAPH_TYPE

} TDG_GRAPH_TYPE;


/************************************************************************
* ShapeType -- 2D shapes enumeration.
*
* If you change this list, you also need to change the szShape array in
* comload.c, and also the DrawMarker routine in C2D_MKRS.C.
************************************************************************/
typedef enum _ShapeType {
	NoMarker,
	SRectangle,
	NStar45,
	Plus,
	Circle,
	Diamond,
	SpikedX,
	PlainX,
	IsTri1, 															/* isosceles triangles */
	NStarSkewed,
	FatPlus,
	NStar90,
	SoftX,
	PiratePlus,
	FatX,
	Castle,
	IsTri2,
	IsTri3,
	IsTri4,
	RtTri1, 															/* right triangles */
	RtTri2,
	RtTri3,
	RtTri4,
	SEllipse,
	Square,
	Hexagon,
	Pentagon,
	House,
	Pentagram,
	FontMarker
} ShapeType;


/************************************************************************
* HashStyleType
************************************************************************/
typedef enum _HashStyleType {
	NoHash,
	Grid,
	GridExtended,
	TickIn,
	TickOut,
	TickSpan
} HashStyleType;


/************************************************************************
* SideType -- Axis Placement Constants
************************************************************************/
typedef enum _SideType {
	LowSide,
	HighSide,
	BothSides,
	NeitherSide
} SideType;


/************************************************************************
* OrientaionType
************************************************************************/
typedef enum _OrientationType {
  HORIZONTAL,
	VERTICAL
} OrientationType;


/************************************************************************
* DataOrientationType
************************************************************************/
typedef enum _DataOrientationType {
	Columns, Rows
} DataOrientationType;


/************************************************************************
*  GraphByMethods
************************************************************************/
typedef enum _GraphByMethods {
	GraphByType,													/* Use main graph type for all cells.*/
	GraphBySeries,												/* Use RiserType for series mapping.*/
	GraphByGroup,													/* Use RiserType for group mapping.*/

	MAX_GraphByMethods
} GraphByMethods;


/************************************************************************
*  Color Model Constants 12.16.91/SJR
************************************************************************/
typedef enum _ColorModelConstants {
	CM_BY_FACE,							// 3d only, depends on face, not s or g
	CM_BY_SERIES,
	CM_BY_GROUP,

	CM_BY_ANGLE,						// 3d only, depends on angle to viewer
	CM_BY_HEIGHT,						// depends on length of riser
	CM_BY_VALUE_X,					// depends on distance to LEFT WALL (Y axis)
	CM_BY_VALUE_Y,					// depends on distance to FLOOR (X-axis)
	CM_BY_VALUE_Z,					// 3d only, depends on distance to RIGHT WALL

	NUM_CM_TYPES
} ColorModelConstants;


/************************************************************************
* Control values for A2D_SHOW_DATATEXT.
************************************************************************/

#define DATATEXT_NONE  0		/* Display no datatext.*/
#define DATATEXT_VALUE 1		/* Display value(s) of data item(s). */
#define DATATEXT_TEXT  2		/* Display unique data item text. */
#define DATATEXT_BOTH  3		/* Display both. */
#define DATATEXT_ABS   8    /* Display the absolute value in stacked segments */
#define DATATEXT_ABSVALUE DATATEXT_VALUE || DATATEXT_ABS
#define DATATEXT_ABSBOTH  DATATEXT_BOTH || DATATEXT_ABS

/************************************************************************
* Control values for A2D_SCALEEND_??.
************************************************************************/

#define SCALEEND_BOTH			0
#define SCALEEND_MINONLY	1
#define SCALEEND_MAXONLY	2
#define SCALEEND_NONE			3

/************************************************************************
* Control values for ASG_LGND_LAYOUT.
************************************************************************/

#define LAYOUT_HORIZONTAL			0
#define LAYOUT_VERTICAL				1
#define LAYOUT_AUTOMATIC			2
#define LAYOUT_PIE_INFO				3

/************************************************************************
* Control values for A_FONTSTYLE.
************************************************************************/

#define FONTSTYLE_BOLD				1
#define FONTSTYLE_ITALIC			2
#define FONTSTYLE_UNDERLINE		4

/************************************************************************
* Control values for A2D_LABELMODE_O?.
************************************************************************/

#define LABELMODE_EVEN				0	/* Evenly space any headers found. */
#define LABELMODE_EXACT				1	/* Place headers exactly as found. */
#define LABELMODE_SKIPMANUAL	2	/* As exact but with skipping. */
#define LABELMODE_SKIPAUTO		3 /* As skip manual but automated. */

/************************************************************************
* Control values for A2D_LABELWRAPMODE_O1.
************************************************************************/

#define LABELWRAP_OFF					0 /* label wrap mode (multi-line) off */
#define LABELWRAP_AUTO				1	/* DGDS wraps labels to number of lines */

/************************************************************************
* Control values for A2D_GRIDMODEMAJOR_O1 and A2D_GRIDMODEMINOR_O1.
* TL:11/18/92 added new attributes to control ordinal axis gridlines
************************************************************************/

#define GRIDMODE_NORMAL							0 /* major - grid drawn between each group for bars
																	 			 minor - AxisLookClass.nMinorHash between majors */
#define GRIDMODE_ATSKIPGROUPS				1	/* major - grid drawn at group every 
																					 AxisLookClass.nLabelSkip groups
																	 			 minor - drawn at each group */
#define GRIDMODE_BETWEENSKIPGROUPS	2	/* major - grid drawn between every 
																					 AxisLookClass.nLabelSkip groups
																	 			 minor - drawn between each group */

/* %%TDIBEGIN%% */

/************************************************************************
*  ColorModelStruct	12.16.91/SJR
************************************************************************/
typedef struct _ColorModelStruct {
	INT16 					nColorModel;					/* CM_BY_FACE, CM_BY_SERIES, etc. */
	INT16 					nColorDivisions;
	RGB16						washBeginColor;				/* RGB value of start color for washes. */
	RGB16						washEndColor;					/* RGB value of end color for washes. */
} ColorModelStruct, *ColorModelPtr;


/************************************************************************
* CLevelLookClass -- Contour Level Look Class
************************************************************************/
typedef struct
	{
	REAL					fContourValue; 	/* Contour level value to be drawn for given surface */
	INT16					nSurfaceID;		 	/* Surface number for this contour level value */
	BOOLEAN16				bIsMinor;			/* TRUE=Minor , FALSE=Major */
	} CLevelLookClass, FAR *CLevelLookPtr;


typedef char STRING[MAXSTRLEN];
/************************************************************************
* CPointLookClass -- Contour Point Look Class
************************************************************************/
typedef struct
	{
	REAL					x;					/* Contour Point : x coordinate */
	REAL					y;					/* Contour Point : y coordinate */
	INT16					nColorIndex; 	/* Absolute color index for this contour point */
 	STRING				szLabel;			/* Label at given x,y */
	}	CPointLookClass, FAR *CPointLookPtr;


/************************************************************************
* CSurfaceLookClass -- Contour Surface Look Class
************************************************************************/
typedef struct
	{
	INT16					nLabelSeg;			/* Put a contour level label every nTh segment except: 0=nonem 1=put only one label */
	INT16					nLFormat;			/* Contour level format 0=Auto, 1=Manual, 2=List in CLevelLookClass Array */
	REAL					fLMinAuto;			/* Auto contour level min */
	REAL					fLMaxAuto;			/* Auto contour level max */
	REAL					fLMajorIntAuto;	/* Auto Major contour level interval */
	REAL					fLMinorIntAuto;	/* Auto Minor contour level interval */
	REAL					fLMinManu;			/* Mnual contour level min */
	REAL					fLMaxManu;			/* Mnual contour level max */
	REAL					fLMajorIntManu;	/* Mnual Majro contour level interval */
	REAL					fLMinorIntManu;	/* Mnual Minor contour level interval */
	} CSurfaceLookClass, FAR *CSurfaceLookPtr;


/************************************************************************
* Font3DFields -- 3D Graph Anatomy Constants
************************************************************************/
typedef enum _Font3DFields {
	Row_Headers, 														/* text labels along z axis */
	Col_Headers, 														/* text labels along x axis */
	Left_Numbers, 													/* text labels along left y axis */
	Right_Numbers, 													/* text labels along right y axis */
	Row_Title, 															/* text label on left side of base */
	Col_Title, 															/* text label on right side of base */
	Left_Title, 														/* text label on left wall */
	Right_Title, 														/* text label on right wall */

	Max_3DFields
} Font3DFields;

typedef REAL64		fMatrixType[4][XYZ];
typedef INT32			dMatrixType[4][XYZ];

typedef struct {
	INT32						x, y, z;								/* Coordinates of a 3D point in 4-byte ints. */
} dPoint3D;

#define DATALINE_BOTH					0
#define DATALINE_MARKER				1
#define DATALINE_LINE					2


#define LINRTYPE_NONE		0
#define LINRTYPE_LINEAR	1

/************************************************************************
* LinRAnalysisClass - Linear regression analysis.
************************************************************************/
typedef struct {

	INT16	nLinRType;

	INT16	nCoefficients;
	PREAL	pfCoefficients;


} LinRAnalysisClass, FAR * LinRAnalysisPtr;


/************************************************************************
* BoundScaleClass - Scale information derived from graph/data binding.
************************************************************************/
typedef struct {

	BOOLEAN16						bIsBound;		/* Is data structure valid? */

	REAL							fRawMin;		/* Unprocessed scale minimum. */
	REAL							fRawMax;		/* Unprocessed scale maximum. */
	REAL							fScaleMin;	/* Processed scale minimum. */
	REAL							fScaleMax;	/* Processed scale maximum. */

	BOOLEAN16						bHasZero;		/* Scale has zero values. */
	BOOLEAN16 					bhasNeg;  	/* Scale has negative values. */

	LinRAnalysisClass	lraResults;

} BoundScaleClass, FAR * BoundScalePtr;

/************************************************************************
* BoundAccessClass - Information derived from graph/data binding.
************************************************************************/
typedef struct {

	BOOLEAN16					bIsBound;	/* Is data structure valid? */

	INT16						nSeries;				/* Series count. */
	INT16 					nGroups;				/* Group count. */
	INT16 					nEntries; 			/* Entry (VDM page) count. */

	BOOLEAN16					bExcessiveQDRs;	/* Too many QDRs for detnodes. */

	BoundScaleClass	X1Scale;				/* X1 axis information. */
	BoundScaleClass	Y1Scale;				/* Y1 axis information. */
	BoundScaleClass	Y2Scale;				/* Y2 axis information. */
	BoundScaleClass	Z1Scale;				/* Z1 axis information. */

} BoundAccessClass, FAR * BoundAccessPtr;

/*%%TDIBEGIN%%*/

/************************************************************************
* ArrowInfoRec - Arrow Information Record
************************************************************************/
typedef struct {
	Point 				p0;
	Point 				p1;
	REAL					angle;
	INT16					headSides;
	INT16					headIndent;
	INT16					headWidth;
	INT16					tailIndent;
	INT16					tailWidth;
} 							ArrowInfoRec, FAR *ArrowInfoPtr;

/************************************************************************
* AnaLineInfoRec - Annotation Line Information Record
************************************************************************/
typedef struct {
	Point 				p0;
	Point 				p1;
	INT16				thickness;
	INT16				arrowAtStart;
	INT16				arrowAtEnd;
	INT16				arrowSize;
} 							AnaLineInfoRec, FAR *AnaLineInfoPtr;


/************************************************************************
* GroupInfoRec - Group Information Record
************************************************************************/
typedef struct {
	INT16					children;
} 							GroupInfoRec, FAR *GroupInfoPtr;


/************************************************************************
* PolygonInfoRec - Polygon Information Record
************************************************************************/
typedef struct {
	BOOLEAN16				bClosed;
	PolyHandle		hPoly;		/*POLYHDL*/
} PolygonInfoRec, FAR *PolygonInfoPtr;



/************************************************************************
* GTextInfoRec - Generalized Text Box Information Record
************************************************************************/
typedef struct {
	TEXTHDL					hText;		/*%%DYNAMIC%%*/
	INT16						leftInd;
	INT16						topInd;
	INT16						rightInd;
	INT16						bottomInd;

	/* ...For Balloons... */
	INT16						hPct;
	INT16						vPct;
	INT16						SpikeWidth;

	/* ...For Bullet Charts... */
	AreaInstPtr			pbArea;			/*INT32*/
	LineInstPtr			pbLine;			/*INT32*/
	INT16						bTopInd;
	INT16						bSides;
	INT16						bulTxtSpc;
	INT16						bShape;

	INT16						thickness;
} GTextInfoRec, FAR *GTextInfoPtr;

#if defined(TDI_SDK)
	typedef HLLNEXT AnodeInfoNext;
	typedef HLLPREV AnodeInfoPrev;
#else
	typedef MEMHDL AnodeInfoNext;
	typedef MEMHDL AnodeInfoPrev;
#endif

/************************************************************************
* AnodeInfoRec
************************************************************************/
#if defined(_WINDOWS_NT) || defined (WIN32)
typedef MEMHDL AnodeInfoHdl;
#else
typedef INT16 AnodeInfoHdl;
#endif
typedef struct _AnodeInfoRec {

	/*%%TDICHECK(600)%%*/ /*%%NEW(1)%%*/

	CONTROL /*%%NodeType2Union%%*/nNodeType;
	AnodeInfoNext				hNextNode;
	AnodeInfoPrev				hPrevNode;
	INT16								group;								/* group #. 0 if none */
	Rect								bounds;								/* enclosing rect */
	AreaInstPtr					pArea;	/*INT32*/	/* area instance */
	LineInstPtr					pLine;	/*INT32*/	/* line instance */
	FontInstPtr					pFont;	/*INT32*/	/* font instance */
	INT16								linkSeries;
	INT16								linkGroup;
	Rect								linkRect;
	union {
		AnaLineInfoRec		line;	/* This is the ANNOTATION Poly info...different...*/
		PolygonInfoRec		poly;	/* This is the ANNOTATION Poly info...different...*/
		WedgeInfoRec			wedge;
		RegionInfoRec			region;
		GTextInfoRec			text;
		ArrowInfoRec			arrow;
		GroupInfoRec			group;
	} info;

	/*%%TDICHECK(601)%%*/ /*%%NEW(1)%%*/

} AnodeInfoRec, FAR *AnodeInfoPtr;

/************************************************************************
* AnodeMasterRec
************************************************************************/
#if defined(TDI_SDK)

typedef HLLTYPEA /*%%AnodeInfoRec%%*/	AnodeMasterRec;

#else

typedef struct {
	AnodeInfoHdl				head;
	AnodeInfoHdl				tail;
} AnodeMasterRec, FAR *AnodeMasterPtr;

#endif

/*%%TDITRANSFER(AnodeMasterRec)%%*/

/*%%TDIEND%%*/

/************************************************************************
* GeodeInfoRec
************************************************************************/
typedef MEMHDL GeodeInfoHdl;

typedef struct {
	INT16		 				nNodeType;
	DetNodeRef			DetRef;					/* 24april91 */
	_GraphPtr				pGraph;
	INT16						layer;
	INT16						attrCode;							/* attribute code */
	Rect						bounds;								/* enclosing rect */
	union {
		LineInfoRec		line;
		PolyInfoRec		poly;
		WedgeInfoRec	wedge;
		RegionInfoRec	region;
		TextInfoRec		text;
	} info;
} GeodeInfoRec, FAR *GeodeInfoPtr;


/************************************************************************
* GraphDataInfo -- Per-Graph Data Access Methods and Info
************************************************************************/
typedef enum _GraphDataStringType {
	gsTITLE,
	gsSUBTITLE,
	gsFOOTNOTE,
	gsSERIESTITLE,
	gsGROUPSTITLE,
	gsXAXISTITLE,
	gsY1AXISTITLE,
	gsY2AXISTITLE,
	gsZAXISTITLE,

	MAX_GraphDataStringType
} GraphDataStringType;

typedef
INT16 (CALLBACK 
*LPFNGetDataCallBack) (
	INT16						nDataPt,							/* Row # of of requested value. */
	INT16						nSeries,							/* Column # of of requested value. */
	REAL64 FAR *		rVal,									/* Caller provided buffer for REAL64 assigment. */
	INT32						lClientData						/* client data value */
);

typedef
INT16 (CALLBACK 
*LPFNGetLabelCallBack) (
	INT16						nCol,									/* Column # of of requested label. */
	INT16						nRow,									/* Row # of of requested label. */
	char FAR *			lpBuffer,							/* Caller provided buffer for string assignment. */
	INT16						nDimBuffer,						/* Buffer length. */
	INT32						lClientData						/* client data value */
);

typedef
INT16 (CALLBACK 
*LPFNGetStringCallBack) (
	INT16						nWhich,								/* Ordinal identifier of requested string. */
	char FAR *			lpBuffer,							/* Caller provided buffer for string assignment. */
	INT16						nDimBuffer,						/* Buffer length. */
	INT32						lClientData						/* client data value */
);

typedef
INT16 (CALLBACK 
*LPFNSetPageCallBack) (
	INT16						nPage,								/* New current page. */
	INT32						lClientData						/* client data value */
);

typedef
INT16 (CALLBACK 
*LPFNRealToStringCallBack) (
	REAL64					rVal,									/* Value to be formatted. */
	char FAR *			lpResult,							/* Caller provided buffer for string assigment. */
	INT16						nDimBuffer,						/* Buffer length. */
	INT16						nFmtCode,							/* Format conversion identifier. */
	INT32						lClientData						/* client data value */
);

typedef enum {
	gdY1,
	gdY2,
	gdX1,
	gdZ1,
	MAX_DataAxisRef
} DataAxisRef;

typedef
BOOLEAN16 (CALLBACK 
*LPFNGetRawLimits) (
	INT16						nWhichAxis,						/* Axis limits requested. */
	REAL64 FAR *		prMin, 								/* Axis raw minimum. */
	REAL64 FAR *		prMax, 								/* Axis raw maximum. */
	INT32						lClientData						/* Client data value. */
);

/* Callback function for when user has a specified a handle for a picture */

typedef
INT16 (CALLBACK
*LPFNPictureCallBack) (
	INT32						lClientData,			/* client data value */
	char FAR *		  lppictName,     /* The string which identifies this handle */
	INT32 FAR *			lphPicture,	 	/* Caller supplied picture handle */
	BOOLEAN16 FAR *	  lpbIsAPM,			/* Caller supplied flag. Set TRUE if this is an APM Metafile */
	RECT  FAR * lpAPMbox	            /* Caller supplied World Coord. Box for APM Metafiles */ 
);

/************************************************************************
*  Data Interface Mode constants to define the Data Interface
************************************************************************/
#define DATAIF_CALLBACK	0	/* use host supplied callbacks for chart data */
#define DATAIF_SENDDATA	1	/* host sends data for storage before charting */
#define	DATAIF_VDM_DM		2	/* Data Manager supplies chart data and/or host 
													** sends data for storage */

typedef struct _GraphDataInfo {
	LPFNGetDataCallBack 			lpfnGetData; 			/* returns data for a given row, col */
	LPFNGetLabelCallBack			lpfnGetLabel;			/* returns label for a given row, col */
	LPFNGetStringCallBack			lpfnGetString;		/* returns string based on GraphDataStringType */
	LPFNRealToStringCallBack	lpfnRealToString;	/* convert a value to a string */
	LPFNSetPageCallBack				lpfnSetPage;			/* request to select a page */
	LPFNGetRawLimits					lpfnGetRawLimits;	/* request data limits. */
	LPFNPictureCallBack		lpfnPicture;			/* request a picture handle */
	
	INT16						nPages;								/* # of of pages accessable thru CallBacks. */
	INT16						nCols;								/* # of of columns accessable thru CallBacks. */
	INT16						nRows;								/* # of of rows accessable thru CallBacks. */
	INT32						lClientData;					/* client-supplied data */
	INT16						nDataIFMode;					/* data interface mode, see constants above */

} GraphDataInfo, FAR * GraphDataPtr;


/************************************************************************
*  TDG_ClientInfo -- Information needed by Client (02.27.91/SS)
************************************************************************/
typedef struct _TDG_ClientInfo {
	INT16				nClientHeight;
	INT16				nClientWidth;
	INT16				nClientAtX;
	INT16				nClientAtY;
	BoxInstRec	ClientDisplayRect;
	INT16				nClientTemp1;
	INT16				nClientTemp2;
	INT16				nClientTemp3;
	INT16				nClientTemp4;
	char				szClientTemp1[256];
	char				szClientTemp2[256];
	MEMHDL				ClientText;			/* an unlimited amount of text */
} TDG_ClientInfo;


/************************************************************************
* from DETECTIV.H
************************************************************************/

typedef struct {
	UINT32					offset;								/* offset to next DetNode */
	INT16						nNodeType;						/* DetNode shape */
	INT16 					nObjectID;						/* object ID */
	INT16 					nSeriesID;						/* series ID or -1 */
	INT16 					nGroupID; 						/* group	ID or -1 */
	Rect						detBounds;						/* enclosing rectangle */
	AreaInstPtr 		pArea;								/* area instance */
	LineInstPtr 		pLine;								/* line instance */
	FontInstPtr 		pFont;								/* font instance */
	union {
		CrustInfoRec		crust;
		LineInfoRec 		line;
		PolyInfoRec 		poly;
		RegionInfoRec 	region;
		SliceInfoRec		slice;
		TextInfoRec 		text;
		WedgeInfoRec		wedge;
	} info;
	INT16 					tagSize;							/* size of special tagging info */
	char						tagInfo[2]; 					/* where the tag info lives */
} DetNodeRec, HUGE * DetNodePtr;



/************************************************************************
*  M a c r o s
************************************************************************/
#define IsValidDetNodeRef(pDetRef) ((pDetRef)->offset != 0)


/************************************************************************
*  D e t N o d e   F u n c t i o n s
************************************************************************/
void PUBLIC
FreeDetNode(DetNodeRefPtr pDetRef);


INT16 PUBLIC
GetDetNodeObjectID(DetNodePtr pNode);


INT16 PUBLIC
XorDetNode(
	DrawEnvPtr			pDE, 
	DetNodePtr			pNode
);


INT16 PUBLIC
XorDetNodeRef(
	DrawEnvPtr			pDE, 
	DetNodeRefPtr		hDetRef
);

DetNodePtr PUBLIC
LockDetNodeRef(DetNodeRefPtr hDetRef);

INT16 PUBLIC
UnlockDetNodeRef(DetNodeRefPtr hDetRef);


/************************************************************************
* from COM_SLCT.H
************************************************************************/

#define SELECT_NUM_HANDLES 8
/* hit test handle positions */
typedef enum _HandleType{
	HTTopLeft,						/* 0 */
	HTTopRight,						/* 1 */
	HTBottomLeft,					/* 2 */
	HTBottomRight,				/* 3 */
	HTCenterTop,					/* 4 */
	HTCenterRight,				/* 5 */
	HTCenterLeft,					/* 6 */
	HTCenterBottom,				/* 7 */

	MAX_HITTEST_HANDLES
} HandleType;

/*******************
 *  S e l I t e m  *
 *******************/
enum SelItemDataType {
	DETNODE,
	ANODE,
	GEODE,
	GROUPODE
};

#define GROUP_LAYER (MAX_LAYER + 1)

/****************************
 *   S e l L i s t I n f o  *
 ****************************/
enum SelListInfoIndexType {
	SLI_NUMSELECTED,
	SLI_NUMANODESSELECTED,
	SLI_NUMGEODESSELECTED,
	SLI_NUMDETNODESSELECTED,
	SLI_NUMGROUPSSELECTED,
	SLI_NUMMOVABLESELECTED,
	SLI_NUMTEXTBOXSELECTED,
	SLI_NUMNONDELETE,
	SLI_NUMGROUPSATTACHED,
	SLI_NUMSELWITHLINE,
	SLI_NUMSELWITHAREA,
	SLI_NUMSELWITHFONT
};

/****************************************************************
 *   Selection List Relations - Used in Select_AddRelatedItems  *
 ****************************************************************/
enum SelListRelationIndexType {
	SLR_SAME_OBJECT,
	SLR_SAME_SERIES,
	SLR_SAME_GROUP,
	SLR_SAME_AREAINST,
	SLR_SAME_LINEINST,
	SLR_SAME_FONTINST,
	SLR_DEFAULT
};

typedef struct SelItemRec {
	struct SelItemRec FAR *	pNext;
	void 					FAR *	pSiblings;					/* The list this guy's in */
	void					FAR *	pChildren;					/* Pointer to child list if 	*/
																	/* this is a group, else NULL */
	
	INT16						nLayer;								/* layer  ID */
	INT16 					nObjectID;						/* object ID */
	INT16 					nSeriesID;						/* series ID */
	INT16 					nGroupID; 						/* group	ID */

	Rect						rcBounds;							/* outer bounds */
	Rect						rcLastBounds;				 	/* last bounds before move */
	Point						p0;									/* start point of line */
	Point						p1;									/* end point of line */
	INT16						nHandleCount;					/* # of handle rects */
	Rect						rcHandles[8];					/* always 8 handles for now... */

	INT16						nType;								/* SelItemDataType */
	DetNodeRef			refDetNode;
	union {
		AnodeInfoHdl		hAnode;
		GeodeInfoHdl		hGeode;
	} data;

} SelItemRec, FAR * SelItemPtr;


/************************************************************************
*  SelListRec -- Selection List Header
************************************************************************/
typedef struct _SelListRec {
	INT16 					nItemCount;

	SelItemPtr						pHead;
	SelItemPtr						pGroups;
	SelItemPtr						pParent;		/* Pointer to parent Group Item. 		*/
	SelItemPtr						pParentMarker; 	/* Pointer to parent Group Marker item. */

} SelListRec, FAR * SelListPtr;


SelListPtr PUBLIC			Select_AllocList			(	void );
INT16 PUBLIC					Select_FreeList				( SelListPtr pSelList );
SelItemPtr PUBLIC			Select_GetNextItem(SelItemPtr pCurr, INT16	goIntoGroups);
SelItemPtr PUBLIC			Select_GetFirstItem(SelListPtr pSelList, INT16 goIntoGroups);

INT16 PUBLIC					Select_ClearList			(	SelListPtr pSelList );

INT16 PUBLIC					Select_RebuildItem		(	GraphPtr 				pGraph, 
																							SelItemPtr 			pItem	);
INT16 PUBLIC					Select_RebuildList		(	GraphPtr				pGraph,
																							SelListPtr			pSelList  );

SelItemPtr PUBLIC			Select_AddItem				(	GraphPtr				pGraph,
																							SelListPtr			pSelList,
																							DetNodeRefPtr		pDetRef   );

INT16 PUBLIC					Select_RemoveItem			(	SelListPtr			pSelList,
																							SelItemPtr			pItem			);

SelItemPtr PUBLIC			Select_SearchList			(	SelListPtr			pSelList,
																							DetNodeRefPtr		pDetRef   );

INT16 PUBLIC					Select_IsEqual				(	SelItemPtr			pOne,
																							SelItemPtr			pTwo      );

INT16 PUBLIC					Select_CalcHandlesList(	DrawEnvPtr			pDE,
																							SelListPtr			pSelList  );
																							
INT16 PUBLIC					Select_CalcHandlesItem(	DrawEnvPtr			pDE,
																							SelItemPtr			pItem     );
																							
INT16 PUBLIC					Select_DrawXorList		(	DrawEnvPtr			pDE,
																							SelListPtr			pSelList  );
																							
INT16 PUBLIC					Select_DrawXorItem		(	DrawEnvPtr			pDE,
																							SelItemPtr			pItem     );

SelItemPtr PUBLIC			Select_HandleHitTest	(	SelListPtr			pSelList,
																							Point						mousePt,
																							INT16	FAR				*whichHandle,
																							Rect FAR				*pItemRect);

void PUBLIC						GetFirstDetNodeRef		(	SelListPtr			pSelList,
																							DetNodeRefPtr		pDetRef   );

void PUBLIC						Item2DetRef						(	SelItemPtr			pItem,
																							DetNodeRefPtr		pDetRef   );


SelListPtr PUBLIC				Select_DuplicateList		(	SelListPtr			pSelList	);

SelItemPtr PUBLIC
SelectDetNode	(	GraphPtr			pGraph,
						DrawEnvPtr		pDE,
						SelListPtr		pSelList,
						DetNodeRefPtr	pDetRef,
						INT16				append	 	);

INT16 PUBLIC
SelectDetNodesInRect	(	GraphPtr			pGraph,
								INT16			LayerID,
								SelListPtr		pSelList,
								Rect				*pBounds,
								DrawEnvPtr		pDE,
								INT16				append		);
								
INT16 PUBLIC
Select_Group(
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16					compactNow
);

INT16 PUBLIC
Select_UnGroup(
	GraphPtr				pGraph,
	SelListPtr			pSelList
);

INT16 PUBLIC
Select_GetListBounds(
	SelListPtr			pSelList,
	Rect					*pRect
);

INT16 PUBLIC
Select_GetListInfo(
	SelListPtr			pSelList,
	INT16						nIndex
);

INT16 PUBLIC
Select_IsObjectSelected(
	SelListPtr			pSelList,
	INT16						nObjectID
);

INT16 PUBLIC
Select_AddRelatedItems(	
	GraphPtr			pGraph,				/* Pointer to graph		*/
	SelListPtr		pSelList,			/* SelList to update	*/
	DetNodeRefPtr	pDetRef,			/* Target for search	*/
	INT16					nRelation,		/* Relation to find		*/
	INT16					bSelectTarget,/* Select pDetRef too?*/
	INT16					nObjectFilter	/* Object ID constrain*/
);

/* DW:(11/24/93) Added these next two routines for */
LPPOINT PUBLIC 
CreateSelItemOutline(
	DrawEnvPtr			pDE,
	SelItemPtr			pItem,
	PINT16				  pnPoints);

INT16 PUBLIC
DestroySelItemOutline(
	Point FAR *			ptData);


/************************************************************************
* from COM_RNGE.H
************************************************************************/

typedef struct {

	/*
	 * Caller sets these variables.
	 */

	REAL	fRawMin;
	REAL	fRawMax;

	BOOLEAN16	bIsLog;

	BOOLEAN16	bManualMajorHash;
	INT16		nMajorHashCount;		/* Manual hash count. */

	INT16		nManualScale;

	/*
	 * Routine sets these variables.
	 */


	INT16 					nMajorHash;
	REAL						fMin;				/* Requires formatting for display. */
	REAL						fMax;				/* Requires formatting for display. */

} ScaleClass, FAR *ScalePtr;

INT16 PUBLIC
DetermineScale(
	ScalePtr	pScale
);


/************************************************************************
* from COM_GRAF.H
************************************************************************/

GraphPtr PUBLIC			AllocGraphPtr			 (void); 										/* get bag for globals */

void PUBLIC					FreeGraphPtr			 (GraphPtr pGraph);					/* give it back */

void PUBLIC					FreeColorInstSFX	 (ColorInstPtr pColor);

BOOLEAN16 PUBLIC			FindNextDetNode		 (GraphPtr				pGraph,				/* ptr to Graph struct */
																 				Point FAR *			pMouser,			/* in virtual coords */
																 				DetNodeRefPtr		pDetRef, 			/* struct filled upon success */
																				BOOLEAN16					bFound);			/* FALSE = First Search in this DetList */

BOOLEAN16 PUBLIC			FindDetNode				 (GraphPtr				pGraph,				/* ptr to Graph struct */
																 				Point FAR *			pMouser,			/* in virtual coords */
																 				DetNodeRefPtr		pDetRef  );		/* struct filled upon success */

void PUBLIC					FreeAllDetNodes		 (GraphPtr pGraph);

INT16 PUBLIC				GetDetNode				 (GraphPtr				pGraph,
																 				INT16						objectID,
																 				INT16						seriesID,
																 				INT16						groupID, 
																 				INT16 					caseID,
																 				DetNodeRefPtr 	pDetRef );


INT16 PUBLIC
GetNextDetNode(
	GraphPtr			pGraph,
	INT16					objectID,
	INT16					seriesID,
	INT16					groupID,
	INT16					caseID,
	DetNodeRefPtr	pDetRef
);

INT16 PUBLIC												/* NEW FUNCTION: 12/6/92 DW */
GetRiserDetNodeLimit(
	GraphPtr			pGraph
);

VOID PUBLIC													/* NEW FUNCTION: 12/6/92 DW */
SetRiserDetNodeLimit(
	GraphPtr			pGraph,
	INT16					MaxNum
);

/************************************************************************
* from COM_DGRF.H
************************************************************************/

INT16 PUBLIC
IsGraphBackgroundVisible(GraphPtr pGraph);

INT16 PUBLIC
DrawBackgroundLayer(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph
);


INT16 PUBLIC
DrawGraphLayer(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph
);


INT16 PUBLIC
DrawAnnotationLayer(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph
);


INT16 PUBLIC
DryRunTheGraph(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	INT16						wantGraph,
	INT16						wantBackground,
	INT16						wantAnnotation
);


INT16 PUBLIC
DrawTheGraph(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	short						wantGraph,
	short						wantBackground,
	short						wantAnnotation
);


/************************************************************************
* from COM_UTIL.H
************************************************************************/

/* return current spreadsheet page num */
INT32 PUBLIC
GetGraphPage(GraphPtr pGraph);

BOOLEAN16	PUBLIC	IsObjectATextBox
	(
	INT16						nObjID								/* Object's ID number.    					*/
	);

/* return engine class */
INT16 PUBLIC
GetGraphEngineClass(GraphPtr pGraph, INT16 layerID, SelItemPtr pItem);

/* return numeric graphtype index */
INT16 PUBLIC
GetGraphTypeIndex(GraphPtr pGraph);

/* return current graph type name */
LPSTR PUBLIC 
GetGraphTypeName(GraphPtr pGraph);

/* return numeric value for name */
INT16 PUBLIC
GetGraphTypeIndexFromName(char FAR *name);

/* returns name for value */
LPSTR PUBLIC 
GetGraphTypeNameFromIndex(INT16 idx);

WashBandPtr PUBLIC
GetGraphWashBandTbl(GraphPtr pGraph);

INT16 PUBLIC
SetGraphDataInfo(
	GraphPtr				pGraph,								/* ptr to valid graph */
	GraphDataPtr		pGraphData						/* ptr to caller supplied struct */
);

void PUBLIC
GetGraphDataInfo(
	GraphPtr				pGraph,								/* ptr to valid graph */
	GraphDataPtr		pGraphData						/* ptr to caller supplied struct */
);


/************************************************************************
* from DLLFLOAT.H
************************************************************************/

void CALLBACK 		ConvertFltToStr				(double, char FAR *);


/************************************************************************
* from STD_IORW.H
************************************************************************/

typedef struct IOPATH {
	COOKIE					cookie;
	INT16						isRamFile;
	UCHAR FAR *			pBuffer;
	UCHAR FAR	*			buffer;
	UINT32					nBufSize;
	UINT32					nBufIndex;
} IOPATH, FAR * IOPATHPTR;


#define IO_RD_WR    TRUE  
#define IO_RD_ONLY 	FALSE 

INT16 PUBLIC
IOopen(
	IOPATHPTR				iopath,								/* ptr to the io path */
	char FAR *			fileName,							/* c string filename */
	INT16						vRefNum,							/* volume ref num - used for Macintosh only */
	BOOLEAN16 				rw										/* T = read/write, F = read only */
);


INT16 PUBLIC
IOconnect(
	IOPATHPTR				iopath,								/* ptr to the io path */
	COOKIE					cookie								/* file cookie */
);


INT16 PUBLIC
IOclose(
	IOPATHPTR				iopath								/* the file id */
);

INT16 PUBLIC
IOgetc(
	IOPATHPTR				iopath
);


LPSTR PUBLIC   IOgets(
	IOPATHPTR		iopath,
	char FAR *	buffer,
	INT32				bufsiz
);


//INT16 FAR
//IOprintf(IOPATHPTR iopath, char FAR *fmt, ...);


INT32 PUBLIC
IOread(
	IOPATHPTR		iopath,
	void FAR *	buffer,
	INT32				bufsiz
);


INT32 PUBLIC
IOwrite(
	IOPATHPTR		iopath,
	void FAR *	buffer,
	INT32				bufsiz
);

/**************************************************************************
*	DEFINE:	IOseek( )	macros
*	AUTHOR:	Neil S. Glover
*	DATE:		January 31, 1991
*	DESC:		A seek routine can be performed in three ways:
*							1. From beginning of the file
*							2. From the current position
*							3. From the end of the file.
*					These macros are to be used in the nOrigin position.
*
**************************************************************************/
#if defined(applec) || defined(THINK_C)

#define IO_SEEK_BEG	0x0001
#define IO_SEEK_CUR	0x0003
#define IO_SEEK_END 0x0002

#elif defined(_WINDOWS) || defined(MSDOS)

#define IO_SEEK_BEG	0x0000
#define IO_SEEK_CUR	0x0001
#define IO_SEEK_END 0x0002

#endif

INT32 PUBLIC
IOseek(
	IOPATHPTR   ioPath,
	long        lBytes,
	INT16       nOrigin
);


/************************************************************************
* from tdi_graf.h
************************************************************************/

#define REQUEST_LOOK				 	0x0001	/* Graph visual characteristics. */
#define REQUEST_TCLOOK				0x0002	/* Table chart visual characteristics. */
#define REQUEST_DLOOK					0x0004	/* Data related characteristics. */
#define REQUEST_TEXTOBJECT		0x0008	/* Text charts. */
#define REQUEST_ANODE					0x0010	/* Annotation. */
#define REQUEST_CELL					0x0020	/* Graph data. */
#define REQUEST_FONTMASTER		0x0040	/* Graph fonts. */
#define REQUEST_BACKGROUND		0x0080	/* Background area instance. TL:11/17/92 w/MR: */

/* TL:11/23/92 added bit 0x0080 to support read/write layers (background) */
#define REQUEST_TDC						0x00F7	
#define REQUEST_TDL						0x00D7

/* TL:11/23/92 added read/write requests to support layers */
#define REQUEST_TDCBACKGROUND	0x0080
#define REQUEST_TDCGRAPH			0x006F
#define REQUEST_TDCANNOTATION 0x0010

/* TL:11/23/92 added read/write requests to support layers */
#define REQUEST_TDLBACKGROUND	0x0080
#define REQUEST_TDLGRAPH			0x0047
#define REQUEST_TDLANNOTATION 0x0010

#define REQUEST_3D3		0x00FF			/* Full chart tag aggregation. */
#define REQUEST_3DL		0x00D3			/* Look only chart tag aggregation. */


INT16 PUBLIC
TDIReadGraph(
	GraphPtr	pGraph,			/* Target of read operation. */
	UINT32		ulRequest,	/* Bitwise tag request flags. */
	PCHAR			szFile			/* Name of file to be read. */
);


INT16 PUBLIC
TDIWriteGraph(
	GraphPtr	pGraph,			/* Graph to be written. */
	UINT32		ulRequest,	/* Bitwise tag request flags. */
	PCHAR			szFile			/* Name of file to be written. */
);

INT16 PUBLIC
TDIReadPath(
	IOPATHPTR	pIO,
	GraphPtr	pGraph,
	UINT32		ulRequest
);

INT16 PUBLIC
TDIWritePath(
	IOPATHPTR	pIO,
	GraphPtr	pGraph,
	UINT32		ulRequest
);

GraphPtr PUBLIC
TDICloneGraph(
	GraphPtr				pGraph		/* Graph to be cloned. */
);

INT16 PUBLIC
TDISizeTest(
	GraphPtr				pGraph,
	PINT32					pnMoved		 
);



/************************************************************************
* from CRO_DEFS.H
************************************************************************/

#define A2D_RANGE_BEGIN		  1
#define A2D_RANGE_END			255

#define A3D_RANGE_BEGIN		256
#define A3D_RANGE_END			351

#define AAN_RANGE_BEGIN		352
#define AAN_RANGE_END			415

#define ATX_RANGE_BEGIN		416
#define ATX_RANGE_END			447

#define A_RANGE_BEGIN			448
#define A_RANGE_END				511


#define O_RANGE_BEGIN			1
#define O_RANGE_END				255

#define O2D_RANGE_BEGIN		256
#define O2D_RANGE_END			511

#define O3D_RANGE_BEGIN		512
#define O3D_RANGE_END			767

#define OTX_RANGE_BEGIN		768
#define OTX_RANGE_END			1023

#define OAN_RANGE_BEGIN		1024
#define OAN_RANGE_END			1279


#define MAXATTRIBUTES 32			/* max # of attribues allowed in a list */


/*********************************
 *  C o m m o n   O b j e c t s  *
 *********************************/
typedef enum {
	O5D_BACKGROUND = O_RANGE_BEGIN,
	O5D_FRAME,
	O5D_LBLFOOTNOTE,
	O5D_LBLSUBTITLE,
	O5D_LBLTITLE,

	OSG_LEGEND_AREA,
	OSG_LEGEND_LINE,
	OSG_LEGEND_MARKER,
	OSG_LEGEND_TEXT,

	O5DTYPEMAX
} O5DType;
#define O5DCOUNT ((int) O5DTYPEMAX)

#if (O5DTYPEMAX > O_RANGE_END)
	#error cro_defs.h: (O5DTYPEMAX > O_RANGE_END)
#endif


/***************************************************
 *  C o m m m o n   A t t r i b u t e   C o d e s  *
 ***************************************************/
#define A_COMMON_THRESHOLD A_RANGE_BEGIN

typedef enum {
	ACM_COLORDIVISIONS  = A_COMMON_THRESHOLD,	/* # of colors used in CM_BY_HEIGHT, etc. */
	ACM_COLORMODEL,								/* CM_BY_SERIES, CM_BY_HEIGHT, etc. */
	ACM_SERIES_COLOR,							/* Sets an entry in pRiserColors */ 
	ACM_WASH,											/* Fills pRiserColors with a wash */ 
	ACM_WASHBEGIN,								/* Start of wash applied by ACM_WASH */
	ACM_WASHEND,									/* End of wash applied by ACM_WASH */

	ASG_LGND_ITEMS,
	ASG_LGND_LAYOUT,
	ASG_SERIES_COLOR, 
	ASG_SERIES_DELETE,
	ASG_REVERSE_GROUPS,
	ASG_REVERSE_SERIES,
	ASG_SWAP,

	A_AREABACKCOLOR,							/* Background color for patterns */
	A_AREACOLOR_BIN,							/* nSpectrumBin */
	A_AREACOLOR_NONE,							/* invisble area flag */
	A_AREACOLOR_RGB,							/* RGB Color picker */
	A_AREADROPSHADOW,							/* DropShadow for Areas */	// TL:11/16/92 from DW: work
	A_AREAPATTERN,								/* Pattern picker */
	A_AREASFX,										/* Area Special effects */
	A_AREASFXPRESET,							/* Area Special effect preset # */
	A_ARROWHEADS,									/* Arrowheads for lines */
	A_FONTALIGN,									/* Font justification picker */
	A_FONTCHARSET,								/* Font's character set */
	A_FONTCOLOR_BIN,							/* nSpectrumBin */
	A_FONTCOLOR_NONE,							/* invisible font flag */
	A_FONTCOLOR_RGB,							/* RGB Font color picker */
	A_FONTDROPSHADOW,							/* DropShadow for Fonts */
	A_FONTNAME,										/* Font family picker */	// TL:11/16/92
	A_FONTFAMILY,									/* Font pitch & family code */
	A_FONTORIENT,									/* Font orientation. */
	A_FONTPATTERN,								/* Font pattern picker */
	A_FONTQUALITY,								/* Font quality picker: Stroke, Draft, Proof or Exact */
	A_FONTSFX,										/* Font special effects picker */
	A_FONTSIZE_VC,								/* Virtual Coord FontSize picker */
	A_FONTSTYLE,									/* Font style picker: italic, bold, etc. */
	A_GRAPH_PRESET,								/* Graph Preset Type */
	A_LINECOLOR_BIN,							/* nSpectrumBin */
	A_LINECOLOR_NONE,							/* invisible line flag */
	A_LINECOLOR_RGB,							/* RGB ColorPicker for Lines */
	A_LINEPATTERN,								/* Line Style */
	A_LINESFX,								  	/* Special effects applied to border line */
	A_LINEWIDTH,									/* Line width */
	A_LOCATE_FOOTNOTE,
	A_LOCATE_FRAME,
	A_LOCATE_SUBTITLE,
	A_LOCATE_TITLE,
	A_SHOW_FOOTNOTE,
	A_SHOW_SUBTITLE,
	A_SHOW_TITLE,

	MAX_COMMON_ATTRIBUTE
} AttributeCommon;


/************************************************************************
* from C2D_DEFS.H
************************************************************************/

/*
 * Some 2D graph terms defined:
 *		Group						-	Generally a column of data.
 *		Primary axis		-	The only numeric axis on charts with only one.
 *											Applies to the left hand data set in dual Y charts,
 *											and the Y axis on scatter charts.
 *		Secondary axis	-	Numeric axis scaling the right hand data set for dual Y charts
 *											and the X axis on scatter charts.
 *		Series					-	Generally a row of data.
 *		Surface					- Any rectanglar area of the charting viewspace.
 */

typedef enum {
	O2D_AREARISER = O2D_RANGE_BEGIN,			/* Quantitative data representation on an area chart. */
	O2D_CURVE,							/* Quantitative data series interpolation line. */
	O2D_DATALINE,						/* Line connecting data markers of a line chart. */
	O2D_DATAMARKER,					/* Quantitative data representation point. */
	O2D_DATATEXT,
	O2D_DIVBIPOLAR,					/* Line dividing bipolar chart surfaces. */
	O2D_ERRORBAR,						/* */

	O2D_LINR_EXP,
	O2D_LINR_LINE,
	O2D_LINR_LOG,
	O2D_LINR_NATLOG,
	O2D_LINR_NPOLY,
	O2D_LINR_TEXT,

	O2D_MEANLINE,						/* Histogram mean line. */
	O2D_MOVAVGLINE,					/* Quantitative data series moving average line. */

	O2D_O1_BODY,
	O2D_O1_LABEL,
	O2D_O1_MAJOR,
	O2D_O1_MINOR,
	O2D_O1_SUPER,						/* TL:11/17/92 added super grid line for bars */
	O2D_O1_TITLE,

	O2D_O2_BODY,
	O2D_O2_LABEL,
	O2D_O2_MAJOR,
	O2D_O2_MINOR,
	O2D_O2_TITLE,


	O2D_PRESDL_CONN,
	O2D_PRESDL_CONNBRK,
	O2D_PRESDL_STEP,
	O2D_PRESDL_STEPBRK,

	O2D_RISER,							/* Quantitative data representation of a bar chart. */
	O2D_RISERSHADOW,				/* Visual effect for bar data representation. */
	O2D_STDDEVLINE,					/* Histogram standard deviation line(s). */

	O2D_X1_BODY,
	O2D_X1_LABEL,
	O2D_X1_MAJOR,
	O2D_X1_MINOR,
	O2D_X1_TITLE,
	O2D_X1_ZERO,

	O2D_Y1_BODY,
	O2D_Y1_LABEL,
	O2D_Y1_MAJOR,
	O2D_Y1_MINOR,
	O2D_Y1_TITLE,
	O2D_Y1_ZERO,

	O2D_Y2_BODY,
	O2D_Y2_LABEL,
	O2D_Y2_MAJOR,
	O2D_Y2_MINOR,
	O2D_Y2_TITLE,
	O2D_Y2_ZERO,

	OBP_CAT_COLDIVISORS, 
	OBP_CAT_COLHEADAREA, 
	OBP_CAT_COLMARKER,	 
	OBP_CAT_DATAAREA,		 
	OBP_CAT_LBLCELL,		 
	OBP_CAT_LBLCOLHEAD,	 
	OBP_CAT_LBLROWHEAD,	 
	OBP_CAT_LBLROWTITLE, 
	OBP_CAT_ROWDIVISORS, 
	OBP_CAT_ROWHEADAREA, 
	OBP_CAT_SUBJECTAREA, 
	
	OBP_GRP_COLDIVISORS, 
	OBP_GRP_COLHEADAREA, 
	OBP_GRP_COLMARKER,	 
	OBP_GRP_DATAAREA,		 
	OBP_GRP_LBLCELL,		 
	OBP_GRP_LBLCOLHEAD,	 
	OBP_GRP_LBLROWHEAD,	 
	OBP_GRP_LBLROWTITLE, 
	OBP_GRP_ROWDIVISORS, 
	OBP_GRP_ROWHEADAREA, 
	OBP_GRP_SUBJECTAREA, 

	OBP_BOX,
	OBP_MEDIAN,
	OBP_STEM,
	OBP_TAIL,

	OCT_LBLCONTOUR,				/* Contour levels Label 	*/
	OCT_LBLCONTOURPOINT,	/* Label associated with a Contour Point	*/
	OCT_LINECONTOUR,			/* Contour Lines*/
	OCT_MRKCONTOURPOINT,	/* Marker for contour point */

	OPI_FEELER,
	OPI_LBLFEELER,
	OPI_LBLPIE,
	OPI_LBLRING,
	OPI_SLICE,
	OPI_SLICECRUST,
	OPI_SLICEFACE,
	OPI_SLICERING,
	OPI_BARCONNECT,				/* TL:05/06/93 line connects pie to bar in pie bar */
  
	OPL_CIRCLEPOLARAXIS,	/* Circle polar axis. */
	OPL_LBLPOLARAXIS,			/* Polar Axis Label 	*/
	OPL_LINES,						/* Polar Lines. */
	OPL_THICKPOLARAXIS,		/* Polar Axis Thick 	*/

	OSM_RISER,

	OSP_SCALE_MARKER,

	OTC_COLDIVISORS,			/* Lines separating full chart columns. */
	OTC_COLHEADAREA,			/* Surface beneath the column headers of a table chart. */
	OTC_COLMARKER,				/* */
	OTC_DATAAREA,					/* Surface beneath the data text of a table chart. */
	OTC_LBLCELL,					/* Data text of a table chart. */
	OTC_LBLCOLHEAD,				/* Column header text of a table chart. */
	OTC_LBLROWHEAD,				/* Row header text of a table chart. */
	OTC_LBLROWTITLE,			/* Row title text associated with row headers. */
	OTC_ROWDIVISORS,			/* Lines separating full chart rows. */
	OTC_ROWHEADAREA,			/* Surface beneath the row headers of a table chart. */
	OTC_SUBJECTAREA,			/* Surface just above the row header surface area. */
 	OBL_QUADRANT_LINE,			/* 28sep94/DW: Add support for BUBBLE CHARTS */
 
 MAX_2D_OBJCLASS
} ObjClass2D;

#if (MAX_2D_OBJCLASS > O2D_RANGE_END)
	#error c2d_defs.h: (MAX_2D_OBJCLASS > O2D_RANGE_END)
#endif


typedef enum {
	A2D_AUTOFIT_ALL = A2D_RANGE_BEGIN, 				/* Global control of autofitting. */
	A2D_AUTOFIT_DATATEXT,
	A2D_AUTOFIT_LEGEND,
	A2D_AUTOFIT_O1,
	A2D_AUTOFIT_O2,
	A2D_AUTOFIT_X,
	A2D_AUTOFIT_Y1,
	A2D_AUTOFIT_Y2,
	A2D_AXISSWAP,								/* Interpret series as columns? */
	A2D_BAR_GROUP_SPACING,			/* Intergroup spacing for side by side charts. */
	A2D_BAR_RISER_WIDTH,				/* Bar width (-50 <= x < 0 < x <= 100 ). */
	A2D_COLORBYSERIES,				 	/* Color QDRs by series? */
	A2D_CURVECOLORASSERIES,
	A2D_CURVEMOVING,						/* Moving average line factor. */
	A2D_CURVESMOOTH,						/* Smooth curve factor (0 < x < 16). */
	A2D_DATAFORMAT,							/* Data format specifier. */
	A2D_DATAFORMAT_VERT,				/* Vertical data node format control. */
	A2D_DEPTH_IMS_ANGLE,
	A2D_DEPTH_IMS_COLORMODE,
	A2D_DEPTH_IMS_THICK,
	A2D_DEPTH_MODE,
	A2D_DIRECTION_X,						/* X numeric axis ascending or descending? */
	A2D_DIRECTION_Y1,						/* Y1 numeric axis ascending or descending? */
	A2D_DIRECTION_Y2,						/* Y2 numeric axis ascending or descending? */
	A2D_EXCLUDE_ZERO_X,
	A2D_EXCLUDE_ZERO_Y1,
	A2D_EXCLUDE_ZERO_Y2,
	A2D_FORMATDTXT_X,
	A2D_FORMATDTXT_Y1,
	A2D_FORMATDTXT_Y2,
	A2D_FORMAT_DATATEXT,				/* Set format code for data text. */
	A2D_FORMAT_SDLINE,
	A2D_FORMAT_X,								/* Set format code for X axis scale text. */
	A2D_FORMAT_Y1,							/* Set format code for Y1 axis scale text. */
	A2D_FORMAT_Y2,							/* Set format code for Y2 axis scale text. */
	A2D_FORMAT_Z,								/* Set format code for Z axis scale text. */
	A2D_GRIDLINESORD_O1,				/* O1 ordinal axis gridline control. */
	A2D_GRIDLINESORD_O2,				/* O2 ordinal axis gridline control. */
	A2D_GRIDLINES_X,						/* X numeric axis gridline control. */
	A2D_GRIDLINES_Y1,						/* Y1 numeric axis gridline control. */
	A2D_GRIDLINES_Y2,						/* Y2 numeric axis gridline control. */
	/* TL:11/18/92 added new attributes to control ordinal axis gridlines */
	A2D_GRIDMODEMAJOR_O1,				/* O1 ordinal axis major gridline mode control */
	A2D_GRIDMODEMINOR_O1,				/* O1 ordinal axis minor gridline mode control */
	A2D_HL_COLOR,
	A2D_IGNORE_SERIES,
	A2D_INSET_LGND_ICON,				/* Inset box of legend icon. */
	A2D_INSET_LGND_TEXT,				/* Inset box of legend text. */
	A2D_LABELMODE_O1,
	A2D_LABELMODE_O2,
	A2D_LABELWRAPMODE_O1,				/* TL:11/12/92 multi-line label wrap */
	A2D_LABELWRAPLINES_O1,			/* TL:11/12/92 multi-line label wrap # of lines */
	A2D_LOCATE_LEGEND,					/* Legend surface location. */
	A2D_LOCATE_LINR_TEXT,
	A2D_LOCATE_TITLE_X,					/* X axis title location. */
	A2D_LOCATE_TITLE_Y1,				/* Y1 axis title location. */
	A2D_LOCATE_TITLE_Y2,				/* Y2 axis title location. */
	A2D_LOG_X,									/* X numeric axis logarithmic flag. */
	A2D_LOG_Y1,									/* Y1 numeric axis logarithmic flag. */
	A2D_LOG_Y2,									/* Y2 numeric axis logarithmic flag. */
	A2D_MARKERSHAPE,						/* Marker shape. */
	A2D_MARKERSIZE,							/* Marker size. */
	A2D_ORIENTATION,						/* Horizontal chart flag. */
	A2D_PLACE_O1,
	A2D_PLACE_O2,
	A2D_PLACE_X,
	A2D_PLACE_Y1,
	A2D_PLACE_Y2,
	A2D_PRESDL_CONN,
	A2D_PRESDL_CONNBRK,
	A2D_PRESDL_STEP,
	A2D_PRESDL_STEPBRK,
	A2D_PRESDL_STEPVERT,
	A2D_SCALEBASE,							/* Riser base control. */
	A2D_SCALEEND_X,
	A2D_SCALEEND_Y1,
	A2D_SCALEEND_Y2,
	A2D_SCALEFREQ_BEG_O1,			 
	A2D_SCALEFREQ_BEG_O2,
	A2D_SCALEFREQ_BEG_X,
	A2D_SCALEFREQ_BEG_Y1,
	A2D_SCALEFREQ_BEG_Y2,
	A2D_SCALEFREQ_END_O1,
	A2D_SCALEFREQ_END_O2,
	A2D_SCALEFREQ_END_X,
	A2D_SCALEFREQ_END_Y1,
	A2D_SCALEFREQ_END_Y2,
	A2D_SCALEFREQ_O1,					 
	A2D_SCALEFREQ_O2,
	A2D_SCALEFREQ_X,
	A2D_SCALEFREQ_Y1,
	A2D_SCALEFREQ_Y2,
	A2D_SCALE_X,								/* X numeric axis scale control. */
	A2D_SCALE_Y1,								/* Y1 numeric axis scale control. */
	A2D_SCALE_Y2,								/* Y2 numeric axis scale control. */
	A2D_SCIMOVAVG,							/* Generate scientific moving averages. */
	A2D_SDDATALINE_TYPE,
	A2D_SDEMPHASIZED,						/* Series dependant integer - emphasized. */
	A2D_SDLINECONN,							/* Series dependant line boolean - connected. */
	A2D_SDLINECURV,							/* Series dependant line boolean - smooth curve. */
	A2D_SDLINELINR,
	A2D_SDLINELINR_CORR,
	A2D_SDLINELINR_EXP,
	A2D_SDLINELINR_FORMULA,
	A2D_SDLINELINR_LINE,				/* Series dependant line boolean - linear regression. */
	A2D_SDLINELINR_LOG,
	A2D_SDLINELINR_NATLOG,
	A2D_SDLINELINR_NPOLY,
	A2D_SDLINELINR_NPOLYFAC,
	A2D_SDLINEMEAN,							/* Series dependant line boolean - mean. */
	A2D_SDLINEMOVA,							/* Series dependant line boolean - moving average. */
	A2D_SDLINESTDD,							/* Series dependant line boolean - standard deviation. */
	A2D_SHADOW_OFFSETS,					/* Riser shadow offsets. */
	A2D_SHOW_DATATEXT,				 	/* Data text show flag. */
	A2D_SHOW_DIVBIPOLAR,				/* Bipolar division line flag. */
	A2D_SHOW_ERRORBAR,
	A2D_SHOW_LEGEND,						/* Legend box show flag. */
	A2D_SHOW_O1,								/* Ordinal axis 1 show flag. */
	A2D_SHOW_O2,								/* Ordinal axis 2 show flag. */
	A2D_SHOW_OFFSCALE_X,
	A2D_SHOW_OFFSCALE_Y1,
	A2D_SHOW_OFFSCALE_Y2,
	A2D_SHOW_QUADRANTS,					/* DW: 4/22/94 */
	A2D_SHOW_SHADOWS,						/* Riser shadow show flag. */
	A2D_SHOW_TITLE_X,						/* X axis title text show flag. */
	A2D_SHOW_TITLE_Y1,					/* Y1 axis title text show flag. */
	A2D_SHOW_TITLE_Y2,					/* Y2 axis title text show flag. */
	A2D_SHOW_X,									/* Numeric X axis show flag. */
	A2D_SHOW_Y1,								/* Numeric primary Y axis show flag. */
	A2D_SHOW_Y2,								/* Numeric secondary Y axis show flag. */
	A2D_SHOW_ZL_X,
	A2D_SHOW_ZL_Y1,
	A2D_SHOW_ZL_Y2,
	A2D_SIDE_O1,								/* O1 axis label placement. */
	A2D_SIDE_O2,								/* O2 axis label placement. */
	A2D_SIDE_X,									/* X axis label placement. */
	A2D_SIDE_Y1,								/* Y1 axis label placement. */
	A2D_SIDE_Y2,								/* Y1 axis label placement. */
	A2D_SIZE_ERRORBARS,
	A2D_SPLITY,									/* Y Axis association for Dual Y charts. */
	A2D_SPLITY_ND,
	A2D_SQUARE_LGND_ICONS,
	A2D_STAGGER_O1,							/* Staggered axis text flag. */
	A2D_STAGGER_O2,							/* Staggered axis text flag. */
	A2D_STAGGER_X, 							/* Staggered axis text flag. */
	A2D_STAGGER_Y1,							/* Staggered axis text flag. */
	A2D_STAGGER_Y2,							/* Staggered axis text flag. */
	A2D_SYMBOL_FORSERIES,
	A2D_UNIFORM_QDRBORDERS,
	A2D_UNIFORM_QDRSHAPES,

	ABA_PICTOGRAPH,

	ABP_CATTABLE_LAYOUT,
	ABP_COMPRESSION,
	ABP_DATAMARKER_SPACING,
	ABP_GROUPTABLE_FAR,
	ABP_GROUPTABLE_NEAR,
	ABP_GROUP_SPLITY_ND,
	ABP_JITTER,
	ABP_SHOW_DATAMARKERS,
	ABP_SHOW_GROUPTABLE,
	ABP_SHOW_HINGEBOXES,
	ABP_SHOW_HINGES,
	ABP_SHOW_HINGETAILS,
	ABP_SHOW_MEDIAN,
	ABP_SHOW_OUTLIERS,

	ACT_BCLIPSURFACE,  /* Clip surface */
	ACT_BSHOWLABEL,			 /* on/off Contour Label */
	ACT_CLEVEL,        /* Contour level CLevelLookClass */
	ACT_CPOINT,        /* Contour point */
	ACT_CSURFACE,        /* Contour surface */
	ACT_FLMAJORINTAUTO,
	ACT_FLMAJORINTMANU,
	ACT_FLMINORINTAUTO,
	ACT_FLMINORINTMANU,
	ACT_FLMAXAUTO,		/* Auto contour level max */
	ACT_FLMAXMANU,		/* Mnual contour level max */
	ACT_FLMINAUTO,		/* Auto contour level min */
	ACT_FLMINMANU,		/* Mnual contour level min */
	ACT_NCONTOURS,     /* Number of Contour levels 0 < x */
	ACT_NCPOINTS,      /* Number of Contour points 0 <= x */
	ACT_NINDEX,         /* set index for AttrSetOperation */
	ACT_NLABELSEG,		 /* Number of contour labels every nTh segment > 0 */
	ACT_NLFORMAT,      
	ACT_NOPERATION,		 /* Set operation format */
	ACT_NSMOOTH,			 /* Contour smooth factor (1 <= x <= 10). */
	ACT_NSURFACES,     /* Number of SURFACES 0 < x */
	ACT_NSURFACESFLAG, 
	ACT_XSTART,        /* Contour x-axis starting point */
	ACT_XSTEP,         /* Contour x-axis unit interval */
	ACT_YSTART,        /* Contour y-axis starting point > 0.0 */
	ACT_YSTEP,         /* Contour y-axis unit interval > 0.0 */

	API_AUTOFIT_LBLPIE,
	API_DEPTH,
	API_FEELER_CENTER,
	API_FEELER_HORZ,
	API_FEELER_RADIAL,
	API_FORMAT_DATATEXT,
	API_FORMAT_RINGTEXT,
	API_HOLESIZE,
	API_INSET_LBLPIE,
	API_INSET_PIE,
	API_PIESPERROW,
	API_ROTATE,
	API_SHOW_FEELER,
	API_SHOW_LBLFEELER,
	API_SHOW_LBLPIE,
	API_SHOW_LBLRING,
	API_SLICE_DELETE,
	API_SLICE_MOVE,
	API_SLICE_RESTORE,
	API_TILT,
	API_TILT_ON,
	API_DRAW_CLOCKWISE,

	APL_ANGLE,				/* Angle in Degree or Radian */
	APL_AXIS,				/* Polar coordinate Axis wanted or not */
	APL_AXIS_CIRCLES,		/* Number of Polar Axis Circles */
	APL_AXIS_THICKS,		/* Number of Polar Axis Thicks */
	APL_LINES,				/* Connecting polar lines graphed or not */
	APL_LINE_FORMAT,		/* Format to connect for connecting lines. 0 = all, 1 = by series, 2 = by groups */
	APL_SMOOTH,				/* Smooth factor for connecting lines */

	ASM_HLWIDTH,
	ASM_ITEM_DTXT,
	ASM_ITEM_SDLINE,
	ASM_OCHEIGHT,
	ASM_OCWIDTH,
	ASM_SHOW_CLOSE,
	ASM_SHOW_OPEN,

	ASP_INSET_MAP,

	ATC_AUTOFIT_ALL,
  ATC_AUTOFIT_CELL,
	ATC_AUTOFIT_COLHEAD,
	ATC_AUTOFIT_ROWHEAD,
  ATC_AUTOFIT_SUBJECT,
	ATC_DIVISIONS,
	ATC_INSET_TABLE,
	ATC_LINECONTROL,
	ATC_UNIFORMCOLS,
	ATC_UNIFORMROWS,

	MAX_2D_ATTRIBUTE
} Attributes2D;


/************************************************************************
* from C3D_DEFS.H
************************************************************************/

typedef enum {
	O3D_COLHEADER = O3D_RANGE_BEGIN,	/* Text associated with a data group (column). */
	O3D_COLHEADER_2D,			/* 2D text version of column header. */
	O3D_COLHEADER_BOX,			/* Optional box behind COLHEADER. */
	O3D_COLTITLE,				/* Title associated with all data groups. */
	O3D_COLTITLE_2D,			/* 2D text version of column title. */
	O3D_COLTITLE_BOX,			/* Optional box behind COLTITLE. */
	O3D_DATALABEL,				/* Text label used mainly for scatter graph. */
	O3D_DATALABEL_BOX,			/* Box for O3D_DATALABEL. */
	O3D_DATAMARKER,				/* 2D Marker used for scatter graphs. */
	O3D_FLOOR1,					/* Front and back faces of graph's floor. */
	O3D_FLOOR2,					/* Left and right faces of graph's floor. */
	O3D_FLOOR3,					/* Top and bottom faces of graph's floor. */
	O3D_FRAMEGRID_X,			/* Tickline along x axis on graph cube / frame.*/
	O3D_FRAMEGRID_Y,			/* Tickline along y axis on graph cube / frame.*/
	O3D_FRAMEGRID_Z,			/* Tickline along z axis on graph cube / frame.*/
	O3D_LASTRISERFACE,		/* Tenth face of a riser. */
	O3D_LEFTWALL1,				/* Front and back faces of graph's left wall. */
	O3D_LEFTWALL2,				/* Left and right faces of graph's left wall. */
	O3D_LEFTWALL3,				/* Top and bottom faces of graph's left wall. */
	O3D_LYHEADER,				/* Text associated with left vertical axis (Y1). */
	O3D_LYHEADER_2D,			/* 2D text version of left header. */
	O3D_LYHEADER_BOX,			/* Optional box behind LYHEADER. */
	O3D_LYTITLE,				/* Title associated with left vertical axis (Y1). */
	O3D_LYTITLE_2D,				/* 2D text version of left title. */
	O3D_LYTITLE_BOX,			/* Optional box behind LYTITLE. */
	O3D_RIGHTWALL1,				/* Front and back faces of graph's right wall. */
	O3D_RIGHTWALL2,				/* Left and right faces of graph's right wall. */
	O3D_RIGHTWALL3,				/* Top and bottom faces of graph's right wall. */
	O3D_RISERFACE1,				/* First face of a riser. */
	O3D_RISERFACE2,				/* Second face of a riser. */
	O3D_RISERFACE3,				/* Third face of a riser. */
	O3D_RISERFACE4,				/* Fourth face of a riser. */
	O3D_RISERFACE5,				/* Fifth face of a riser. */
	O3D_RISERFACE6,				/* Sixth face of a riser. */
	O3D_RISERFACE7,				/* Seventh face of a riser. */
	O3D_RISERFACE8,				/* Eigth face of a riser. */
	O3D_RISERFACE9,				/* Ninth face of a riser. */
	O3D_RISERGRID_X,			/* Tickline along x axis on risers.*/
	O3D_RISERGRID_Y,			/* Tickline along y axis on risers.*/
	O3D_RISERGRID_Z,			/* Tickline along z axis on risers.*/
	O3D_ROWHEADER,				/* Text associated with a data series (row). */
	O3D_ROWHEADER_2D,			/* 2D text version of row header. */
	O3D_ROWHEADER_BOX,			/* Optional box behind ROWHEADER. */
	O3D_ROWTITLE,				/* Title associated with all data series. */
	O3D_ROWTITLE_2D,			/* 2D text version of row title. */
	O3D_ROWTITLE_BOX,			/* Optional box behind ROWTITLE. */
	O3D_RYHEADER,				/* Text associated with right vertical axis (Y2). */
	O3D_RYHEADER_2D,			/* 2D text version of right header. */
	O3D_RYHEADER_BOX,			/* Optional box behind RYTITLE. */
	O3D_RYTITLE,				/* Title for right vertical axis. */
	O3D_RYTITLE_2D,				/* 2D text version of right title. */
	O3D_RYTITLE_BOX,			/* Optional box behind RYTITLE. */
	O3D_SCATTERLINE,			/* Line connecting scatter markers. */
	O3D_TIELINE_XX,				/* Line connecting markers to the left wall. */
	O3D_TIELINE_YY,				/* Line connecting markers to the floor. */
	O3D_TIELINE_ZZ,				/* Line connecting markers to the right wall. */

	MAX_3D_OBJCLASS
} ObjClass3D;

#if (MAX_3D_OBJCLASS > O3D_RANGE_END)
	#error c3d_defs.h: (MAX_3D_OBJCLASS > O3D_RANGE_END)
#endif


/*****************************************************************************/
/*																			 */
/*    Keep this table in sync with the ones in C3D_ATTR.C and G3D_TAB.H      */
/*																			 */
/*****************************************************************************/
typedef enum 
	{
	A3D_AUTOFIT = A3D_RANGE_BEGIN,	/* Scale 3D graph to fit window. */
	A3D_AUTOFIT_DATALABELS,		/* For autoscaling 3D Scatter marker labels. */
	A3D_AUTOFIT_LEGEND,			/* For autoscaling Legend text. */
	A3D_AUTOFIT_TEXT,			/* For autoscaling 2D text. */
	A3D_AUTOSHADE_CUBE,			/* Set autoshade mode for the cube. */
	A3D_AUTOSHADE_RISERS,		/* Set autoshade mode for the risers. */
	A3D_AXIS_DIVS_X,  			/* Division along x axis (scatter only.) */
	A3D_AXIS_DIVS_Y,  			/* Division along y axis (all graphs). */
	A3D_AXIS_DIVS_Z,  			/* Division along z axis (scatter only). */
	A3D_CUSTOMVIEW,				/* Access to rotation, movement, etc.. */
	A3D_DATAFORMAT,				/* Data format specifier. */
	A3D_FIXED_2D_TEXT,			/* Make 2D text headers all same size. */
	A3D_FONTBOX,				/* Will we display the box behind text? */
	A3D_FONTMARGIN,				/* Margin around text label. */
	A3D_FONTOFFSET,				/* Offset of text header label from axis. */
	A3D_FONTSIZE,				/* Relative size of text. */
	A3D_FONTWIDTH,				/* Relative width of text. */
	A3D_FORMAT_X,				/* Set number format for X axis scale text. */
	A3D_FORMAT_Y,				/* Set number format for Y axis scale text. */
	A3D_FORMAT_Z,				/* Set number format for Z axis scale text. */
	A3D_GRAPH_BY_WHAT,			/* 0-major graph type, 1-type by series, 2-by group */
	A3D_GRID_FLOOR,				/* Display of gridlines on floor. */
	A3D_GRID_LWALL,				/* Display of gridlines on left wall. */
	A3D_GRID_RISER,				/* Grid/ticklines on risers. */
	A3D_GRID_RWALL,				/* Display of gridlines on right wall. */
	A3D_IGNORE_SERIES,			/* Struct contains series, boolean (whether to ignore).*/
	A3D_INSET_LGND_ICON,		/* Inset box of legend icon. */
	A3D_INSET_LGND_TEXT,		/* Inset box of legend text. */
	A3D_JUSTIFY,				/* 3D text justification parameter. */
	A3D_LOCATE_COLTITLE_2D,		/* User-specified location for O3D_COLTITLE_2D */
	A3D_LOCATE_LEGEND,			/* Legend location. */
	A3D_LOCATE_LYTITLE_2D,		/* User-specified location for O3D_LYTITLE_2D */
	A3D_LOCATE_ROWTITLE_2D,		/* User-specified location for O3D_ROWTITLE_2D */
	A3D_LOCATE_RYTITLE_2D,		/* User-specified location for O3D_RYTITLE_2D */
	A3D_MARKER_SHAPE,			/* Shape of a 3D scatter marker. */
	A3D_MARKER_SHAPE_DEFAULT,	/* Default shape of a 3D scatter marker. */
	A3D_MARKER_SIZE,			/* Size of a 3D scatter marker. */
	A3D_PICT_QUALITY,			/* Image sfx'ed polys in 2D or use raytracing? */
	A3D_RISERTHICK,				/* Relative width/depth of riser in percent. */
	A3D_SCALEBASE,				/* Graph negative values from base or from zero? */
	A3D_SCALEEND_X,				/* Show the Min and max values?. */
	A3D_SCALEEND_Y,				/* Show the Min and max values?. */
	A3D_SCALEEND_Z,				/* Show the Min and max values?. */
	A3D_SCALEFREQ_X,			/* Skip factor for scale labels. */
	A3D_SCALEFREQ_Y,			/* Skip factor for scale labels. */
	A3D_SCALEFREQ_Z,			/* Skip factor for scale labels. */
	A3D_SCALERANGE_X,			/* Min and max values at ends of scale. */
	A3D_SCALERANGE_Y,			/* Min and max values at ends of scale. */
	A3D_SCALERANGE_Z,			/* Min and max values at ends of scale. */
	A3D_SCALETYPE_X,			/* Linear or log. */
	A3D_SCALETYPE_Y,			/* Linear or log. */
	A3D_SCALETYPE_Z,			/* Linear or log. */
	A3D_SCATTER_N,				/* Connect scatter marker to previous scatter marker. */
	A3D_SCATTER_X,				/* Connect scatter marker to left wall. */
	A3D_SCATTER_Y,				/* Connect scatter marker to floor. */
	A3D_SCATTER_Z,				/* Connect scatter marker to right wall. */
	A3D_SERIES_TYPE,			/* Select graph type for current series or group. */
	A3D_SHOWBOX_DATALABELS,		/* Show scatter point data labels? */
	A3D_SHOWOFFSCALE_X,			/* Show X values clipped that are out of range? */
	A3D_SHOWOFFSCALE_Y,			/* Show Y values clipped that are out of range? */
	A3D_SHOWOFFSCALE_Z,			/* Show Z values clipped that are out of range? */
	A3D_SHOWTEXT_ALL,			/* Display all text. */
	A3D_SHOWTEXT_COLHEADERS,	/* Controls if column headers are displayed. */
	A3D_SHOWTEXT_COLTITLE,		/* Controls if column title are displayed. */
	A3D_SHOWTEXT_DATALABELS,	/* Controls if scatter point labels are displayed. */
	A3D_SHOWTEXT_LEFTNUMBERS,	/* Controls if left numbers are displayed. */
	A3D_SHOWTEXT_LEFTTITLE,		/* Controls if left title are displayed. */
	A3D_SHOWTEXT_RIGHTNUMBERS,	/* Controls if right numbers are displayed. */
	A3D_SHOWTEXT_RIGHTTITLE,	/* Controls if right title are displayed. */
	A3D_SHOWTEXT_ROWHEADERS,	/* Controls if row headers are displayed. */
	A3D_SHOWTEXT_ROWTITLE,		/* Controls if column headers are displayed. */
	A3D_SHOW_FLOOR,				/* Controls display of graph cube's floor. */
	A3D_SHOW_LEGEND,			/* Controls display of Legend (scatters only). */
	A3D_SHOW_LWALL,				/* Controls display of graph cube's left wall. */
	A3D_SHOW_RWALL,				/* Controls display of graph cube's right wall. */
	A3D_SQUARE_LGND_ICONS,		/* Force Legend markers to be square. */
	A3D_SYMBOL_FORSERIES,		/* Specify an alpha symbol to represent series */
	A3D_TEXT_POSITION,			/* Position text on graph cube or next to it. */
	A3D_TEXT_QUALITY,			/* Draft/proof. */
	A3D_UNIFORM_QDRSHAPES,		/* If TRUE, all scatter markers are same shape */
	A3D_VIEWANGLES,				/* Dispatches to Lightspeed's version of custom angles. */
	A3D_VIEWSTRUCT,				/* Redefine entire viewing scene. */

	MAX_3D_ATTRIBUTE
	}
	Attributes3D;


/************************************************************************
* from CAN_DEFS.H
************************************************************************/

typedef enum ANAType
	{
	AAN_ARC_INFO = AAN_RANGE_BEGIN,
	AAN_LINEARROWHEADS, 	/*  arrowheads on the ends of lines */
	AAN_ARW_ANGLE,			/* 	angle of arrow head																*/
	AAN_ARW_HDIND,			/* 	Indent from tip of arrow head for shaft attachment*/
	AAN_ARW_HDWID,			/* 	Width of shaft at head of arrow										*/
	AAN_ARW_PRESET,			/*	Preset arrow type																	*/
	AAN_ARW_SIDES,			/* 	length of sides of arrow head											*/
	AAN_ARW_TLIND,			/* 	Indent from tail of arrow for "feathering"				*/
	AAN_ARW_TLWID,			/* 	Width of shaft at tail of arrow										*/
	AAN_BOUNDS,					/*   annotation object's bounds					*/
	AAN_BOXTYPE_BALLOON,/*		-	Balloon Text																	*/
	AAN_BOXTYPE_BCHART,	/*		-	Bullet Chart Text															*/
	AAN_BOXTYPE_BOX,		/*		-	Regular Boxed Text														*/
	AAN_BOXTYPE_DBLTBOX,/*		-	Double Edged Text Box													*/
	AAN_BOXTYPE_NOBOX,	/*		-	Text with no bounding box											*/
	AAN_BOXTYPE_THREEDTBOX,/*	-	3D Effect Text Box														*/
	AAN_BULLET_SHP,			/*	Shape of bullet in bullet chart										*/
	AAN_BULLET_SIZE,		/*	Size of bullet in bullet chart										*/
	AAN_BULLET_SPACING,
	AAN_ENDPOINTS,
	AAN_LINE_END_P0,
	AAN_LINE_END_P1,
	AAN_RECT_ROUNDNESS,	/*  rectangle's roundness factor											*/
	AAN_RROUNDNESS_NONE,/*  rectangle's roundness preset											*/
	AAN_RROUNDNESS_25,	/*  rectangle's roundness preset											*/
	AAN_RROUNDNESS_50,	/*  rectangle's roundness preset											*/
	AAN_RROUNDNESS_75,	/*  rectangle's roundness preset											*/
	AAN_RROUNDNESS_100,	/*  rectangle's roundness preset											*/
	AAN_TBOX_EDITBOUNDS,
	AAN_TBOX_MARGINS,
	AAN_TBOX_TYPE,			/*	Type of text box for object:											*/
	AAN_TEXT,						/*  annotation object's text													*/
	AAN_THICKNESS,			/*	Text box thickness																*/
	
	MAX_ANA_ATTRIBUTE
} ANAType;

#if (MAX_ANA_ATTRIBUTE > AAN_RANGE_END)
	#error can_defs.h: (MAX_ANA_ATTRIBUTE > AAN_RANGE_END)
#endif


typedef enum ObjClassAna
	{
	OAN_ARC = OAN_RANGE_BEGIN,		/* Arc annotation object										*/
	OAN_ARROW,										/* Arrow object															*/
	OAN_BALLOON,									/* Balloon object														*/
	OAN_BALLOONPARA,							/* Balloon paragraph												*/
	OAN_DBLTBOXIN,								/* Inside Double Text Box object						*/
	OAN_DBLTBOXOUT,								/* Outside Double Text Box object						*/
	OAN_ELLIPSE,									/* Annotation object.												*/
	OAN_FREEHAND,									/* Arrow object															*/
	OAN_GROUP,										/* "Group" object													  */
	OAN_LINE,											/* Annotation object.												*/
	OAN_POLYGON,									/* Annotation object.												*/
	OAN_POLYLINE,									/* Annotation object.												*/
	OAN_RECTANGLE,								/* Annotation object.												*/
	OAN_ROUNDRECT,								/* Annotation object.												*/
	OAN_TBOXPARA,									/* Text Box paragraph												*/
	OAN_TCHARTBULLET,							/* Text Chart bullet												*/
	OAN_TCHARTPARA,								/* Text Chart paragraph											*/
	OAN_TEXT,											/* Annotation object.												*/
	OAN_TEXTBOX,									/* Text Box object													*/
	OAN_TEXTCHART,								/* Text Chart object												*/
	OAN_THREEDTBOXFACE,						/* Face Of 3D Text Box object								*/
	OAN_THREEDTBOXSIDES,					/* Sides Of 3D Text Box object							*/
	OAN_WEDGE,										/* Annotation object.												*/
	
	MAX_ANA_OBJCLASS
} ObjClassAna;

#if (MAX_ANA_OBJCLASS > OAN_RANGE_END)
	#error can_defs.h: (MAX_ANA_OBJCLASS > OAN_RANGE_END)
#endif


/************************************************************************
* from CTX_DEFS.H
************************************************************************/

typedef enum 
	{
	OTX_BOX_TITLE=OTX_RANGE_BEGIN,/* Each element of the text chart has a box.*/
	OTX_BOX_SUBTITLE,							/* Box for text chart's subtitle.           */
	OTX_BOX_FOOTNOTE,							/* Box for text chart's footnote.           */
	OTX_BOX_COLUMN1,							/* Box for text chart's first column.       */
	OTX_BOX_COLUMN2,							/* Box for text chart's second column.      */
	OTX_BOX_COLUMN3,							/* Box for text chart's third column.       */
	OTX_BOX_COLUMN4,							/* Box for text chart's fourth column.      */
	OTX_BOX_FLOATER1,							/* Box for text chart's first floater.      */
	OTX_BOX_FLOATER2,							/* Box for text chart's second floater.     */
	OTX_BOX_FLOATER3,							/* Box for text chart's third floater.      */
	OTX_BOX_FLOATER4,							/* Box for text chart's fourth floater.     */
	OTX_BOX_ANNOTATION,						/* Box for a text annotation object.        */
	OTX_BULLET,										/* Optional bullet for text paragraph.      */
	OTX_FRAME,										/* The text chart lives in this frame.			*/

	MAX_TEXT_OBJCLASS
	} 
	ObjClassText;

#if (MAX_TEXT_OBJCLASS > OTX_RANGE_END)
	#error ctx_defs.h: (MAX_TEXT_OBJCLASS > OTX_RANGE_END)
#endif


/****************************************************************************/
/*																			 																		*/
/*    Keep this table in sync with the one in GTX_TAB.H !!!                 */
/*																			 																		*/
/****************************************************************************/
typedef enum 
	{
	/*
	 * Set/Get Attributes
	 */
	ATX_BORDER_STYLE = ATX_RANGE_BEGIN,	/* Boxes are adorned with various borders.	*/
	ATX_BOX_ID,		  							/* ID specifies title, subtitle, etc.       */
	ATX_BOX_LOCATION,							/* Location of box = lower left corner.			*/
	ATX_BOX_ROUNDNESS,						/* Roundness of box corner.									*/
	ATX_BOX_SHOW,									/* Box display.															*/
	ATX_BOX_SIZE,									/* Box size.																*/
	ATX_BOX_STYLE,	 							/* Our boxes come in various shapes & colors*/
	ATX_BULLET_SHOW,							/* Shall this box be adorned with bullets?  */
	ATX_BULLET_SHAPE,							/* Which marker do we use as a bullet?      */
	ATX_BULLET_SIZE,							/* Size of the bullet in virt. coordinates. */
	ATX_BULLET_SPACING,						/* Dist. of bullet center & left text edge. */
	ATX_CHAR_SPACING, 						/* Space between characters can be adjusted.*/
	ATX_LINE_SPACING,							/* Variable line spacing.                   */
	ATX_LOCATE_BOX,  							/* Analogous to AXX_LOCATE_X functions.			*/
	ATX_PARA_SPACING,							/* Variable paragraph spacing.              */
	ATX_TEXT_AUTOFIT,  						/* Toggle for automatic text-to-box sizing.	*/
	ATX_TEXT_EDIT,								/* Edit text that appears inside box.       */
	ATX_TEXT_ID,		  						/* ID specifies title, subtitle, etc.       */
	ATX_TEXT_JUST_H,  						/* Horizontal justif. for text block in box.*/
	ATX_TEXT_JUST_V,  						/* Vertical justific. for text block in box.*/
	ATX_TEXT_MARGIN,  						/* Margins for text block in box (all sides)*/

	/*
	 * Function attributes
	 */
	FTX_BOX_DELETE,								/* Permanently delete box.									 */
	FTX_BOX_NEW,									/* Create a new text box from scratch.			 */
	FTX_FIT_BOX_TO_TEXT,					/* Scale contents of text box to fit.				 */
	FTX_FIT_TEXT_TO_BOX,					/* Fit box around text.                  		 */

	MAX_TEXT_ATTRIBUTE
	}
	AttributesText;


/************************************************************************
* from CRO_ATTR.H
************************************************************************/

/*
 *  Graph Preset Type Info
 */
typedef struct {
	INT16			nMajorType;
	INT16			nMinorType;
} TDG_GraphPresetInfo, FAR *TDG_GraphPresetPtr;

typedef struct {
	INT16			nSeriesID;
	RGB16			rgb;
} TDG_SeriesColorInfo, FAR *TDG_SeriesColorPtr;


/************************************************************************
* from COM_ATTR.H
************************************************************************/

INT16 PUBLIC				GetGraphAttrSL			(	GraphPtr	 			pGraph, 
																					SelListPtr			pSelList,
																					INT16						attrCode,
																					void FAR *			pData     );

INT16 PUBLIC				SetGraphAttrSL			(	GraphPtr				pGraph,
																					SelListPtr			pSelList,
																					INT16						attrCode,
																					void FAR * 			pData			);

INT16 PUBLIC				GetGraphAttrSI			(	GraphPtr	 			pGraph, 
																					SelItemPtr			pItem,
																					INT16						attrCode,
																					void FAR *			pData     );

INT16 PUBLIC				SetGraphAttrSI			(	GraphPtr				pGraph,
																					SelItemPtr			pItem,
																					INT16						attrCode,
																					void FAR * 			pData			);

INT16 PUBLIC				ExecGraphFuncSL			(	DrawEnvPtr			pDE,
																					GraphPtr				pGraph,
																					SelListPtr			pSelList,
																					INT16						attrCode,
																					void FAR * 			pData			);
                 
INT16 PUBLIC				GetGraphAttr				(	GraphPtr				pGraph,
																					INT16						nLayerID,
																					INT16						nObjectID,
																					INT16						nSeriesID,
																					INT16						nGroupID,
																					INT16						attrCode,
																					void FAR *			pData			);

INT16 PUBLIC				SetGraphAttr				(	GraphPtr				pGraph,
																					INT16						nLayerID,
																					INT16						nObjectID,
																					INT16						nSeriesID,
																					INT16						nGroupID,
																					INT16						attrCode,
																					void FAR *			pData			);

INT16 PUBLIC				ExecGraphFunc				(	DrawEnvPtr			pDE,
																					GraphPtr				pGraph,
																					INT16						nLayerID,
																					INT16						nObjectID,
																					INT16						nSeriesID,
																					INT16						nGroupID,
																					INT16						attrCode,
																					void FAR *			pData			);


INT16 PUBLIC				GetDetNodeAttr			(	GraphPtr				pGraph,
																					INT16						nLayerID,
																					DetNodeRefPtr		pDetRef,
																					INT16						attrCode,
																					void FAR *			pData			);

INT16 PUBLIC				SetDetNodeAttr			(	GraphPtr				pGraph,
																					INT16						nLayerID,
																					DetNodeRefPtr		pDetRef,
																					INT16						attrCode,
																					void FAR *			pData			);

INT16 PUBLIC				ExecDetNodeFunc			(	GraphPtr				pGraph,
																					INT16						nLayerID,
																					DetNodeRefPtr		pDetRef,
																					INT16						attrCode,
																					void FAR *			pData			);

INT16 PUBLIC 				AttrCode2EngineClass	(	INT16 nAttr			);
INT16 PUBLIC				Object2EngineClass		(	INT16 nObjID		);

INT16 PUBLIC
GetObjectMobility(
	GraphPtr		pGraph,
	INT16 			objID 								
);


INT16 PUBLIC
SetBoundsCommon(
	GraphPtr				pGraph,
	INT16 					attrCode,
	BoxInstPtr			pNewBounds
);


/************************************************************************
* from STD_FMT.H
************************************************************************/

/************************************************************************
* from C2D_ATTR.H
************************************************************************/

/************************************************************************
*  GridLines Structure
************************************************************************/
typedef struct _TDG_GridLines {
	BOOLEAN16 				bIsLog; 							/* log flag 							*/
	BOOLEAN16 				bMajorHashManual; 		/* major hash manual flag */
	BOOLEAN16 				bMinorHashManual; 		/* minor hash manual flag */
	INT16 					nMajorHashStyle;			/* major hash style 			*/
	INT16 					nMinorHashStyle;			/* minor hash style 			*/
	INT16 					nMajorHashCount;			/* major hash count 			*/
	INT16 					nMinorHashCount;			/* minor hash count 			*/
} TDG_GridLinesInfo, FAR * TDG_GridLinesPtr;


/************************************************************************
*  GridLines Structure
************************************************************************/
typedef struct _TDG_GridLinesOrd {
	INT16 					nMajorHashStyle;			/* major hash style 			*/
	INT16 					nMinorHashStyle;			/* minor hash style 			*/
	INT16 					nMinorHashCount;			/* minor hash count 			*/
	/* TL:11/17/92 added super hash lines for every nSuperHashCount major grid lines */
	INT16						nSuperHashStyle;			/* super hash style				*/
	INT16						nSuperHashCount;			/* super hash every major hash count */
} TDG_GridLinesOrdInfo, FAR * TDG_GridLinesOrdPtr;

/************************************************************************
* Scale Values Structure
************************************************************************/
typedef struct _TDG_ScaleValues {
	INT16						nManualScale; 				/*	0-auto,
																						1-manual,
																						2-manual minimum, auto maximum,
																						3-auto minimum, manual maximum */
	REAL						fManualScaleMax;			/* Manual scale maximum. */
	REAL						fManualScaleMin;			/* Manual scale minimum. */
} TDG_ScaleValuesInfo, FAR * TDG_ScaleValuesPtr;


/************************************************************************
* Histogram Buckets Structure
************************************************************************/
typedef struct _TDG_HistogramBuckets {
	BOOLEAN16 				bManual;							/* manual flag				*/
	INT16 					nBuckets; 						/* number of buckets	*/
} TDG_HistogramBucketsInfo, FAR * TDG_HistogramBucketsPtr;


/************************************************************************
* Table Divisions Structure
************************************************************************/
typedef struct _TDG_TableDivs {
	INT16 					StripeStyle;					/* None, vertical or horiziontal stripes. */
	INT16 					nLineSkip;						/* Stripes skipped between lines. */
	INT16 					nColorSkip; 					/* Row or columns per color. */
	INT16 					nActiveStripes; 			/* Color count. */
	BOOLEAN16 				bExtendedStripes; 		/* Stripes extended into header region? */
} TDG_TableDivsInfo, FAR * TDG_TableDivsPtr;

/************************************************************************
* SplitY Non-Detection Node Specific Structure
************************************************************************/
typedef struct _TDG_GroupSplitYND {
	INT16	nGroupID;
	BOOLEAN16	bSplitY;
} TDG_GroupSplitYNDInfo, FAR * TDG_GroupSplitYNDPtr;

/************************************************************************
* Series Dependant INT16 Non-Detection Node Specific Structure
************************************************************************/
typedef struct _TDG_SerDepINT16 {
	INT16	nSeriesID;
	INT16	nValue;
} TDG_SerDepINT16, FAR * TDG_SerDepINT16Ptr;

/************************************************************************
* Series Dependant BOOLEAN16 Non-Detection Node Specific Structure
************************************************************************/
typedef struct _TDG_SerDepBOOLEAN16 {
	INT16	nSeriesID;
	BOOLEAN16	bValue;
} TDG_SerDepBOOLEAN16, FAR * TDG_SerDepBOOLEAN16Ptr;

/************************************************************************
* Table Stripe Dependant BOOLEAN16 Non-Detection Node Specific Structure
************************************************************************/
typedef struct _TDG_StripeDepBOOLEAN16 {
	INT16		nStripeID;
	BOOLEAN16	bValue;
} TDG_StripeDepBOOLEAN16, FAR * TDG_StripeDepBOOLEAN16Ptr;

#define SERCON_USESELLIST	-10
#define SERCON_DOALL			-11


/************************************************************************
* from COM_ERRS.H
************************************************************************/

/************************************************************************
*  Base Values for All Error Messages
************************************************************************/
#define E00_BASE	0x0000								/* Common errors */
#define ELS_BASE  0x0100								/* LoadSave errors */
#define E2D_BASE	0x0200								/* 2D engine errors */
#define E3D_BASE  0x0300								/* 3D engine errors */
#define EPI_BASE  0x0400								/* Pie engine errors */
#define EAN_BASE  0x0500								/* Annotation engine errors */
#define EAC_BASE  0x0600								/* Std Access errors */
#define EDR_BASE  0x0700								/* Std Draw errors */
#define EFX_BASE  0x0800								/* SFX errors */
#define ETX_BASE  0x0900								/* Text Chart engine errors */
#define ETF_BASE	0x0A00								/* Tiff/3DF file errors */
#define ETDI_BASE	0x0B00								/* TypeDef Imaging errors. */


/************************************************************************
* Error Classes:
*		STATUS		- not an error, return of status
*		WARNING		- recoverable error, no user intervention
*		CONFIRM		- recoverable error, needs user yay or nay
*		SPECIAL		- recoverable error, needs user to make a multiple-choice
*		FATAL			- oh well...
************************************************************************/
typedef enum {
	ERRCLASS_STATUS,
	ERRCLASS_WARNING,
	ERRCLASS_FATAL,
	ERRCLASS_CONFIRM,
	ERRCLASS_SPECIAL
} ERROR_CLASSES;


/************************************************************************
* System-Wide Error Codes
************************************************************************/
typedef enum {
	E00_OK,											/* STATUS: Indicates successful function return result */
	
	E00_DISK_FULL,							/* WARNING: insufficient disk space */
	E00_FATAL_ERROR,						/* FATAL: Internal error */
	E00_FILE_CLOSE_ERROR,				/* WARNING: file close error */
	E00_FILE_NOT_FOUND,					/* WARNING: file not found */
	E00_FILE_READ_ERROR,				/* WARNING: file read error */
	E00_FILE_SEEK_ERROR,				/* WARNING: file seek error */
	E00_INVALID_NULL_ARG,				/* WARNING: NULL arg not valid here */
	E00_MEM_ERROR,							/* WARNING: out of memory */
	E00_NOT_IMPLEMENTED,				/* WARNING: Function not implemented */
	E00_RANGE_ERROR,						/* WARNING: Out of range error. */
	E00_USER_BREAK,							/* STATUS: User interrupted function by pressing escape */
	E00_USER_CANCEL,						/* STATUS: User canceled from dialog */
	
	E00_SINGLE_SERIES,					/* WARNING: Multiple series required. */
	E00_SINGLE_GROUP,						/* WARNING: Multiple groups required. */
	E00_NOT_SPLITY_DATA,				/* WARNING: Nothing assigned to Split Y axis, assigning half arbitrarily. */
	E00_NO_DATA,								/* WARNING: No data found. */
	E00_SERIESID_ERROR,					/* STATUS: Illegal series address reference. */
	E00_INVALID_STRUCT_SIZE,		/* ERROR: Passed structure wrong size. */
	E00_DOMAIN_ERROR,						/* ERROR: Illegal value. */
	E00_DDE_INIT,								/* DDE initialization failure. */
	E00_FILE_WRITE_ERROR,

	E00_MAX_ERROR
} E00_ERROR_CODES;

#define ReportError(p,id,class,lData) xReportError(p,id,class,lData,__FILE__,__LINE__)

INT32 PUBLIC
xReportError(
	void FAR			 *pContext,			/* Error context information (pGraph, pDE, etc.) */
	INT16						nErrorID,			/* Error code (Exx_yyyy) */
	INT16						nErrorClass,	/* Error class. */
	INT32						lData,				/* add'l info such as filename, etc. */
	char FAR *			pFile,				/* offending filename */
	INT16						nLine					/* offending line number */
);


typedef
INT16 (
*LPFNErrorCallBack) (
	void FAR			 *pContext,			/* Error context information (pGraph, pDE, etc.) */
	INT16						nErrorID,			/* Error code (Exx_yyyy) */
	INT16						nErrorClass,	/* Error class. */
	INT32						lData,				/* add'l info such as filename, etc. */
	char FAR *			pFile,				/* offending filename */
	INT16						nLine					/* offending line number */
);


INT16 PUBLIC
SetErrorCallBack(
	LPFNErrorCallBack	lpfnErrorCB
);


/************************************************************************
* from C2D_ERRS.H
************************************************************************/

typedef enum {
	E2D_GEN_ERROR = E2D_BASE,

	E2D_MEMERR,					/* WARNING: Meory allocation problem. */
	E2D_ERRBSTACKED,			/* WARNING: Error bars not supported by stacked chart types. */
	E2D_LEGENDCOLOR,			/* CONFIRM: Legend box not applicable to group colored area chart. */
	E2D_PERCENTLOG,			/* WARNING: Logarithmic scale not applicable to percent chart. */
	E2D_NEGLOG,					/* WARNING: Negative values not possible on logarithmic scale. */
	E2D_ZEROLOG,				/* WARNING: Zero value requires infinite range with logarithmic scale. */
	E2D_CONTOURBSPL,			/* WARNING:	Less than two number of vertices on BSplines. */
	E2D_CONTOURLOG,			/* WARNING:	Zero or negative values require infinite range with logarithmic scale. */
	E2D_CONTOURSTEP,			/* WARNING:	Zero or negative intervals are not applicable. */
	E2D_CONTOURLEVELS,		/* WARNING:	Zero or negative number of Contour Levels are not applicable. */
	E2D_CONTOURSURFACE,		/* WARNING:	Zero or negative number of Contour Surfaces are not applicable. */
	E2D_CONTOURPOINTS,		/* WARNING:	Negative number of Contour Points are not applicable. */
	ETC_DC_OVERFLOW,			/* Current table chart overflows DC - set to all autofit. */
	E2D_MAX_ERRORS

} E2D_ERROR_CODES;


/************************************************************************
* from C3D_ERRS.H
************************************************************************/

typedef enum {

/************************** I N T E R N A L   E R R O R S *******************/
	E3D_CODE_NUMTOPOLINES = E3D_BASE,	
															/* WARNING:
																 More topo lines (grids, contours...) were
																 generated than predicted. This error is a
																 sign of a corrupted .3D3 file and "should"
																 never occur in real life.
															 */
	E3D_CODE_ODDTOPOPOINTS,			/* WARNING:
																 This error indicates an internal program
																 bug - helpful during development, but, like
																 the error above, "should" never occur.
															 */
	E3D_CODE_BADCOLORMAP,				/* FATAL:
																 Invalid color mapping code (trapped when 
																 calculating area and line ID bins).			  */
	E3D_CODE_BADOBJID,					/* FATAL:
																 Invalid object ID, probably out of range.	*/


/***************** M A C - S P E C I F I C   E R R O R S ********************/
	E3D_MAC_GDEVICE,						/* WARNING:
																 A Mac-specific error indicating that the 
																 program was unable to obtain graph device
																 information from the O/S. This one's not
																 our fault.						 
															 */

/************* W I N D O W S - S P E C I F I C   E R R O R S ****************/
	E3D_WIN_COLORTABLE,					/* WARNING:
																 WINDOWS didn't let us allocate a color table
															   probably due to memory shortage.						*/
	E3D_WIN_PIPPIX,  						/* WARNING:
																 WINDOWS didn't let us allocate an offscreen
																 picture handle.														*/

/************************** M E M O R Y  E R R O R S ************************/
	E3D_MEM_3DSTRINGALLOC,			/* WARNING:
																 Unable to allocate memory for a text string.
																 Usual reason is lack of memory, as is the 
																 case for all the _MEM_ error codes below.
															 */
															/* WARNING:
																 Unable to allocate mem for...							*/
	E3D_MEM_AUTOFIT,						/* ... autofit struct. 											  */
	E3D_MEM_FRAME,							/* ... graph frame info structure.						*/
	E3D_MEM_LABELINFO,					/* ... array of header strings.								*/
	E3D_MEM_LINEALLOC,					/* ... buffer for grid-, topo- etc. lines.		*/
	E3D_MEM_MATRIXSORT,					/* ... struct for sorting cells in matrix-type
																 graphs (ordinal x & z axes) = non-scatters.*/
	E3D_MEM_NEWPOLY,						/* ... copy of polygon for clipping purposes.	*/
	E3D_MEM_OBJECT,							/* ... 3D object definition structure.				*/
	E3D_MEM_PIXELBATCH,					/* ... pixel buffer for 3D raytracing.				*/
	E3D_MEM_RAYSTRUCT,					/* ... info struct for 3D raytracing.					*/
	E3D_MEM_SCATTERCLOUDS,			/* ... list of data point location in scatter
																 graphs (used to improve rotation speed).		*/
	E3D_MEM_SCATTERSORT,				/* ... struct for sorting marker points by
																 distance from viewer in scatter graphs.		*/
	E3D_MEM_SINTABLE,						/* ... table of 90 precalc'ed sine values.		*/
	E3D_MEM_STROKESTRINGALLOC,	/* ... table of strings for ATM type text.		*/
	E3D_MEM_TOPOENDPOINTS,			/* ... list of endpoints of topo lines.				*/
	E3D_MEM_TOPOLINELIST,				/* ... list of topolines themselves.					*/
														  	 
/*************************** R A N G E  E R R O R S *************************/
															/* WARNING:
																 OUT-OF-RANGE error for...									*/
	E3D_RANGE_ATTR,							/* ... object attribute.											*/
	E3D_RANGE_GRAPHTYPE_1,			/* ... invalid graph type for matrix graphs.	*/
	E3D_RANGE_GRAPHTYPE_2,			/* ... reserved for invalid scatter type.			*/


/**************************** D A T A  E R R O R S **************************/
	E3D_DATA_SCATTERPOINT,			/* No or bad data for scatter point.      		*/


/******************* A L L - P U R P O S E  E R R O R ***********************/
	E3D_GEN_ERROR,							/* FIXME FIXME 07dec90/ksk 
																 YOU fix me, Keith! What does this mean? 
															 */
	
	E3D_MAX_ERRORS

}	E3D_ErrorCodes;



/************************************************************************
* from CAC_ERRS.H
************************************************************************/

typedef enum {
	EAC_FIRST = EAC_BASE,

	EAC_INVALIDSERIES,	 	/* FATAL: Series address out of range. */
	EAC_INVALIDGROUPS,	 	/* FATAL: Group address out of range. */
	EAC_INVALIDENTRY,		 	/* FATAL: Entry address out of range. */
	EAC_BUFFEROVERFLOW,		/* FATAL: Insuffient space in buffer. */
	EAC_UNKNOWNCHART,			/* FATAL: Chart type not found in data structures. */
	EAC_NULLITEM,					/* STATUS: Attempt was made to query an empty item. */
	EAC_GETSTORAGE,				/* FATAL: Storage device was unable to retrieve data. */
	EAC_PUTSTORAGE,				/* FATAL: Storage device was unable to store data. */
	EAC_EMPTYRANGE,				/* FATAL: Operation failed due to lack of data. */
	EAC_NOTIMPLEMENTED,		/* FATAL: Function not implemented in this version. */
	EAC_INVALIDITEM,			/* FATAL: Item not valid in context used. */
	EAC_EMPTYDATAFORMAT,	/* FATAL: No data items active in node. */
	EAC_NULL_DATARANGE,		/* Data range undefined. */
	EAC_NO_DATA,					/* Insufficient data to form any risers. */
	EAC_TOOFEW_SERIES,		/* At least two series required for this graph. */
	EAC_TOOFEW_GROUPS,		/* At least two groups required for this graph. */
	EAC_NEG_LOG,
	EAC_ZERO_LOG,
	
	EAC_MAX_ERRORS

} EacErrorCodes;


/************************************************************************
* from CAN_ERRS.H
************************************************************************/

typedef enum {
	EAN_MEM_NEWANODE = EAN_BASE,	/* ALERT: Error creating anode. Probably Mem. */
	EAN_MEM_GROUP,						/* ALERT: Error grouping anodes. Probably Mem. */
	EAN_MEM_DUPLICATE,				/* ALERT: Error duplicating. Probably Mem. */

	EAN_SETTEXT,						/* ALERT: Invalid text handle encountered
												or out of mem. while setting text. */
	EAN_BADGRAPH,						/* FATAL: Invalid GraphPtr passed to engine */
	EAN_BADATTR,						/* ALERT: Attribute passed was not valid */
	EAN_BADANODE,						/* ALERT: An Invalid Annotation handle was passed */
	EAN_NOANODES,						/* ALERT: The selection list contained no 
												annotations to act upon. */
	EAN_NODETNODEFOUND,				/* ALERT: No DetNode was found for given Anode */

	EAN_NOLINKOBJECT,					/* ALERT: Hot-Link found no graph object
												to link to in the selection list  */
	EAN_DATAINVALID,					/* FATAL: Attr codes are menu info is invalid */
 	EAN_MAXERR							/* Last annotation error code... */
} EAN_ErrorCodes;


/************************************************************************
* from SDR_ERRS.H
************************************************************************/

typedef enum {
	EDR_INVALID_DETNODEREF = EDR_BASE,
	EDR_INVALID_DETNODEPTR,
	EDR_ITEM_NOT_FOUND,
	EDR_MISSING_SFX_FILE,
	EDR_NULL_AREAINST,
	EDR_NULL_FONTINST,
	EDR_NULL_LINEINST,
	EDR_CREATE,
	EDR_COMBINE,
	EDR_SELECT,

	EDR_MAX_ERRORS
} EDR_ERROR_CODES;


/************************************************************************
* from SFX_ERRS.H
************************************************************************/

typedef enum {
	EFX_MEM_NEWSFX = EFX_BASE,		/* WARNING: Error creating SFXHandle. Probably Mem. */

 	EFX_BAD_PICT,									/* WARNING: Error opening picture file */
 	EFX_BAD_PATH,									/* WARNING: TDGPATH not set to pict's path */
 	EFX_UNKNOWN_PICT,							/* WARNING: Unrecognized picture format */
 	EFX_BAD_EXTENTS,							/* WARNING: Metafile extents are zero'd */
 	EFX_NULL_SFX,									/* WARNING: A NULL SFXHandle was passed */
 	EFX_COLOR_RANGE,							/* WARNING: An out-of-range palette index was ref'd */

 	EFX_OPEN_PRESETS,							/* WARNING: Error opening preset file */
 	EFX_WRITE_PRESETS,						/* WARNING: Error writing preset file */
 	EFX_READ_PRESETS,							/* WARNING: Error reading preset file */
 	EFX_NO_PRESET,								/* WARNING: No preset by that name exists */

 	EFX_NOLAYERS,									/* WARNING: No layers were drawn in SFX */

 	EFX_MAXERR										/* Last SFX error code... */
} EFX_ErrorCodes;


/************************************************************************
* from ANODE.H
************************************************************************/
void PUBLIC				FreeAllAnodes(GraphPtr pGraph);

/************************************************************************
* from STD_SFX.H
************************************************************************/
void PUBLIC						MakeVirginSFXFile			(	void );

/************************************************************************
* from COM_RAMF.H
************************************************************************/

typedef struct _RamFile {
	MEMSIZE					bufSize;
	MEMSIZE					bufWritten;
	MEMHDL					hBuffer;
	UCHAR HUGE *		pBuffer;
	UCHAR HUGE *		pCurrent;
} RamFileRec, FAR * RamFilePtr;


RamFilePtr PUBLIC				AllocRamFile			(MEMSIZE initialSize);
void PUBLIC							FreeRamFile				(RamFilePtr pRamFile);

LPSTR PUBLIC  				GetRamFileName		(RamFilePtr pRamFile);
RamFilePtr PUBLIC				XlateRamFileName	(char FAR *pName);

LPSTR PUBLIC  				GetRamFileBuffer	(RamFilePtr pRamFile);
void PUBLIC							SetRamFileSize		(RamFilePtr pRamFile, UINT32 lBytes);

INT16 PUBLIC						RFgetc						(RamFilePtr pRamFile);
INT16 PUBLIC						RFwrite						(RamFilePtr pRamFile, char FAR *buf, MEMSIZE buflen);
void PUBLIC							RFrewind					(RamFilePtr pRamFile);
INT32 PUBLIC						RFseek						(RamFilePtr pRamFile, INT32 lBytes, INT16 nOrigin);


/************************************************************************
* from INITTDG.H
************************************************************************/
INT16 PUBLIC			InitTDGLIB		(void);
INT16 PUBLIC			FiniTDGLIB		(void);

/************************************************************************
* from COM_UNDO.H
************************************************************************/
void PUBLIC				ClearUndo(GraphPtr pGraph);

BOOLEAN16 PUBLIC		PerformUndo(DrawEnvPtr pDE, GraphPtr pGraph);

INT16 PUBLIC			GetUndoStatus(GraphPtr pGraph);
void PUBLIC				SetUndoStatus(GraphPtr pGraph, INT16 newValue);

/************************************************************************
* from C3D_WIRE.H
************************************************************************/

void 	PUBLIC	DrawWireframe	(DrawEnvPtr pDE, GraphPtr pGraph, INT16 nPixels);
BOOLEAN16 PUBLIC	CheckWireframe	(GraphPtr pGraph);
void PUBLIC		ClearWireframe	(GraphPtr pGraph);


/************************************************************************
* from COM_UPDT.H
************************************************************************/

typedef struct UpdateItemRec {
	struct UpdateItemRec FAR *	pNext;
	
	INT16 					nObjectID;						/* object ID */
	INT16 					nSeriesID;						/* series ID or -1 */
	INT16 					nGroupID; 						/* group	ID or -1 */
	
	Rect						rcBounds;

} UpdateItemRec, FAR * UpdateItemPtr;


UpdateItemPtr PUBLIC
Update_GetFirstItem(GraphPtr pGraph);

UpdateItemPtr PUBLIC
Update_GetNextItem(UpdateItemPtr pItem);

void PUBLIC
Update_GetInvalRect(	UpdateItemPtr 	pItem,
							Rect				*invalRect);

INT16 PUBLIC
Update_ClearList(GraphPtr pGraph);


/************************************************************************
* from CSL_TOOL.H
************************************************************************/

void PUBLIC
MoveSelectedItem(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelItemPtr			pSelItem,
	Rect				FAR *newBounds
);

INT16 PUBLIC
AlignSelList_Top(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16					alignToFirst
);

INT16 PUBLIC
AlignSelList_Bottom(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16					alignToFirst
);

INT16 PUBLIC
AlignSelList_Left(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16					alignToFirst
);

INT16 PUBLIC
AlignSelList_Right(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16					alignToFirst
);

INT16 PUBLIC
JoinToFirst(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList
);


INT16 PUBLIC
JoinHoriz(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16				stretchVert
);

INT16 PUBLIC
JoinVert(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16				stretchHoriz
); 

INT16 PUBLIC
MakeSameSize(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16				horiz,
	INT16				vert
);

INT16 PUBLIC
SizeToPicture(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList
);

INT16 PUBLIC
AlignInsideEdges(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16						alignH,
	INT16						alignV
);

INT16 PUBLIC
CenterOnPage(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16						centerH,
	INT16						centerV
);

INT16 PUBLIC
AlignSelList_Center(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16				horiz,
	INT16				vert
);

void PUBLIC
UndoSelListMove(
	DrawEnvPtr			pDE,
	GraphPtr				pGraph,
	SelListPtr			pSelList
);

INT16 PUBLIC
EncompassLineThickness(
	SelItemPtr			pItem,
	Rect						*bounds
);


/************************************************************************
* from CAN_TOOL.H
************************************************************************/

/***************************************************************************
*
* Placement codes for UnpackAndSelectAnodes
*
***************************************************************************/

typedef enum {
	UPC_SAME_PLACE,			 				/* Unpacks into same virtual location */
	UPC_OFFSET_XY,							/* Unpacks offset by 10 DEST pixels		*/
	UPC_CENTER,									/* Unpacks into center of current DEST*/

	MAX_PLACEMENT_CODE
} UnpackPlacementCodes;

/***************************************************************************
*
* Annotation Functions for Selection Lists
*
***************************************************************************/

int 		PUBLIC BringForward	(GraphPtr pGraph, SelListPtr pSelList);

int 		PUBLIC Bring2Front	(GraphPtr pGraph, SelListPtr pSelList);

int 		PUBLIC SendBackward	(GraphPtr pGraph, SelListPtr pSelList);

int 		PUBLIC Send2Back		(GraphPtr pGraph, SelListPtr pSelList);

int 		PUBLIC Remove			(		GraphPtr pGraph,
												SelListPtr pSelList, 
												BOOLEAN16 all					);

int			PUBLIC RemoveItem(GraphPtr pGraph, SelItemPtr pSelList);

/***************************************************************************
*
* Annotation Object Creation - Return much more useful AnodeID (02/95DW)
*
***************************************************************************/

INT16			 PUBLIC CreateAnode(
										GraphPtr			pGraph,
										INT16				aType,
										Rect FAR * 		bounds,
										MEMHDL			hText,
										PolyHandle		hPoly,
										WedgeInfoPtr 	pWedge,
										Point				startPt,
										Point				endPt);


/***************************************************************************
*
* Annotation Object and List Drawing
*
***************************************************************************/

INT16 	PUBLIC DrawAnAnode(
										DrawEnvPtr		pDE,
										GraphPtr			pGraph,
										INT16				anodeID);

INT16 	PUBLIC DrawAllAnodes(
										DrawEnvPtr		pDE,
										GraphPtr			pGraph);


/***************************************************************************
*
* ID Number, Z-Layer, and AnodeInfoHdl Conversion Tools
*
***************************************************************************/

INT16 			PUBLIC AnodeID2ZLayer	(GraphPtr pGraph, INT16 anodeID);

INT16 			PUBLIC ZLayer2AnodeID	(GraphPtr pGraph, INT16 zLayer);

INT16 			PUBLIC DetRef2AnodeID	(DetNodeRefPtr pDetRef);

void 				PUBLIC AnodeID2DetRef	(GraphPtr pGraph, INT16 anodeID, DetNodeRefPtr pDetRef);

INT16				PUBLIC AnodeHdl2ID		(AnodeInfoHdl hNode);

AnodeInfoHdl 	PUBLIC ID2AnodeHdl		(GraphPtr gPtr, INT16 anodeID);


/***************************************************************************
*
* General Annotation Tools
*
***************************************************************************/

INT16 	PUBLIC GetRectAnodeInfo(
										GraphPtr			pGraph,
										INT16				anodeID,
										Rect				*bounds);

void 		PUBLIC SetRectAnodeInfo(
										GraphPtr			pGraph,
										INT16				anodeID,
										Rect				*bounds);

BOOLEAN16 	PUBLIC IsAnode(DetNodePtr pDetNode);

INT16 		PUBLIC Duplicate(DrawEnvPtr pDE, GraphPtr pGraph, SelListPtr pSelList);

INT16 PUBLIC
SelectAnode_All(
	GraphPtr				pGraph,
	SelListPtr			pSelList
);

SelItemPtr PUBLIC
SelectAnode_AddItem(
	GraphPtr				pGraph,
	SelListPtr			pSelList,
	INT16						anodeID
);

INT16 PUBLIC
ChangeXanTextboxID(	
	GraphPtr	pGraph,
	INT16 		oldID, 
	INT16 		newID
);

INT16 PUBLIC
SetLineItemPoints(
	SelItemPtr			pItem,
	Point						p0,
	Point						p1,
	Rect						*bounds
);

#if WANT_SFX
INT16 PUBLIC
CreatePictureAnode(	GraphPtr pGraph, 
										DrawEnvPtr pDE, 
										INT16 x, 
										INT16 y, 
										char *szPictName, 
										INT32 hdl,
										INT16 xExt,
										INT16 yExt,
										Rect *bounds,
										INT16	*pResized);

#endif

AnodeInfoHdl PUBLIC
GetAnodeFromTextboxID(GraphPtr pGraph, INT16 nBox);
	

/************************************************************************
* from STD_ACSS.H
************************************************************************/

INT16	PUBLIC
GetRawLimits(
	GraphPtr		 	G,				 			/* Full graph pointer. */
	INT16					nAxisReq,				/* Axis requested (see DataAxisRef enum). */
	REAL64 FAR *	pfRawMin,				/* Raw axis minimum. */
	REAL64 FAR *	pfRawMax				/* Raw axis maximum. */
);

INT16 PUBLIC
GetSGCount(
	GraphPtr		 	G,				 			/* Environment pointer. */
	BOOLEAN16			 	bAbsolute,			/* Absolute number of series? */
	PINT16		 		pnSeries,				/* Set to number of series. */
	PINT16		 		pnGroups				/* Set to number of groups. */
);

INT16 PUBLIC
GetSeriesHeaderPos(
	GraphPtr 				G,								/* Environment pointer. */
	INT16	 					nSeriesAddress,		/* Series address. */
	PINT16					pnRow,						/* Set to SSI row address. */
	PINT16					pnCol							/* Set to SSI columnn address. */
);

INT16	PUBLIC
GetSeriesHeaderString(
	GraphPtr	G,				/* Full Graph pointer. */
	INT16			s,				/* Series header requested. */
	PCHAR			szBuffer	/* Must be at least MAXSTRLEN long. */
);

INT16	PUBLIC
GetGroupHeaderString(
	GraphPtr	G,				/* Full Graph pointer. */
	INT16			s,				/* Group header requested. */
	PCHAR			szBuffer	/* Must be at least MAXSTRLEN long. */
);

INT16 PUBLIC
GetGroupHeaderPos(
	GraphPtr 				G,								/* Environment pointer. */
	INT16		 				nGroupsAddress,		/* Group address. */
	PINT16					pnRow,						/* Set to SSI row address. */
	PINT16					pnCol							/* Set to SSI columnn address. */
);


INT16	PUBLIC
AccGraphDataStatus(
	GraphPtr	G						/* Graph whose data status is to be returned. */
);


/************************************************************************
* from C3D_ATTR.H
************************************************************************/


/************************************************************************
* TDG_GridLines3D - Common Attribute Gridline Values Structure
************************************************************************/
typedef struct {
	INT16				Axis;									/* x,y or z (0,1,2)	*/
	INT16				HashStyle;						/* <0:solid, 0:none, >0:ticks */
} TDG_GridLines3D, FAR * TDG_GridLines3DPtr;


/************************************************************************
* TDG_CustomView - Common Attribute Custom View Values Structure
************************************************************************/
typedef struct {
	INT16				FunctionCode;					/* 0..35 */
	INT16				StepSize;							/* 0..MAX_INT */
} TDG_CustomView, FAR * TDG_CustomViewPtr;


/************************************************************************
* TDG_AxisDivs- Common Attribute Axis Divisions Structure
************************************************************************/
typedef struct {
	BOOLEAN16			bManualMajorHash;			/* 0: FALSE */
	INT16				nMajorHash;						/* 1.. */
} TDG_AxisDivs, FAR * TDG_AxisDivsPtr;


/************************************************************************
* TDG_ViewStruct - Common Attribute Viewing Scene Values Structure
************************************************************************/
typedef struct {
	fMatrixType	ViewMatrix;						/* Transformation matrix.*/
	dPoint3D		ViewerPosition;				/* Viewer position in 3D.*/
	dPoint3D		GraphSize;						/* Graph cube size.*/
	dPoint3D		WallThickness;				/* Graph cube wall thicknesses.*/
	INT16				xPan;									/* Horizontal displacement.*/
	INT16				yPan;									/* Vertical displacement.*/
} TDG_ViewStruct, FAR * TDG_ViewStructPtr;


/************************************************************************
* TDG_RiserThick - Common Attribute Riser Thickness Values Structure
************************************************************************/
typedef struct {
	INT16				xThick;								/* 0..200 */
	INT16				yThick;								/* 0..200 */
	INT16				zThick;								/* 0..200 */
} TDG_RiserThick, FAR * TDG_RiserThickPtr;


/************************************************************************
* TDG_SeriesType - Common Attribute to change graph type for one series.
************************************************************************/
typedef struct {
	INT16				Series;								/* Actually "Series" or "Group" */
	INT16				GraphType;						/* Really "Graph" or "Marker" type */
} TDG_SeriesType, FAR * TDG_SeriesTypePtr;



/************************************************************************
* from CB2VDM.H
************************************************************************/
BOOLEAN16 PUBLIC SetGraphStrings(void FAR *pGraph);
BOOLEAN16 PUBLIC SetGraphLabels(void FAR *pGraph);
BOOLEAN16 PUBLIC SetGraphData(void FAR *pGraph);

BOOLEAN16 PUBLIC SetGraphTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphSubTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphFootNote(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphSeriesTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphGroupsTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphY1AxisTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphY2AxisTitle(void FAR *pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphSeriesLabel(void FAR *pGraph, INT16 nRow, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphGroupsLabel(void FAR *pGraph, INT16 nCol, char FAR *szValue);
BOOLEAN16 PUBLIC SetGraphRowColData(void FAR *pGraph, INT16 nRow, INT16 nCol, REAL64 rValue);

BOOLEAN16 PUBLIC GetGraphTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphSubTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphFootNote(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphSeriesTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphGroupsTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphY1AxisTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphY2AxisTitle(GraphPtr pGraph, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphSeriesLabel(GraphPtr pGraph, INT16 nRow, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphGroupsLabel(GraphPtr pGraph, INT16 nCol, char FAR *szValue);
BOOLEAN16 PUBLIC GetGraphRowColData(GraphPtr pGraph, INT16 nRow, INT16 nCol, REAL64 *prValue);


void PUBLIC GenerateDXF(DrawEnvPtr pDE, GraphPtr pGraph, char FAR *dxf_name);

/*******************************************************************************
* SetUndoMode
*
*	DESCRIPTION:	Sets the Undo Mode for this instance of the library
*					0 = No Undo information saved
*					1 = Last attribute change only saved (default)
*					2 = All attribute changes saved (create Undo Stack) 
*
*	RETURNS:		None
*
*******************************************************************************/

void PUBLIC SetUndoMode(INT16 nUndoMode);                                                 

/* FUNCTION TO FORCE CREATION OF INTERNAL RISER INFO MEMORY: For
   cases where you wish to modify a riser attribute BEFORE it is ever
   drawn on-screen */
INT16 PUBLIC
CreateRisers(
   GraphPtr    pGraph,
   INT16       nCount);

/* For SEND_DATA or DM method of data storage.  Get the current internal
   spreadsheet's range of cells to graph */

INT16 PUBLIC GetDataRange(
	GraphPtr pGraph,			/* graph pointer. */
   INT16    *prULC,        /* Start Row */  
   INT16    *pcULC,        /* Start Col */
   INT16    *prLRC,        /* Stop Row */
   INT16    *pcLRC         /* Stop Col */
);

/* For SEND_DATA or DM method of data storage.  Set the current internal
   spreadsheet's range of cells to graph.  Not needed in regular
   usage, but occassionally useful for viewing subsets of data stored
   inside the graph object. NOTE: SetGraphData() will reset these
   parameters */

INT16 PUBLIC
SetDataRange(
	GraphPtr pGraph,			/* graph pointer. */
   INT16    *prULC,        /* Start Row */  
   INT16    *pcULC,        /* Start Col */
   INT16    *prLRC,        /* Stop Row */
   INT16    *pcLRC         /* Stop Col */
);

/* For TABLECHARTS in SEND_DATA method, here's a way to set string values
   directly into the internal data matrix */

BOOLEAN16 PUBLIC
SetGraphRowColString(
	GraphPtr 	pGraph,		  			/* graph pointer */
	INT16			nRow,			  			/* series number for the data */
	INT16   	nCol,							/* groups number for the data */
	char FAR *lpValue						/* string pointer */
);

/* For TABLECHARTS in SEND_DATA method, here's a way to get string values
   directly from the internal data matrix */

BOOLEAN16 PUBLIC
GetGraphRowColString(
	GraphPtr 	pGraph,		  			/* graph pointer */
	INT16			nRow,			  			/* series number for the data */
	INT16   	nCol,							/* groups number for the data */
	char FAR *lpValue						/* string pointer */
);

/*
 Function to Set the Ascii-Text String of an existing Text-Annotation  
 RETURNS:	0 = SUCCESS, NON-ZERO = FAILURE
*/
INT16 PUBLIC
SetAnnotationText( 
	GraphPtr			pGraph,
	DrawEnvPtr			pDE,                	/* current draw env. */
	INT16						anodeID,								/* Which Annotation */
	char FAR *			psNewText               /* Ptr to New Text String */
);

/*
 Function to Get the Ascii-Text String of an existing Text-Annotation. Copies
 the Current Annotation Text into string pointed to by pText.  Will copy up to
 nLength bytes.  If pText = NULL, function will return length of Current Annotation
 Text (including NULL byte at end of string) into *pnLength. 
 RETURNS:	0 = SUCCESS, NON-ZERO = FAILURE
*/
INT16 PUBLIC
GetAnnotationText(
	GraphPtr			pGraph,
	INT16			 	anodeID,						/* Which Annotation */
	char FAR *		pText,                    /* Result COPIED into here */
	INT16	FAR		*pnLength                   /* Max. # of bytes to copy */
);

/*12jun95DW:  Routine to set user-defined widths & heights for cells in our TABLE CHARTS
	Assumes that ATC_UNIFORMROWS and/or ATC_UNIFORMCOLS have been set to 2 (User-defined mode) */
INT16 PUBLIC
SetTableChartCellDimensions(
	GraphPtr 				pGraph,				/* Which Graph */
	INT16					nRow,				/* If Row >= 0, Set HEIGHT */
	INT16					nCol,				/* If Col >= 0, Set WIDTH */
	PINT16					pnValue			 	/* Value */
);

/*12jun95DW:  Routine to get user-defined widths & heights for cells in our TABLE CHARTS */
INT16 PUBLIC
GetTableChartCellDimensions(
	GraphPtr 				pGraph,				/* Which Graph */
	INT16					nRow,				/* If Row >= 0, Get HEIGHT */
	INT16					nCol,				/* IfCol >= 0, Get WIDTH */
	PINT16					pnValue			 	/* Value */
);


#ifdef __cplusplus
}
#endif
#pragma pack()
