/*--------------------------------------------------------------------------*\
  FILE: SAMP14.C                                            

  DESCIPTION:
    This is a sample program that demonstrates how to use the Windows 32 bit
    version of the Presentation Graphics SDK.  This program
    is based on SAMP1.C

  WRITTEN BY: Dan Weingart

  DATE: December 7, 1994

  COMPILER: Microsoft C8
  PG VERSION: 120794.1

  OTHER FILES NEEDED TO COMPILE:
    SAMP14.MAK
    SAMP14.H
    SAMP14.DEF
    PG.H
    PG32.LIB

    SAMP14.RC     * RESOURCE FILE *
		EDITDATA.DLG	* RESOURCE FILE *
    HAND.CUR      * RESOURCE FILE *
    TDG_LOGO.ICO  * RESOURCE FILE *

  OTHER FILES NEEDED TO RUN:
    DEFAULT.TDL
    PG32.DLL
\*--------------------------------------------------------------------------*/

#include <Windows.H>
#include <stdlib.h>
#include <string.h>
#include "SAMP14.H"
#include "PG.H"                  /* PG SDK GRAPHICS LIBRARY */
//#include "dlgopen.h"           /* needed for OpenFile dialog */
#define WASH_FX 		3
#define PICTURE_FX	4
#include "PG_FX.H"

// int FAR              dprintf(char FAR *fmt, ...);

/*--------------------------------------------------------------------------*\
|                        FUNCTION PROTOTYPES                                |
\*--------------------------------------------------------------------------*/

long  FAR   PASCAL  RecWndProc (HWND, WORD, WORD, LONG);
BOOL	FAR 	PASCAL 	EditDlgProc (HWND hdlg,	WORD wMsg,
											 WORD wParam, LONG lParam);
long	FAR		PASCAL	FullGraphWndProc (HWND, WORD, WORD, LONG);
BOOL	FAR 	PASCAL 	EditTitleProc (HWND hdlg,	WORD wMsg,
											 WORD wParam, LONG lParam);
VOID  NEAR  PASCAL  Rect2DrawNotRect (HWND, int, int, int, int);

/* PROGRAM SPECIFIC CALLS TO HOOK UP PG SDK LIBRARY TO LOCAL DATA SOURCES */

int  NEAR  DoReadFile(HWND hWnd,GraphPtr  pGraph,char FAR *pName, int nType);
int NEAR 	 SetWinTitle(HWND  hWnd, char FAR *pName);

int  NEAR  DoWriteFile(HWND hWnd,GraphPtr pGraph,char FAR *pName,int nType);


int  NEAR  GetInputFileName(HWND hWnd, char FAR *pFileName,INT16  nFileType);


int  NEAR  GetOutputFileName(HWND hWnd,char FAR *pFileName,INT16  nFileType);


HANDLE NEAR CreateGraphMetaFile(HWND hWnd, LPSTR fileName, LPRECT pBounds);

INT16 NEAR XOR_List (HWND hWnd, SelListPtr pSelList, DrawEnvPtr pDrawEnv);

INT16 PUBLIC DryGraph(DrawEnvPtr pDE, GraphPtr pGraph, INT16 wantGraph,
							 INT16 wantBackground, INT16 wantAnnotation);

BOOL PUBLIC InitDataCallBacks(HANDLE hInst, GraphPtr pGraph);
VOID PUBLIC FiniDataCallBacks(GraphPtr pGraph);

VOID	NEAR	PASCAL	ChangeGraphType (WORD);
VOID	NEAR	PASCAL	UpdateMenu  (HMENU hmenu, WORD *mVar, WORD wParam);

#define SetTitleColor(A,B)		  (SetGraphAttr((A),GRAPH_LAYER,O5D_LBLTITLE,NULL_SERIESID,NULL_GROUPID,A_FONTCOLOR_RGB  ,(B)))
#define SetTitleFont(A,B)		  	(SetGraphAttr((A),GRAPH_LAYER,O5D_LBLTITLE,NULL_SERIESID,NULL_GROUPID,A_FONTNAME       ,(B)))
#define SetRowHeaderColor(A,B)  (SetGraphAttr((A),GRAPH_LAYER,O2D_O1_LABEL,NULL_SERIESID,NULL_GROUPID,A_FONTCOLOR_RGB,(B)))
#define SetBackGroundColor(A,B) (SetGraphAttr((A),BACKGROUND_LAYER,O5D_BACKGROUND,NULL_SERIESID,NULL_GROUPID,A_AREACOLOR_RGB,(B)))
#define SetFrameColor(A,B)		  (SetGraphAttr((A),GRAPH_LAYER,O5D_FRAME,NULL_SERIESID,NULL_GROUPID,A_AREACOLOR_RGB,(B)))
#define SetRiserColor(A,B,C)	  (SetGraphAttr((A),GRAPH_LAYER,O2D_RISER,(B),NULL_GROUPID,A_AREACOLOR_RGB,(C)))
#define SetRiserPattern(A,B,C)  (SetGraphAttr((A),GRAPH_LAYER,O2D_RISER,(B),NULL_GROUPID,A_AREAPATTERN,(C)))

#define SetY1TitleOnOff(A,B)	  (SetGraphAttr((A),GRAPH_LAYER,O2D_Y1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_SHOW_TITLE_Y1,(B)))
#define SetY1TitleOrient(A,B)	  (SetGraphAttr((A),GRAPH_LAYER,O2D_Y1_TITLE,NULL_SERIESID,NULL_GROUPID,A_FONTORIENT,(B)))
#define SetY1TitleLocation(A,B) (SetGraphAttr((A),GRAPH_LAYER,O2D_Y1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_LOCATE_TITLE_Y1,(B)))

#define GetY1TitleOnOff(A,B)	  (GetGraphAttr((A),GRAPH_LAYER,O2D_Y1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_SHOW_TITLE_Y1,(B)))
#define GetY1TitleOrient(A,B)	  (GetGraphAttr((A),GRAPH_LAYER,O2D_Y1_TITLE,NULL_SERIESID,NULL_GROUPID,A_FONTORIENT,(B)))

#define SetX1TitleOnOff(A,B)	  (SetGraphAttr((A),GRAPH_LAYER,O2D_X1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_SHOW_TITLE_X,(B)))
#define SetX1TitleOrient(A,B)	  (SetGraphAttr((A),GRAPH_LAYER,O2D_X1_TITLE,NULL_SERIESID,NULL_GROUPID,A_FONTORIENT,(B)))
#define SetX1TitleLocation(A,B) (SetGraphAttr((A),GRAPH_LAYER,O2D_X1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_LOCATE_TITLE_X,(B)))

#define GetX1TitleOnOff(A,B)	  (GetGraphAttr((A),GRAPH_LAYER,O2D_X1_TITLE,NULL_SERIESID,NULL_GROUPID,A2D_SHOW_TITLE_X,(B)))
#define GetX1TitleOrient(A,B)	  (GetGraphAttr((A),GRAPH_LAYER,O2D_X1_TITLE,NULL_SERIESID,NULL_GROUPID,A_FONTORIENT,(B)))

#define SetAutoShade(A,B) 		  (SetGraphAttr((A),GRAPH_LAYER,O5D_BACKGROUND,NULL_SERIESID,NULL_GROUPID,A3D_AUTOSHADE_CUBE,(B)))

/*--------------------------------------------------------------------------*\
|                       Static Data.                                       |
\*--------------------------------------------------------------------------*/
DLGPROC lpitEditTitleDlg;
FARPROC lpitEditDlg;
HANDLE  hInst;
HANDLE  ghDMInst;

/* PG SDK - Global graph variables */
DrawEnvPtr gpDrawEnv;                   /* ptr to StdDraw Environment */
GraphPtr   gpGraph;                     /* ptr to Graph Object */
SelListPtr		gpList;							/* ptr to Selection List */
DetNodeRef		gDetNode;						/* global DetNode			 */
DetNodeRefPtr	gpDetNode = &gDetNode;		/* ptr to global DetNode */
DetNodePtr		tempNode;						/* ptr to global DetNode */
SelItemPtr		gpSelItem;						/* ptr to Selection Item */
int        gbGraphValid;                /* TRUE when graph exists */
char       gFileName[256];
int        gnControlMenu = MCONTROL_WHOLE_GRAPH;
HBRUSH     ghGreenBrush;
HBRUSH     ghOldBrush;
INT16		  gFontObj = O5D_LBLTITLE;
BOOLEAN	  ActionMode = FALSE;	/* TRUE = Drawing partial graph */
LOGFONT   lfControl;
LOGFONT   lfData;
HFONT     hfControl;
HFONT     hfData;
REAL		 	One = 1;
REAL			Two = 2;
REAL			Three  = 3;
REAL			Ten = 10;
REAL			Hundred = 100;
REAL		   Thousand = 1000;
REAL			NegOne = -1;
REAL			NegTen = -10;
RECT      rctDM;
RECT      r,rOld;
BOOLEAN 		bO2DFilter = FALSE;
BOOLEAN 		bO2DXGrid = FALSE;
INT16				Filter = -1;
BOOL  		bTRUE = TRUE;
BOOL			bFALSE= FALSE;
INT16			Center  = 0;
INT16			Top     = 3;
INT16			Above   = 4;
BOOLEAN 	b8000Test  = FALSE;
INT16			MaxVal = 700;				 	

/*** Useful mnemonics for Write3Dx ***/
#define WANT_TEXT   1
#define WANT_BINARY 0

#define CANNOT_UNDO_OR_REDO 0
#define CAN_UNDO 						1
#define CAN_REDO 						2

/* THE FOLLOWING STATIC VARIABLES ARE USED TO STORE THE CHART DATA */
#define MaxStringSz  64

int   StringID [12] =  {ID_TITLE,
                ID_SUBTITLE,
                 ID_RH1,ID_RH2,ID_RH3,ID_RH4,
                ID_CH1,ID_CH2,ID_CH3,
                0,0,0};

int   NumID [4][3] = {{ID_R1C1,ID_R1C2,ID_R1C3},
               {ID_R2C1,ID_R2C2,ID_R2C3},
               {ID_R3C1,ID_R3C2,ID_R3C3},
               {ID_R4C1,ID_R4C2,ID_R4C3}};

/* THE FOLLOWING STATIC VARIABLES ARE USED TO STORE THE CHART DATA */
#define MaxStringSz	64

char	StringData[29][MaxStringSz] = {"Presentation Graphics SDK",
												 "by Palisades Software",
												 "Dan", "Elmer","Alex","Eric",
												 "Martin","Kai","Neil","Wayne",
												 "James","Bryan","Sam","Celia",
												 "January", "February", "March","April",
												 "May","June","July","August",
												 "September","October","November","December",
												 "The Row Title", "The Column Title",
												 "A footnote"};

int   NumData [12][12] = {{41,44,45,46,700,600,700,800,900,1000,1100,1200},
								  {55,56,57,58,880,700,800,900,1000,1100,1200,1300},
								  {66,67,68,69,860,700,800,900,1000,1100,1200,1300},
								  {82,83,84,99,840,700,800,900,1000,1100,1200,1300},
								  {600,580,400,300,200,300,200,100,200,300,400,500},
								  {420,510,620,710,820,700,800,900,1000,1100,1200,1300},
								  {440,530,640,730,840,700,800,900,1000,1100,1200,1300},
								  {480,550,660,750,860,700,800,900,1000,1100,1200,1300},
								  {400,570,680,770,880,700,800,900,1000,1100,1200,1300},
								  {500,600,700,800,900,800,900,1000,1100,1200,1300,1400}};

#define MaxEditCol	3
#define MaxEditRow	4

char FAR *FileTypeExt[] = {
  "*.TDL",
  "*.3DL",
  "*.WMF",
  "*.PAL"
};

//CHAR FileFilter[] = "TDL Files (*.TDL)\0*.TDL\03DL Files (*.3DL)\0*.3DL\0WMF Files (*.WMF)\0*.WMF\0";
CHAR FileFilter[] = "TDL Files (*.TDL)\0*.TDL\0";

enum FileType {
  FILE_LOOK,
  FILE_3DL,
  FILE_WMF,
	FILE_PAL,
  MAX_FileType
};

HWND	hwndChild;

/*--------------------------------------------------------------------------*\
|                       Main Function: WinMain                             |
\*--------------------------------------------------------------------------*/

int PASCAL WinMain  (HANDLE hInstance,
               HANDLE hPrevInstance,
               LPSTR  lpszCmdLine,
               int    cmdShow)

  {
  HWND     hwnd;
  MSG      msg;
  WNDCLASS wndclass;
  INT16    nStatus;
  char     tmpbuf[256];
	LPSTR		lpszToken = NULL;
	BOOL		bCmdFile = FALSE;

  if (!hPrevInstance)
    {
    wndclass.lpszClassName = "SAMP14:MAIN";
    wndclass.hInstance     = hInstance;
    wndclass.lpfnWndProc   = RecWndProc;
    wndclass.hCursor       = LoadCursor (hInstance, "hand");
    wndclass.hIcon         = LoadIcon (hInstance, "TDG_LOGO");
    wndclass.lpszMenuName  = "SAMP14_MENU";
    wndclass.hbrBackground = COLOR_WINDOW+1;
    wndclass.style         = CS_HREDRAW | CS_VREDRAW;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;

    RegisterClass( &wndclass);


	  wndclass.lpszClassName = "FULLGRAPH:CHILD";
	  wndclass.hInstance     = hInstance;
 	  wndclass.lpfnWndProc	 = FullGraphWndProc;
	  wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	  wndclass.hIcon		    = NULL;
	  wndclass.lpszMenuName  = NULL;
	  wndclass.hbrBackground = COLOR_WINDOW+1;
	  wndclass.style		    = NULL;
	  wndclass.cbClsExtra	 = 0;
	  wndclass.cbWndExtra	 = 0;

	  RegisterClass( &wndclass);

    }

  hInst = hInstance;


  if ( nStatus = InitTDGLIB() )     /* PG SDK - MAIN INITIALIZATION CALL */
     {
    wsprintf(tmpbuf, "InitTDGLIB failed (%d)!", nStatus);
    MessageBox(NULL, tmpbuf, "WinMain",
            MB_OK | MB_ICONHAND | MB_SYSTEMMODAL );
     }


  if ( !(gpGraph = AllocGraphPtr()) ) /* PG SDK - ALLOCATE A GRAPH POINTER */
    return FALSE;
            
	InitDataCallBacks(hInst, gpGraph);  

                          /* PG SDK - ALLOCATE DRAW ENVIRONMENT */
   if ( !(gpDrawEnv = AllocDrawEnvPtr(hwnd, FALSE)) )  
    return FALSE;


								  /* PG SDK- CREATE AN EMPTY SELECTION LIST */
  gpList = Select_AllocList();

  hwnd = CreateWindow("SAMP14:MAIN",     /* Class Name. */
                "PG SDK Sample #14",      /* Title      */
                WS_OVERLAPPEDWINDOW,    /* Style bits. */
                CW_USEDEFAULT,          /* x - default */
                0,                      /* y - default  */
                CW_USEDEFAULT,          /* cx - default*/
                0,                      /* cy - default*/
                NULL,                   /* No parent  */
                NULL,                   /* Class menu. */
                hInstance,              /* Creator    */
                NULL                    /* Params    */
               ) ;

	hwndChild = CreateWindow("FULLGRAPH:CHILD",		/* Class Name. */
							  NULL,
							  WS_POPUP,					/* Style bits. */
							  0,							/* x - default */
							  0,							/* y - default	*/
							  GetSystemMetrics(SM_CXSCREEN),	/* cx - default*/
							  GetSystemMetrics(SM_CYSCREEN),	/* cy - default*/
							  hwnd,						/* No parent	*/
							  NULL,						/* Class menu. */
							  hInstance,				/* Creator		*/
							  NULL						/* Params		*/
							 ) ;

	/*
	** look for command line file
	*/
	lpszToken = strtok(lpszCmdLine, " \t");

	if (!lpszToken || !*lpszToken)	/* PG SDK- LOAD A BAR GRAPH TEMPLATE AS DEFAULT */
		{
	  nStatus = TDIReadGraph(gpGraph, REQUEST_TDL, "default.tdl");
		SetWinTitle(hwnd, "default.tdl");
		}
	else							
		{
    // dprintf("Loading file from command line: %s\n", lpszToken);
	  nStatus = TDIReadGraph(gpGraph, REQUEST_TDL, lpszToken);
  	SetWinTitle(hwnd, lpszToken);
    GetClientRect(hwnd, &rOld);
    r = rOld;
		gbGraphValid = TRUE;
		}

	if (nStatus != E00_OK)
     return FALSE;

	lpitEditDlg = MakeProcInstance (EditDlgProc, hInst);

  ShowWindow (hwnd, cmdShow);

  while (GetMessage (&msg, 0, 0, 0))
    {
    TranslateMessage (&msg);    /* Keyboard input. */
    DispatchMessage (&msg);
    }


  /* PERFORM PG SDK CLEAN-UP */

  Select_FreeList (gpList);		 /* PG SDK - FREE MEMORY USED BY THIS POINTER */


  DeleteObject(ghGreenBrush);

  FreeDrawEnvPtr(gpDrawEnv);     /* PG SDK - FREE MEMORY USED BY THIS POINTER */

	FiniDataCallBacks(gpGraph);	 /* LOCAL PROC - CLEAN UP THUNKS */

  FreeGraphPtr(gpGraph);       /* PG SDK - FREE MEMORY USED BY THIS POINTER */

  FiniTDGLIB();

  return 0;
  }

/*--------------------------------------------------------------------------*\
|                       Window Procedure: RecWndProc.                      |
|   This is the main message processing loop for this application           |
\*--------------------------------------------------------------------------*/

long FAR PASCAL RecWndProc (HWND hWnd,    WORD msg,
                   WORD wParam,  LONG lParam)

  {
  static BOOL  fCapture = FALSE;
  static BOOL  fDrag    = FALSE;
  static POINT ptDrag;
  static RECT  r2,aRect,rBegin;
  HMENU        hmenu;
  char         buffer[80];
  char         tmpbuf[256];
  char			   szTemp[256];
  int          nUndoId;
  int          dStatus;
  static int   one = 1;
  static BOOL  sbDMVisible = FALSE;
  static HWND  shWndDM;

#define FULL 65535		/* PG SDK - FULL INTENSITY OF A GIVEN COLOR */
#define THIRD 21760		/* PG SDK - THIRD INTENSITY OF A GIVEN COLOR */

	static RGB16 aRGB[8]  = {{   0,   0,   0},	/* BLACK */
									 {FULL,FULL,FULL},	/* WHITE */
									 {FULL,   0,   0},	/* RED   */
									 {   0,FULL,   0},	/* GREEN */
									 {   0,   0,FULL},	/* BLUE  */
									 {FULL,FULL,   0},	/* YELLOW*/
									 {2*THIRD,2*THIRD,2*THIRD},	/* LT.GREY*/
									 {THIRD,THIRD,THIRD}};	/* DK.GREY*/

	static INT16 pat[5]  = {1,
									2,
									3,
									4,
									5};

	static INT16 Solid	= 0;

	static int aFontStyle [4] = {0, /* NORMAL */
										  1, /* BOLD */
										  2, /* ITALICS */
										  4};/* UNDERLINE */

  /* IMPORT FILTER ADDITION 4/3/92 -DW */
  static WORD wGraphID = IDM_BAR;
  static WORD wSameID  = IDM_SAME_AREA;
  static WORD wLabelID = IDM_LABEL_OFF;
  static WORD wTitleFont   = IDM_TIMES;
  static WORD wTitleColor  = IDM_TBLACK;
  static WORD wTitleStyle = IDM_NORMAL;
  static WORD wMouseID = IDM_CHARTLOC;
  static BOOLEAN bE1	  = FALSE;
  static BOOLEAN bPatterns = FALSE;
  static BOOLEAN bSelect   = FALSE;
  static BOOLEAN bSize	   = FALSE;
  static BOOLEAN bDetect   = FALSE;
  static BOOLEAN bSame     = FALSE;
  static BOOLEAN bIsOn     = FALSE;
  static BOOLEAN bIsHotel  = FALSE;
  static BOOLEAN bAuto3D   = TRUE;
  static BOOLEAN bAutoFit  = TRUE;
  static INT16	BarSpace = 50;
  static INT16	BarWidth = 50;
  static INT16	NoData  	  = 0;
  static INT16	ValueOnly  = 1;
  static INT16	Base    = 2;
  static INT16	nStyle;
  static INT16	iSame = 3;
  static int NormalText = FONTORIENT_NORMAL;
  static int HotelText  = FONTORIENT_HOTEL;
  static BoxInstRec Location1;
  static BoxInstRec Location2;
	static BOOLEAN bPokeTest  = FALSE;
	static BOOLEAN bFoundItem = FALSE;
	static BOOLEAN bShadow = FALSE;
	static BOOLEAN bFake3D = FALSE;
	static INT16 FmtCode = 56;

  DWORD	nFree;
  DWORD	nTime;
  DWORD	nTest;

  HDC foohdc;
  PAINTSTRUCT foops;
	static BoxInstRec 	ShadowBox = {500,500,500,500};

  switch (msg)
    {
    case WM_COMMAND:
      hmenu = GetMenu (hWnd);
      switch (wParam)
        {

        case IDM_QUIT:         /* TIME TO QUIT! */
          DestroyWindow (hWnd);
          break;
        
        case MFILE_OPEN_LOOK:
			  	if ( GetInputFileName(hWnd, gFileName, FILE_LOOK) )
					  gbGraphValid = (DoReadFile(hWnd, gpGraph, gFileName, FILE_LOOK) == E00_OK);
					if (gbGraphValid)
					 	SetWinTitle(hWnd, gFileName);
				  InvalidateRect (hWnd, &rOld, TRUE);
					break;


        case MFILE_SAVE_LOOK:
			  	if ( GetOutputFileName(hWnd, gFileName, FILE_LOOK) )
					  DoWriteFile(hWnd, gpGraph, gFileName, FILE_LOOK);
					break;

				case CLONE_GRAPH:

					{
						GraphPtr	pNew;

						FreeAllDetNodes(gpGraph);

						pNew = TDICloneGraph(gpGraph);

            if (pNew)
              {

							FiniDataCallBacks(gpGraph);	 /* LOCAL PROC - CLEAN UP THUNKS */
						  FreeGraphPtr(gpGraph);

						  gpGraph = pNew;

							InitDataCallBacks(hInst, gpGraph);  

					    InvalidateRect (hWnd, &rOld, TRUE);
              UpdateWindow(hWnd);           /* Sends WM_PAINT message */
              }
					}

					break;

         case MFILE_SAVEMETAFILE:
					{
					Rect	rMF;

   	    	if (GetOutputFileName(hWnd, gFileName, FILE_WMF) )
					  {
				    GetClientRect(hWnd, &rMF);
	          CreateGraphMetaFile(hWnd,gFileName, &rMF);
					  }
					}
          break;

		  case IDM_TLEFT: 		
		  case IDM_TRIGHT: 		
		  case IDM_TCENTER: 		
			{
			INT16	Left 			= ALIGN_LEFT;
			INT16	Right			= ALIGN_RIGHT;
			INT16	Center		= ALIGN_CENTER;

			if (wParam == IDM_TLEFT)		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTALIGN, &Left); 
			else
				if (wParam == IDM_TRIGHT)		
 				  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTALIGN, &Right); 
				else
					if (wParam == IDM_TCENTER)		
 					  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTALIGN, &Center); 
	    InvalidateRect (hWnd, &rOld, TRUE);
			}
       break;

			case IDM_FULLSCREEN:
		    ShowWindow(hwndChild, SW_SHOW);
			  break;

			case IDM_POKY:
        CheckMenuItem(hmenu,wParam,(bPokeTest)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bPokeTest = !bPokeTest;
			  break;

			case IDM_8000:
				SetGraphAttrSI(gpGraph,NULL,A2D_SHOW_O1,&b8000Test);
        CheckMenuItem(hmenu,wParam,(b8000Test)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  b8000Test = !b8000Test;
				InitDataCallBacks(hInst, gpGraph);  
		    InvalidateRect (hWnd, &r, TRUE);
			  break;

			case IDM_UNDO:
				{
				PerformUndo(gpDrawEnv,gpGraph);
		    InvalidateRect (hWnd, &r, TRUE);
				}
			  break;

			case IDM_USERDEFINED:
				{
				SetGraphAttrSI(gpGraph,NULL, A2D_FORMAT_Y1,&FmtCode);
		    InvalidateRect (hWnd, &r, TRUE);
				}
			  break;

#if 0
			case IDM_SAVEPAL:
			 	if ( GetOutputFileName(hWnd, gFileName, FILE_PAL) )
				  {
				  nStatus = ExtractPalette (gpGraph, &gPalette);
				  nStatus = IOopen(&iop, gFileName, 0, IO_RD_WR);
				  nStatus = WritePalette (&iop, &gPalette);
				  IOclose (&iop);
				  };
				break;

			case IDM_LOADPAL:
		  	if ( GetInputFileName(hWnd, gFileName, FILE_PAL) )
				  {
				  nStatus = IOopen(&iop, gFileName, 0, IO_RD_ONLY);
				  if (nStatus) 
				   {
					 };
			    nStatus = ReadPalette(&iop, 0, &gPalette);
			    IOclose(&iop);
			    ChangePalette(gpGraph, gPalette);
		  	  InvalidateRect (hWnd, &r, TRUE);
				  };
				break;
#endif

		  case IDM_HELVETICA: 		
		  case IDM_TIMES:			   
		  case IDM_SYMBOL: 		
		  case IDM_SYSTEM: 		
		  case IDM_MODERN: 		
		  case IDM_COURIER: 		
		  case IDM_SCRIPT: 		
			{
			FontNameInfo	HelvFont = {"Helv",DEFAULT_PITCH,ANSI_CHARSET,0};
			FontNameInfo	ScriptFont = {"Script",66,OEM_CHARSET,0};
			FontNameInfo	WingDingFont = {"WingDings",DEFAULT_PITCH,ANSI_CHARSET,0};
			FontNameInfo	TimesFont = {"Times New Roman",DEFAULT_PITCH,ANSI_CHARSET,0};
			FontNameInfo	SystemFont = {"Arial",DEFAULT_PITCH,ANSI_CHARSET,0};
			FontNameInfo	CourierFont = {"Courier",49,DEFAULT_CHARSET,0};
			FontNameInfo	ModernFont = {"Modern",DEFAULT_PITCH|FF_MODERN,OEM_CHARSET,0};

			UpdateMenu (hmenu,&wTitleFont,wParam);


			if (wParam == IDM_HELVETICA)		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &HelvFont); 
			else		
			  if (wParam == IDM_TIMES)		
 			    SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &TimesFont); 
			  else
			  	 if (wParam == IDM_SYMBOL)		
 			      SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &WingDingFont);
			  else
			  	 if (wParam == IDM_COURIER)		
 			      SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &CourierFont); 
			  else
			  	 if (wParam == IDM_MODERN)		
 			      SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &ModernFont); 
			  else
			  	 if (wParam == IDM_SCRIPT)		
 			      SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &ScriptFont); 
			  else
 			      SetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, &SystemFont);
		   InvalidateRect (hWnd, &rOld, TRUE);		
			}
			break;	 
	
			case IDM_SHOWFONT:
				{
				char szFontName[64];
				char szFontMessage[128] = "Font name = ";

 			  GetGraphAttrSI(gpGraph,gpSelItem,A_FONTNAME, szFontName); /*PG SDK- MACRO FOR SetGraphAttr */		
				lstrcat(szFontMessage,szFontName);
        MessageBox (hWnd, szFontMessage, "SHOW FONT", MB_OK);
				}
        break;

			case IDM_AUTOFIT:
				{
 			  SetGraphAttrSI(gpGraph,gpSelItem,A3D_AUTOFIT_TEXT, &bTRUE); /*PG SDK- MACRO FOR SetGraphAttr */		
		    InvalidateRect (hWnd, &rOld, TRUE);		
				}
        break;
			case IDM_UNAUTOFIT:
				{
 			  SetGraphAttrSI(gpGraph,gpSelItem,A3D_AUTOFIT_TEXT, &bFALSE); /*PG SDK- MACRO FOR SetGraphAttr */		
		    InvalidateRect (hWnd, &rOld, TRUE);		
				}
        break;

		  case IDM_TRED:								   
		  case IDM_TGREEN:			   
		  case IDM_TBLUE:	   
		  case IDM_TBLACK:			   

			UpdateMenu (hmenu,&wTitleColor,wParam);		

			if (wParam == IDM_TRED) 		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTCOLOR_RGB, &aRGB[2]);
			if (wParam == IDM_TGREEN)		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTCOLOR_RGB, &aRGB[3]);
			if (wParam == IDM_TBLUE) 		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTCOLOR_RGB, &aRGB[4]);
			if (wParam == IDM_TBLACK) 		
 			  SetGraphAttrSI(gpGraph,gpSelItem,A_FONTCOLOR_RGB, &aRGB[0]);

		   InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_TSIZE:			   

			gFontObj = O5D_LBLTITLE;

			lpitEditTitleDlg = (DLGPROC) MakeProcInstance (EditTitleProc, hInst);

			dStatus = DialogBox(hInst,"TITLE_SIZE", hWnd,lpitEditTitleDlg);		
		  
			FreeProcInstance((FARPROC)lpitEditTitleDlg);

			if (dStatus == ID_OK) 		
		       InvalidateRect (hWnd, &rOld, TRUE);		

			break;		

		  case IDM_NORMAL:			   
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 	 		SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &aFontStyle [0]);
	    	InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_BOLD:
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &aFontStyle [1]);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_ITALICS:			   
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &aFontStyle [2]);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_UNDERLINE:
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &aFontStyle [3]);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_BI:
			nStyle = aFontStyle[1] + aFontStyle[2];
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &nStyle);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_BU:
			nStyle = aFontStyle[1] + aFontStyle[3];
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &nStyle);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_IU:
			nStyle = aFontStyle[2] + aFontStyle[3];
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &nStyle);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_BIU:
			nStyle = aFontStyle[1] + aFontStyle[2] + aFontStyle[3];
			UpdateMenu (hmenu,&wTitleStyle,wParam);		
 			SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSTYLE, &nStyle);
	    InvalidateRect (hWnd, &rOld, TRUE);		
			break;		

		  case IDM_AUTO_ON:
		     CheckMenuItem(hmenu,wParam,(bAuto3D)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
		  	  bAuto3D = !bAuto3D;
			  if (bAuto3D)
				 SetAutoShade(gpGraph,&bTRUE);
			  else
				 SetAutoShade(gpGraph,&bFALSE);

	   	  InvalidateRect (hWnd, &rOld, TRUE);		
		  	  break;

        case IDM_3DGON:
			  {
			  TDG_GridLines3D OnZ2 = {1,-1};

			  SetGraphAttr(gpGraph,GRAPH_LAYER,O5D_BACKGROUND, NULL_SERIESID,NULL_GROUPID,
			  							A3D_GRID_RISER,&OnZ2);
	   	  InvalidateRect (hWnd, &rOld, TRUE);		
			  }
		  	  break;

        case IDM_3DGOFF:
			  {
			  TDG_GridLines3D OffZ = {1,0};

			  SetGraphAttr(gpGraph,GRAPH_LAYER,O5D_BACKGROUND, NULL_SERIESID,NULL_GROUPID,
			  							A3D_GRID_RISER,&OffZ);
	   	  InvalidateRect (hWnd, &rOld, TRUE);		
			  }
		  	  break;
				case IDM_RISERSHADOW:
					bShadow = !bShadow;
					SetGraphAttrSI(gpGraph,NULL, A2D_SHADOW_OFFSETS, &ShadowBox);
					SetGraphAttrSI(gpGraph,NULL,A2D_SHOW_SHADOWS,&bShadow);
          InvalidateRect (hWnd, &rOld, TRUE);
					break;

				case IDM_FAKE3D:
					bFake3D = !bFake3D;
					SetGraphAttrSI(gpGraph,NULL,A2D_DEPTH_MODE,&bFake3D);
          InvalidateRect (hWnd, &rOld, TRUE);
					break;

        case IDM_BAR:
        case IDM_LINE:
        case IDM_AREA:
        case IDM_3D:
        case IDM_PIE:
        case IDM_BARS:
        case IDM_BARP:
        case IDM_SCATTER:
        case IDM_HISTOGRAM:
			  UpdateMenu (hmenu,&wGraphID,wParam);
			  ChangeGraphType (wGraphID);	/* SEE SUB-ROUTINE FOR PG SDK CALL */
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_HILITE:
			  {
			  SetGraphAttrSI(gpGraph,gpSelItem,A2D_HL_COLOR,&bTRUE);

			  foohdc = GetDC (hWnd);
	        DESetPortInfo(gpDrawEnv, foohdc, DE_PORT_NORMAL);
           DryRunTheGraph(gpDrawEnv, gpGraph, TRUE, TRUE, TRUE);
			  ReleaseDC (hWnd,foohdc);

			  SetGraphAttrSI(gpGraph,gpSelItem,A_AREACOLOR_RGB,&aRGB[5]);

	   	  InvalidateRect (hWnd, &rOld, TRUE);		
			  }
		  	  break;

		  case IDM_UNHILITE:
			  SetGraphAttrSI(gpGraph,gpSelItem,A2D_HL_COLOR,&bFALSE);
	   	  InvalidateRect (hWnd, &rOld, TRUE);		
		  	  break;

		  case IDM_SERIES0:
		  case IDM_SERIES1:
		  case IDM_SERIES2:
			  {
			  INT16	i;
			  BOOLEAN bEmphasized;

			  i = wParam - IDM_SERIES0;
			  GetGraphAttr(gpGraph,
			  					GRAPH_LAYER,
							  	NULL_OBJECTID,
								i,
							  	NULL_GROUPID, 
								A2D_SDEMPHASIZED,
								&bEmphasized);
			  SetGraphAttr(gpGraph,GRAPH_LAYER,NULL_OBJECTID,i,NULL_GROUPID, A2D_SDEMPHASIZED, (bEmphasized)?&bFALSE:&bTRUE);
		     CheckMenuItem(hmenu,wParam,(bEmphasized)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
           InvalidateRect (hWnd, &rOld, TRUE);
			  };
			  break;

		  case IDM_SELECT:
		  case IDM_DETECT:
		  case IDM_SIZE:
		  case IDM_SAME:
		  case IDM_CHARTLOC:
			  {
			  UpdateMenu (hmenu,&wMouseID,wParam);

			  bSelect = FALSE;
			  bDetect = FALSE;
			  bSize = FALSE;
			  bSame = FALSE;

  			  switch (wParam)
				 {
				 case IDM_SELECT:
			 	   bSelect = TRUE;
					break;
				 case IDM_DETECT:
			 	   bDetect = TRUE;
					break;
				 case IDM_SIZE:
			 	   bSize = TRUE;
					break;
				 case IDM_SAME:
			 	   bSame = TRUE;
					break;
				 case IDM_CHARTLOC:
					break;
				 }
  
			  };
			  break;

		  case IDM_O2DFILTER:
		     CheckMenuItem(hmenu,wParam,(bO2DFilter)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
		  	  bO2DFilter = !bO2DFilter;
			  if (bO2DFilter)
			    Filter = O2D_RISER;
			  else
			  	 Filter = -1;
       	  XOR_List(hWnd,gpList,gpDrawEnv);	 /*PG SDK - TURN XOR HANDLES OFF */
		     Select_ClearList (gpList); 			 /*PG SDK - Clear our master list */	  
			  break;

		  case IDM_O2DXGRID:
				{
				 TDG_GridLinesOrdInfo O1Grid = {1,2,5};

		      CheckMenuItem(hmenu,wParam,(bO2DXGrid)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
		  	  bO2DXGrid = !bO2DXGrid;
					SetGraphAttrSL(gpGraph,NULL,A2D_GRIDLINESORD_O1,&O1Grid);
					SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_O1,&bO2DXGrid);
					SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_TITLE_X,&bO2DXGrid);
        InvalidateRect (hWnd, &rOld, TRUE);
				}
			  break;

      case IDM_SAME_BLACK:
      case IDM_SAME_WHITE:
      case IDM_SAME_RED:
      case IDM_SAME_GREEN:
      case IDM_SAME_BLUE:
      case IDM_SAME_YELLOW:
      case IDM_SAME_LGREY:
      case IDM_SAME_DGREY:
			   {
 	     	   SelItemPtr pSel;
			   int	i;
				Rect  r3;

			   i = wParam - 820;

				if (wSameID == IDM_SAME_AREA)
 			     SetGraphAttrSL(gpGraph,gpList,A_AREACOLOR_RGB,&aRGB[i]);
				else
				  if (wSameID == IDM_SAME_FONT)
 			       SetGraphAttrSL(gpGraph,gpList,A_FONTCOLOR_RGB,&aRGB[i]);
				  else
				    if (wSameID == IDM_SAME_LINE)
 			         SetGraphAttrSL(gpGraph,gpList,A_LINECOLOR_RGB,&aRGB[i]);

			   pSel = Select_GetFirstItem(gpList, FALSE);

       		XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES OFF */
			   while (pSel) 
			     {	
				  r3 = pSel->rcBounds;
				  vdRect(gpDrawEnv, &r3);	

					  r3.top--;	  		/* PAD TO AVOID ZERO HEIGHT RECTS */
					  r3.bottom++;    /* PAD TO AVOID ZERO HEIGHT RECTS */
					  r3.left--;  	 	/* PAD TO AVOID ZERO WIDTH RECTS */
					  r3.right++;     /* PAD TO AVOID ZERO WIDTH RECTS */

               InvalidateRect (hWnd,&r3, TRUE);
				  pSel = Select_GetNextItem(pSel, FALSE);
				  }
             UpdateWindow(hWnd);           
       		XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES OFF */
				}
				break;

      case IDM_SAME_OBJECT:
      case IDM_SAME_SERIES:
      case IDM_SAME_GROUP:
      case IDM_SAME_AREA:
      case IDM_SAME_LINE:
      case IDM_SAME_FONT:
           XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES OFF */
		     Select_ClearList (gpList);  /*PG SDK - Clear our master list */	  
			  UpdateMenu (hmenu,&wSameID,wParam);
           iSame = wParam - IDM_SAME_OBJECT;
			  break;


		  case IDM_Y1_ON:			/* TOGGLE Y1 TITLE ON/OFF */
			  GetY1TitleOnOff (gpGraph, &bIsOn);
		     CheckMenuItem(hmenu,wParam,(bIsOn)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bIsOn = !bIsOn;
			  SetY1TitleOnOff (gpGraph, &bIsOn);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_Y1_HOTEL:		/* TOGGLE Y1 TEXT FROM NORMAL TO HOTEL */
			  GetY1TitleOrient (gpGraph, &bIsHotel);
		     CheckMenuItem(hmenu,wParam,(bIsHotel)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bIsHotel = !bIsHotel;
			  SetY1TitleOrient (gpGraph, &bIsHotel);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_Y1_LOC:		/* PUT Y1 TEXT ON LEFT SIDE OF CHART */
			  Location1.xULC = -15500;
			  Location1.yULC =  6500;
			  Location1.xLRC = -13500;
			  Location1.yLRC = -6500;
			  SetY1TitleLocation (gpGraph, &Location1);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_X1_ON:			/* TOGGLE X1 TITLE ON/OFF */
			  GetX1TitleOnOff (gpGraph, &bIsOn);
		     CheckMenuItem(hmenu,wParam,(bIsOn)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bIsOn = !bIsOn;
			  SetX1TitleOnOff (gpGraph, &bIsOn);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_X1_HOTEL:		/* TOGGLE Y1 TEXT FROM NORMAL TO HOTEL */
			  GetX1TitleOrient (gpGraph, &bIsHotel);
		     CheckMenuItem(hmenu,wParam,(bIsHotel)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bIsHotel = !bIsHotel;
			  SetX1TitleOrient (gpGraph, &bIsHotel);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_X1_LOC:		/* PUT X1 TEXT ON BOTTOM OF CHART */
			  Location2.xULC = -1500;
			  Location2.yULC = -13000;
			  Location2.xLRC =  1500;
			  Location2.yLRC = -15000;
			  SetX1TitleLocation (gpGraph, &Location2);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

		  case IDM_LABEL_OFF:
				  
		     SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_DATATEXT,&NoData);
			  UpdateMenu (hmenu,&wLabelID,wParam);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;
		  case IDM_LABEL_ABOVE:
				  
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_DATATEXT,&ValueOnly);
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Above);
			  UpdateMenu (hmenu,&wLabelID,wParam);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;
		  case IDM_LABEL_TOP:
				  
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_DATATEXT,&ValueOnly);
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Top);
			  UpdateMenu (hmenu,&wLabelID,wParam);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;
		  case IDM_LABEL_CENTER:
				  
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_DATATEXT,&ValueOnly);
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Center);
			  UpdateMenu (hmenu,&wLabelID,wParam);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;
		  case IDM_LABEL_BASE:
				  
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_SHOW_DATATEXT,&ValueOnly);
		  	  SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Base);
			  UpdateMenu (hmenu,&wLabelID,wParam);
           InvalidateRect (hWnd, &rOld, TRUE);
			  break;

//		  case IDM_LABEL_FONT:
//			 gFontObj = O2D_DATATEXT;
//			 dStatus = DialogBox(hInst,"TITLE_SIZE", hWnd,lpitEditTitleDlg);
//			 if (dStatus == ID_OK) 
//           InvalidateRect (hWnd, &rOld, TRUE);
//			  break;

        case IDM_PATTERNS:
				  
			  if (bPatterns)
			    {
				 SetRiserPattern (gpGraph,0, &Solid);
				 SetRiserPattern (gpGraph,1, &Solid);
				 SetRiserPattern (gpGraph,2, &Solid);
				 SetRiserPattern (gpGraph,3, &Solid);
				 }
			  else
			    {
				 SetRiserColor (gpGraph,0, &aRGB[0]);	/* BLACK */
				 SetRiserColor (gpGraph,1, &aRGB[2]);	/* RED */
				 SetRiserColor (gpGraph,2, &aRGB[3]);	/* GREEN */
				 SetRiserColor (gpGraph,3, &aRGB[4]);	/* BLUE */

				 SetRiserPattern (gpGraph,0, &pat[0]);	/* Pattern #1 */
				 SetRiserPattern (gpGraph,1, &pat[1]);	/* Pattern #2 */
				 SetRiserPattern (gpGraph,2, &pat[2]); /* Pattern #3 */
				 SetRiserPattern (gpGraph,3, &pat[3]); /* Pattern #4 */
				 };
		     CheckMenuItem(hmenu,wParam,(bPatterns)?MF_BYCOMMAND | MF_UNCHECKED:MF_BYCOMMAND | MF_CHECKED);
			  bPatterns = !bPatterns;
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_PAT1:
				  
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREAPATTERN, &pat[1]);
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREABACKCOLOR,&aRGB[1]);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_PAT2:
				  
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREAPATTERN, &pat[2]);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_NULL:
				  
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREACOLOR_NONE, &bTRUE);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_MARKER_ON:
					{
				  TDG_SerDepINT16  LineMode;

					LineMode.nValue = DATALINE_BOTH;
					LineMode.nSeriesID = gpSelItem->nSeriesID;

			  	  
				  SetGraphAttrSI (gpGraph,gpSelItem, A2D_SDDATALINE_TYPE, &LineMode);
	        InvalidateRect (hWnd, &rOld, TRUE);
					}
          break;

        case IDM_MARKER_OFF:
					{
				  TDG_SerDepINT16  LineMode;

					LineMode.nValue = DATALINE_LINE;
					LineMode.nSeriesID = gpSelItem->nSeriesID;

					  
				  SetGraphAttrSI (gpGraph,gpSelItem, A2D_SDDATALINE_TYPE, &LineMode);
	        InvalidateRect (hWnd, &rOld, TRUE);
					}
          break;

        case IDM_SOLID:
			  {

				  
			  SetGraphAttrSI (gpGraph,gpSelItem, A_LINECOLOR_NONE, &bFALSE);
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREACOLOR_NONE, &bFALSE);
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREAPATTERN, &Solid);
			  SetGraphAttrSI (gpGraph,gpSelItem, A_AREABACKCOLOR,&aRGB[1]);

           InvalidateRect (hWnd, &rOld, TRUE);
   	     XOR_List(hWnd,gpList,gpDrawEnv);	  
			  }
          break;

        case IDM_HORZ:
				  
			  SetGraphAttrSI (gpGraph, NULL, A2D_ORIENTATION,&bFALSE);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_VERT:
				  
			  SetGraphAttrSI (gpGraph, NULL, A2D_ORIENTATION,&bTRUE);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_SP:
		     BarSpace += 5;
 			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_RISER_WIDTH,&BarWidth);
			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_GROUP_SPACING,&BarSpace);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_SM:
		     BarSpace -= 5;
 			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_RISER_WIDTH,&BarWidth);
			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_GROUP_SPACING,&BarSpace);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_WP:
		     BarWidth += 5;
 			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_RISER_WIDTH,&BarWidth);
			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_GROUP_SPACING,&BarSpace);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_WM:
		     BarWidth -= 5;
 			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_RISER_WIDTH,&BarWidth);
			  SetGraphAttrSI (gpGraph, NULL, A2D_BAR_GROUP_SPACING,&BarSpace);
           InvalidateRect (hWnd, &rOld, TRUE);
          break;

        case IDM_LINEPAT:
			  SetGraphAttrSI (gpGraph,gpSelItem, A_LINEPATTERN, &pat[1]);
           InvalidateRect (hWnd, &rOld, TRUE);
   	     XOR_List(hWnd,gpList,gpDrawEnv);	  
          break;

        case IDM_SOLIDLINE:
			  	SetGraphAttrSI (gpGraph,gpSelItem, A_LINEPATTERN, &Solid);
          InvalidateRect (hWnd, &rOld, TRUE);
   	     	XOR_List(hWnd,gpList,gpDrawEnv);	  
          break;

 				case IDM_EDIT:				/* PUT UP EDIT_DATA DIALOG BOX */
					dStatus = DialogBox(hInst,"EDITDATA_DLG", hWnd,lpitEditDlg);
					if (dStatus == ID_OK) 
				    InvalidateRect (hWnd, &r, TRUE);
					break;

        case IDM_REDRAW:
					InvalidateRect (hWnd, &rOld, TRUE);
					UpdateWindow(hWnd);           /* Sends WM_PAINT message */
					break;

				default:
					wsprintf (buffer, "Command = %d", wParam);
					MessageBox (hWnd, buffer, "WM_COMMAND", MB_OK);

				}
			break;

    case WM_DESTROY:
      if( hfControl )
        DeleteObject( hfControl );
      if( hfData )
        DeleteObject( hfData );
      PostQuitMessage (0);
      break;
    
    case WM_LBUTTONDOWN:
      {
      int i;
      POINT pt;
      POINTS pts;


			if (bPokeTest)
				{
        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
		pt.x = pts.x;
		pt.y = pts.y;
	      dvPoint(gpDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */

				bFoundItem = FALSE;
   	    XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES ON */
	 	    Select_ClearList (gpList);  /*PG SDK - Clear our master list */	  
				do{
		   	  bFoundItem = FindNextDetNode (gpGraph, &pt, gpDetNode,bFoundItem);
				  if (bFoundItem)
					gpSelItem = Select_AddItem(gpGraph,gpList,gpDetNode);	  
				 	} while (bFoundItem);
	     	Select_CalcHandlesList (gpDrawEnv,gpList);
   	    XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES ON */
        break;
				}

      if (bSelect)
        {
	        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
			pt.x = pts.x;
			pt.y = pts.y;
		    dvPoint(gpDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */
// 	    XOR_List(hWnd,gpList,gpDrawEnv);	  
		     
		    if (FindDetNode (gpGraph, &pt, gpDetNode)) 	  
		      {	  
				  Select_ClearList (gpList);  /*PG SDK - Clear our master list */	  
				 	gpSelItem = Select_AddItem(gpGraph,gpList,gpDetNode);	  
	    	 	Select_CalcHandlesList (gpDrawEnv,gpList);
       	 	XOR_List(hWnd,gpList,gpDrawEnv); 
         	}
        break;
        }

      if (bSame)
        {
	        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
			pt.x = pts.x;
			pt.y = pts.y;
		      dvPoint(gpDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */
   	      XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES ON */
		     
		      if (FindDetNode (gpGraph, &pt, gpDetNode)) 	  
		      {	  
			   /* IF SHIFT KEY */

			   if (MK_SHIFT & wParam);
				else
				  Select_ClearList (gpList);  /*PG SDK - Clear our master list */	  

				gpSelItem = NULL;	// No longer valid
            Select_AddRelatedItems(gpGraph,gpList,gpDetNode,iSame,TRUE,Filter);
  			  Select_RebuildList (gpGraph,gpList);
	    		Select_CalcHandlesList (gpDrawEnv,gpList);

       	   XOR_List(hWnd,gpList,gpDrawEnv);			/*PG SDK - TURN XOR HANDLES OFF */

            }
        break;
        }

      if (bSize)
		  {
	        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
			pt.x = pts.x;
			pt.y = pts.y;
	  	  ptDrag = pt;	  
		  dvPoint(gpDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */
		     
		  if (FindDetNode (gpGraph, &pt, gpDetNode)) 	  
		    {	  
			 Select_ClearList	(gpList);  /*PG SDK - Clear our master list */	  
										  /*PG SDK - Add this item to our list */	  
			 gpSelItem = Select_AddItem(gpGraph,gpList,gpDetNode);	  
			 							  /*PG SDK - Calculate Sizing Handles for item */	  
		  	 Select_CalcHandlesItem(gpDrawEnv,gpSelItem);
			  
			 /*	  
			 ** PG SDK - Easy, semi-accurate way to see if selected object is movable 	  
			 */	  
//			 if (gpSelItem->nType != DETNODE) 
			   {	  
			   r2 = gpSelItem->rcBounds;	/* For anything but title,subtitle,footnote */  
			   vdRect(gpDrawEnv,&r2);	  

			   rBegin = r2;	  
		      fCapture = TRUE;	  
		  	   Rect2DrawNotRect (hWnd,  r2.left,   
		  	 						  		 	 r2.top,	  
		  								 		 r2.right,	  
										  		 r2.bottom);		  
            fDrag = TRUE;
			   }	  
		  	 }
		  break;
		  }

      if (bDetect)
		  {
	        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
			pt.x = pts.x;
			pt.y = pts.y;
	  	  ptDrag = pt;	  
		  dvPoint(gpDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */
		     
		  if (FindDetNode (gpGraph, &pt, gpDetNode)) 	  
		    {	  
			 Select_ClearList	(gpList);  /*PG SDK - Clear our master list */	  
										  /*PG SDK - Add this item to our list */	  
			 gpSelItem = Select_AddItem(gpGraph,gpList,gpDetNode);	  
			 							  /*PG SDK - Calculate Sizing Handles for item */	  
		  	 Select_CalcHandlesItem(gpDrawEnv,gpSelItem);
			  
			 /*	  
			 ** PG SDK - Easy, semi-accurate way to see if selected object is movable 	  
			 */	  
//			 if (gpSelItem->nType != DETNODE) 
			   {	  
			   r2 = gpSelItem->rcBounds;	/* For anything but title,subtitle,footnote */  
			   vdRect(gpDrawEnv,&r2);	  

			   rBegin = r2;	  
		      fCapture = TRUE;	  
		  	   Rect2DrawNotRect (hWnd,  r2.left,   
		  	 						  		 r2.top,	  
		  								 		 r2.right,	  
										  		 r2.bottom);		  
            fDrag = TRUE;
			   }	  
		  	 }
		  }
		else
		  {
        SetCapture (hWnd);
        fCapture = TRUE;

        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
		pt.x = pts.x;
		pt.y = pts.y;

        r.left = r.right = pt.x;
        r.top = r.bottom = pt.y;

        /* If not dragging, exit. */
        if (!(MK_SHIFT & wParam))
          break;

         if (PtInRect (&rOld, pt))
            {
           ptDrag = pt;
           fDrag = TRUE;
           r = rOld;
           InvalidateRect (hWnd, &rOld, TRUE);
           UpdateWindow (hWnd);
           Rect2DrawNotRect (hWnd, r.left,
                            r.top,
                           r.right,
                           r.bottom);
           break;
           }
		  }
      }
      break;

    case WM_LBUTTONUP:
        {
          if (!fCapture) 
            break;

          ReleaseCapture ();
          fCapture = FALSE;

		    if (bSize)
		      {
	         int i;

            fDrag = FALSE;
     	      Rect2DrawNotRect (hWnd,   r2.left,
                              	     r2.top,
				                          r2.right,
            			                 r2.bottom);
     	      /* Make sure order is correct: left < right */

   	      if (r2.left > r2.right)
      	     { 
           	  i = r2.left;
	           r2.left = r2.right;
   	        r2.right = i;
      	     }

	         /* Top should be less than bottom */
   	      if (r2.top > r2.bottom)
      	     {
         	  i = r2.top;
	           r2.top = r2.bottom;
	           r2.bottom = i;
   	        }

     		   aRect = r2;
		      dvRect(gpDrawEnv, &aRect);	/*PG SDK - CONVERT TO VIRT. COORDS. */
  			   /*
     			 ** PG SDK - MAIN CALL TO MOVE SELECTED OBJECT
		       */
				 	   
					 if (gpSelItem->nObjectID == O5D_LBLSUBTITLE)
			 	     SetGraphAttrSI (gpGraph, gpSelItem, A_LOCATE_SUBTITLE,&aRect);
					 else
     	       MoveSelectedItem(gpDrawEnv,gpGraph,gpSelItem,&aRect); /*NEW POSITION*/

	         InvalidateRect (hWnd, &rBegin, TRUE); 				 /*UPDATE */
	         InvalidateRect (hWnd, &r2, TRUE); 			   	 /*UPDATE */
				break;
		      }

		      if (bDetect)
		      {

            fDrag = FALSE;
     	      Rect2DrawNotRect (hWnd,  r2.left,
                               	     r2.top,
				                             r2.right,
            				                 r2.bottom);
     		    aRect = r2;
		        dvRect(gpDrawEnv, &aRect);	/*PG SDK - CONVERT TO VIRT. COORDS. */
  			    /*
     			  ** PG SDK - MAIN CALL TO MOVE SELECTED OBJECT
		     	  */

					   

					 if (gpSelItem->nObjectID == O5D_LBLSUBTITLE)
			 	     SetGraphAttrSI (gpGraph, gpSelItem, A_LOCATE_SUBTITLE,&aRect);
					 else
	   	       MoveSelectedItem(gpDrawEnv,gpGraph,gpSelItem,&aRect); /*NEW POSITION*/

	          InvalidateRect (hWnd, &rBegin, TRUE); 				 /*UPDATE */
	          InvalidateRect (hWnd, &r2, TRUE); 			   	 /*UPDATE */
		      }
		      else
		      {
            if (fDrag)
            {
	          fDrag = FALSE;
            Rect2DrawNotRect (hWnd,   r.left,
                				              r.top,
			                                r.right,
			                                r.bottom);
            }
            else
            {
              int i;

              Rect2DrawNotRect (hWnd,   r.left,
                                        r.top,
                                        r.right,
                                        r.bottom);  
      
     	        /* Make sure order is correct: left < right */

   	          if (r.left > r.right)
      	      {
           	    i = r.left;
	              r.left = r.right;
   	            r.right = i;
      	      }

	            /* Top should be less than bottom */
   	          if (r.top > r.bottom)
      	      {
         	      i = r.top;
	              r.top = r.bottom;
	              r.bottom = i;
   	          }

      	      InvalidateRect (hWnd, &rOld, TRUE);
	     	    }  
	          InvalidateRect (hWnd, &r, TRUE);
   	        if ((r.top == r.bottom) || (r.left == r.right)) 
              gbGraphValid = FALSE;
	          else
   	         gbGraphValid = TRUE;
            rOld = r;
		      }
        }

      break;

    case WM_MOUSEMOVE:
       {

      POINT pt;
      POINTS pts;

      if (!fCapture)
        break;

        pts = MAKEPOINTS (lParam);		/* Get the Mouse Pt. */
		pt.x = pts.x;
		pt.y = pts.y;

		if (bSize)
		  {
	     /* Remove previous rectangle */
        Rect2DrawNotRect (hWnd,r2.left,
                             	 r2.top,
			                      r2.right,
         			             r2.bottom);

         r2.right = pt.x;
         r2.bottom = pt.y;

        /* Draw a new rectangle */
        Rect2DrawNotRect (hWnd,r2.left,
                               r2.top,
                      			 r2.right,
                				    r2.bottom);
		  break;

		  }

		if (bDetect)
		  {
	     /* Remove previous rectangle */
        Rect2DrawNotRect (hWnd,r2.left,
                             	 r2.top,
			                      r2.right,
         			             r2.bottom);

        /* Calculate relative movement. */
        ptDrag.x = ptDrag.x - pt.x;    
        ptDrag.y = ptDrag.y - pt.y;    

        r2.left   -= ptDrag.x;
        r2.top    -= ptDrag.y;
        r2.right  -= ptDrag.x;
        r2.bottom -= ptDrag.y;

        /* Remember drag point for next time. */

        ptDrag = pt;

        /* Draw a new rectangle */
        Rect2DrawNotRect (hWnd,r2.left,
                               r2.top,
                      			 r2.right,
                				    r2.bottom);

		  }
		else
		  {
	     /* Remove previous rectangle */
        Rect2DrawNotRect (hWnd,r.left,
                             r.top,
                      r.right,
                      r.bottom);
        if (fDrag)
          {

          /* Calculate relative movement. */
          ptDrag.x = ptDrag.x - pt.x;    
          ptDrag.y = ptDrag.y - pt.y;    

          r.left   -= ptDrag.x;
          r.top    -= ptDrag.y;
          r.right  -= ptDrag.x;
          r.bottom -= ptDrag.y;

          /* Remember drag point for next time. */

          ptDrag = pt;
          }
        else
          {
          r.right = pt.x;
          r.bottom = pt.y;
          }

        /* Draw a new rectangle */
        Rect2DrawNotRect (hWnd,r.left,
                               r.top,
                      			 r.right,
                				    r.bottom);

		  }

      }
      break;

    case WM_PAINT:
      {
      PAINTSTRUCT ps;
      HDC hdc;
	  RECT clientRect;
	  HBRUSH brush;

      hdc = BeginPaint (hWnd, &ps);

		// erase the entire client rectangle
		brush = GetStockObject(WHITE_BRUSH);
		GetClientRect(hWnd, &clientRect);
		FillRect(hdc, &clientRect, brush);
		DeleteObject(brush);

      if (!fDrag)
          {
          if (gbGraphValid)
         {
            DESetDrawProcs(gpDrawEnv, DE_PROCS_DEFAULT);

     /*PG SDK - SET THE CHART'S SIZE & LOCATION IN WINDOW */
          DESetDestRect(gpDrawEnv, &r);

     /*PG SDK - SET DRAWING MODE TO NORMAL, ON-SCREEN */
          DESetPortInfo(gpDrawEnv, hdc, DE_PORT_NORMAL);

     /*PG SDK - DRAW THE GRAPH */
          DrawBegin(gpDrawEnv);
             DrawTheGraph(gpDrawEnv, gpGraph, TRUE, TRUE, TRUE);
          DrawEnd(gpDrawEnv);

     /*PG SDK - SET STANDARD DRAW BACK TO USING THE DEFAULT PROCS */
           DESetDrawProcs(gpDrawEnv, DE_PROCS_DEFAULT);

//			if (bDetect)
		 	  {
			  /* PG SDK - Match up objects in selection list with new detnodes */
  			  Select_RebuildList (gpGraph,gpList);

			  /* PG SDK - Calculate handles for objects in selection list based on new detnodes*/
			  Select_CalcHandlesList (gpDrawEnv,gpList);
			  };
         }
        }

       EndPaint (hWnd, &ps);
       }

      break;

    default:
      return(DefWindowProc(hWnd,msg,wParam,lParam));
      break;
    }
  return 0L;
  }



/*--------------------------------------------------------------------------*\
|                     Edit Data Dialog Procedure: EditDlgProc              |
|  This function processes the messages from the EDIT_DATA Dialog Box       |
\*--------------------------------------------------------------------------*/
#if 0

BOOL FAR PASCAL EditDlgProc (HWND hdlg,  WORD wMsg,
                    WORD wParam, LONG lParam)
  {
  char  TempBuf [MaxStringSz];
  HWND  hCtl;
  static int   i,j, row, col;
  static CellRecord TempCell;
  static CellRecPtr pCell = &TempCell;    /* ptr to temp cell */
  static int page = 1;
  static int left,top,right,bottom;


  switch (wMsg)
    {
    case WM_INITDIALOG:

      DLGetTitlePos(gpGraph, &row, &col);    /*PG SDK - FIND TITLE CELL */
      GetCellRecord(page,row,col,pCell);    /*PG SDK - GET CONTENTS OF CELL */
      GetCellAsString(pCell,(LPSTR) TempBuf);/*PG SDK - GET THE TITLE STRING */           


          hCtl = GetDlgItem (hdlg, StringID[0]);
          SendMessage (hCtl,
                   WM_SETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);

      DLGetSubTitlePos(gpGraph, &row, &col); /*PG SDK - FIND SUBTITLE CELL */
      GetCellRecord(page,row,col,pCell);    /*PG SDK - GET CONTENTS OF CELL */
      GetCellAsString(pCell,(LPSTR) TempBuf);/*PG SDK - GET THE SUBTITLE STRING */           

          hCtl = GetDlgItem (hdlg, StringID[1]);
          SendMessage (hCtl,
                   WM_SETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);

      DLGetSeriesHeaderPos(gpGraph, &row, &col); /*PG SDK - FIND ROW HEADER CELLS */
      for (i=2; i<6; i++)
        {
        GetCellRecord(page,row,col,pCell);    /*PG SDK - GET CONTENTS OF CELL */
        GetCellAsString(pCell,(LPSTR) TempBuf);/*PG SDK - GET THE SUBTITLE STRING */          
 
          hCtl = GetDlgItem (hdlg, StringID[i]);
          SendMessage (hCtl,
                   WM_SETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);
        row++;
        };

      DLGetGroupsHeaderPos(gpGraph, &row, &col); /*PG SDK - FIND COL HEADER CELLS */
      for (i=6; i<9; i++)
        {
        GetCellRecord(page,row,col,pCell);    /*PG SDK - GET CONTENTS OF CELL */
        GetCellAsString(pCell,(LPSTR) TempBuf);/*PG SDK - GET THE SUBTITLE STRING */          
 
          hCtl = GetDlgItem (hdlg, StringID[i]);
          SendMessage (hCtl,
                   WM_SETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);
        col++;
        };

       DLGetDataRange(gpGraph,&left,&top,&right,&bottom);
      row = top;
      col = left;
        for (i=0; i<4; i++)
          {
          for (j=0; j<3; j++)
            {
           GetCellRecord(page,row,col,pCell);    /*PG SDK - GET CONTENTS OF CELL */
              wsprintf (TempBuf, "%ld", (long) pCell->data.RealV);
            hCtl = GetDlgItem (hdlg, NumID[i][j]);
            SendMessage (hCtl,
                 WM_SETTEXT,
                 MaxStringSz,
                 (LONG) (LPSTR) TempBuf);
           col++;
            };
          row++;
          col = left;
          };

        return TRUE;
        break;

    case WM_COMMAND:
      switch (wParam)
        {
        case ID_CANCEL:
          EndDialog (hdlg, ID_CANCEL);
          break;

        case ID_OK:

            hCtl = GetDlgItem (hdlg, StringID[0]);
            SendMessage (hCtl,
                   WM_GETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);

          DLGetTitlePos(gpGraph, &row, &col); /*PG SDK - FIND SUBTITLE CELL */
          AssignString(page,row,col,(LPSTR) TempBuf,0,0);                   
        
           hCtl = GetDlgItem (hdlg, StringID[1]);
            SendMessage (hCtl,
                   WM_GETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);
          DLGetSubTitlePos(gpGraph, &row, &col); /*PG SDK - FIND SUBTITLE CELL */
          AssignString(page,row,col,(LPSTR) TempBuf,0,0);                   



          DLGetSeriesHeaderPos(gpGraph, &row, &col); /*PG SDK - FIND ROW HEADER CELLS */
          for (i=2; i<6; i++)
              {
              hCtl = GetDlgItem (hdlg, StringID[i]);
              SendMessage (hCtl,
                   WM_GETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);
            AssignString(page,row,col,(LPSTR) TempBuf,0,0);                   
            row++;
            };

          DLGetGroupsHeaderPos(gpGraph, &row, &col); /*PG SDK - FIND COL HEADER CELLS */
          for (i=6; i<9; i++)
              {
              hCtl = GetDlgItem (hdlg, StringID[i]);
              SendMessage (hCtl,
                   WM_GETTEXT,
                   MaxStringSz,
                   (LONG) (LPSTR) TempBuf);
            AssignString(page,row,col,(LPSTR) TempBuf,0,0);                   
            col++;
            };

             DLGetDataRange(gpGraph,&left,&top,&right,&bottom);
            row = top;
            col = left;
            for (i=0; i<4; i++)
             {
             for (j=0; j<3; j++)
               {

               hCtl = GetDlgItem (hdlg, NumID[i][j]);
              SendMessage (hCtl,
                     WM_GETTEXT,
                     MaxStringSz,
                     (LONG) (LPSTR) TempBuf);

              AssignReal(page,row,col,(REAL64) atof(TempBuf),0,0);
              col++;
               };
             row++;
             col = left;
             };

          EndDialog (hdlg, ID_OK);
          break;

        default:
          return FALSE;
          break;
        }

    default:
      return FALSE;
    }
  }
#endif


/*--------------------------------------------------------------------------*\
|                Rect2DrawNotRect: Draw a NOT Rectangle                    |
\*--------------------------------------------------------------------------*/

void NEAR PASCAL Rect2DrawNotRect (HWND hWnd, int x1, int y1,
                                   int x2, int y2)
  {
  HDC hdc;

  hdc = GetDC (hWnd);
  SelectObject (hdc, GetStockObject (NULL_BRUSH));
  SetROP2 (hdc, R2_NOT);
  Rectangle (hdc, x1, y1, x2, y2);
  ReleaseDC (hWnd,hdc);
  }

int NEAR
SetWinTitle(
  HWND            hWnd,
  char FAR *      pName
)

{

  char            tmpbuf[256];

  InvalidateRect(hWnd, NULL, TRUE);

  /* set the window title too */
  wsprintf(tmpbuf, "PG SDK SAMPLE #14 - %s", pName);
  SetWindowText(hWnd, tmpbuf);

	return 0;
}



/************************************************************************
*	DoReadFile
*
*	DESCRIPTION:
*		Does a bunch of stuff related to reading a new 3Dx file.
*
*	RETURNS:
*
************************************************************************/
int NEAR
DoReadFile(
	HWND						hWnd,
	GraphPtr				pGraph,
	char FAR *			pName,
	INT16						nType
)
{
	int							nResult;
	char						tmpbuf[256];

	SetCursor (LoadCursor (NULL, IDC_WAIT));
	
	/*
	 *  kill any existing DetNodes
	 */
	FreeAllDetNodes(pGraph);

	/*
	 *  kill the annotation stuff too
	 */
#if	0
	FreeAllAnodes(pGraph);
#endif
	/*
	 *  clear the current selection list too
	 */
	Select_ClearList(gpList);

	switch (nType) {

#if 0
										
	case FILE_3D3:			/*	This is usable only in the VDM version of PG SDK */
	  nResult = TDIReadGraph(pGraph, REQUEST_TDG, pName);
		break;
#endif

	case FILE_LOOK:
	  nResult = TDIReadGraph(pGraph, REQUEST_TDL, pName);
		break;
	
	default:
		nResult = -1;
		break;
	}

	InvalidateRect(hWnd, NULL, TRUE);

	/* set the window title too */
	wsprintf(tmpbuf, "PG SDK SAMPLE #6 - %s", pName);
	SetWindowText(hWnd, tmpbuf);

	SetCursor (LoadCursor (NULL, IDC_ARROW));
  
	/* return the error code */
	return nResult;
}



/************************************************************************
*	DoWriteFile
*
*	DESCRIPTION:
*		Does a bunch of stuff related to reading a new 3Dx file.
*
*	RETURNS:
*
************************************************************************/
int NEAR
DoWriteFile(
	HWND						hWnd,
	GraphPtr				pGraph,
	char FAR *			pName,
	int							nType
)
{
	int							nResult;
	
	SetCursor (LoadCursor (NULL, IDC_WAIT));
	switch (nType) {

#if 0
	case FILE_3D3:			/*  This is usable only in the VDM version of PG SDK  */
	  nResult = TDIWriteGraph(pGraph, REQUEST_TDG, pName);
		break;
#endif

	case FILE_LOOK:	
	  nResult = TDIWriteGraph(pGraph, REQUEST_TDL, pName);
		break;

	default:
		nResult = -1;
		break;
	}
	SetCursor (LoadCursor (NULL, IDC_ARROW));
	
	return nResult;
}


/************************************************************************
*  GetInputFileName
*
*  DESCRIPTION:
*    Requests the user to choose an existing file.
*
*  RETURNS:
*    TRUE if user chose something
*
************************************************************************/
int NEAR
GetInputFileName(
  HWND            hWnd,
  char FAR *      pFileName,
  INT16            nFileType
)
{
  int              nResult;
  char            fName[256];
  OPENFILENAME	   OpenFileName;


  /*** clone filename to prevent damage ***/
  lstrcpy(fName, pFileName);
  

  /*** Call DlgOpen() to get the filename ***/

#if 0
  nResult = DlgOpenFile( hWnd,
                        "Select an Input File",
                        (LONG) OF_EXIST | OF_MUSTEXIST | OF_NOOPTIONS,
                        FileTypeExt[nFileType],
                        fName,
                        NULL);
#else
   OpenFileName.lStructSize       = sizeof(OPENFILENAME);
   OpenFileName.hwndOwner         = hWnd;
   OpenFileName.hInstance         = (HANDLE) hInst;
   OpenFileName.lpstrFilter       = FileFilter;
   OpenFileName.lpstrCustomFilter = (LPSTR) NULL;
   OpenFileName.nMaxCustFilter    = 0L;
   OpenFileName.nFilterIndex      = 1L;
   OpenFileName.lpstrFile         = fName;
   OpenFileName.nMaxFile          = sizeof(fName);
   OpenFileName.lpstrFileTitle    = (LPSTR) NULL;
   OpenFileName.nMaxFileTitle     = 0L;
   OpenFileName.lpstrInitialDir   = NULL;
   OpenFileName.lpstrTitle        = "Select an Input File";
   OpenFileName.nFileOffset       = 0;
   OpenFileName.nFileExtension    = 0;
   OpenFileName.lpstrDefExt       = FileTypeExt[nFileType];
   OpenFileName.lCustData         = 0;
   OpenFileName.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST |
       OFN_FILEMUSTEXIST;

	nResult = GetOpenFileName(&OpenFileName);
#endif

  if (nResult)
    lstrcpy(pFileName, fName);

  return (nResult > 0);
}


/************************************************************************
*   GetOutputFileName
*
*  DESCRIPTION:
*    Requests the user to choose an existing file.
*
*  RETURNS:
*    TRUE if user chose something
*
************************************************************************/
int NEAR
GetOutputFileName(
  HWND            hWnd,
  char FAR *      pFileName,
  INT16            nFileType
)
{
  int              nResult;
  char            fName[256];
	OPENFILENAME				OpenFileName;

  /*** clone filename to prevent damage ***/
  lstrcpy(fName, pFileName);
  
  /* Call DlgOpen() to set the filename */
  
#if 0  
  nResult = DlgOpenFile( hWnd,
                        "Enter Output Filename",
                        (LONG) OF_SAVE | OF_SHOWSPEC | OF_NOOPTIONS,
                        FileTypeExt[nFileType],
                        fName,
                        NULL);

#else
   OpenFileName.lStructSize       = sizeof(OPENFILENAME);
   OpenFileName.hwndOwner         = hWnd;
   OpenFileName.hInstance         = (HANDLE) hInst;
   OpenFileName.lpstrFilter       = (LPSTR) NULL;
   OpenFileName.lpstrCustomFilter = (LPSTR) NULL;
   OpenFileName.nMaxCustFilter    = 0L;
   OpenFileName.nFilterIndex      = 0L;
   OpenFileName.lpstrFile         = fName;
   OpenFileName.nMaxFile          = sizeof(fName);
   OpenFileName.lpstrFileTitle    = (LPSTR) NULL;
   OpenFileName.nMaxFileTitle     = 0L;
   OpenFileName.lpstrInitialDir   = NULL;
   OpenFileName.lpstrTitle        = "Enter Output Filename";
   OpenFileName.nFileOffset       = 0;
   OpenFileName.nFileExtension    = 0;
   OpenFileName.lpstrDefExt       = FileTypeExt[nFileType];
   OpenFileName.lCustData         = 0;
   OpenFileName.Flags = 0L;

	nResult = GetSaveFileName(&OpenFileName);
#endif
    
  if (nResult)
    lstrcpy(pFileName, fName);

	return  1; /* (nResult >= 0);*/
}

/************************************************************************
*   CreateGraphMetaFile
*
*  DESCRIPTION:
*    Creates a metafile of the current graph
*
*  RETURNS:
*    none
*
************************************************************************/
HANDLE NEAR
CreateGraphMetaFile(HWND hWnd, LPSTR fileName, LPRECT pRect)
{
  DrawEnvPtr      pDEMeta;
  HDC              hMetaDC;
  HANDLE          hMetaFile;

	// dprintf("Writing out graph as MetaFile...\n");

  /* create a new DC and drawEnv for the metafile */
  hMetaDC = CreateMetaFile(fileName);
  pDEMeta = AllocDrawEnvPtr(hMetaDC, DE_PORT_PICTURE);
  DESetDestRect(pDEMeta, pRect);

  /* draw the graph if valid */
  if (gbGraphValid)
		{
  	DESetPortInfo(pDEMeta, hMetaDC, DE_PORT_PICTURE);

  	DrawBegin(pDEMeta);
    DrawTheGraph(pDEMeta, gpGraph, TRUE, TRUE, TRUE);
  	DrawEnd(pDEMeta);

    DESetDrawProcs(pDEMeta, DE_PROCS_DEFAULT);
  	}


  /* clean-up shop */
  hMetaFile = CloseMetaFile(hMetaDC);
  // dprintf("Written as %s.\n", fileName);

  FreeDrawEnvPtr(pDEMeta);


  return hMetaFile;
}

/*--------------------------------------------------------------------------*\
|          	  ChangeGraphType: Call PG SDK change graph type routine. 		    |
| This routine takes a single parameter, graphID, and uses its value to 	 	|
| determine an index into an array of type TDG_GraphPresetInfo. Each element|
| in this array represents the 2 parameters needed by the PG SDK call				  |
| SetGraphAttrSL needed to select a preset graphtype. 										  |
\*--------------------------------------------------------------------------*/
void NEAR PASCAL ChangeGraphType (WORD graphID)
  {
  int iGraph;
  static TDG_GraphPresetInfo GraphTable [9] ={{TDG_GRAPH_BARS 	, 8 },
																						  {TDG_GRAPH_LINES	, 0 },
																						  {TDG_GRAPH_AREA 	, 4 },
																						  {TDG_GRAPH_3D   	, 0 },
																						  {TDG_GRAPH_PIE		, 0 },
																						  {TDG_GRAPH_BARS		, 4 },
																						  {TDG_GRAPH_BARS		, 12},
																						  {TDG_GRAPH_SPECIAL, 3},
																						  {TDG_GRAPH_SPECIAL, 0 }};

	  

  switch (graphID)
	 {
	 case IDM_BAR:
 	   SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Above);
 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bFALSE);
	   iGraph = 0;
		 break;
	 case IDM_LINE:
  	 SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Above);
 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bTRUE);
	   iGraph = 1;
		 break;
	 case IDM_AREA:
  	 SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Center);
 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bTRUE);
	   iGraph = 2;
		 break;
	 case IDM_3D:
	   iGraph = 3;
		 break;
	 case IDM_PIE:
	   iGraph = 4;
		 break;
	 case IDM_BARS:
  	 SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Center);
 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bFALSE);
	   iGraph = 5;
		 break;
	 case IDM_BARP:
  	 SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Center);
 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bFALSE);
	   iGraph = 6;
		 break;
	 case IDM_SCATTER:
//  	 SetGraphAttrSL(gpGraph,NULL,A2D_PLACE_Y1,&Center);
// 	   SetGraphAttrSI (gpGraph, NULL, A2D_EXCLUDE_ZERO_Y1,&bFALSE);
	   iGraph = 7;
		 break;

	 case IDM_HISTOGRAM:
	   iGraph = 8;
		 break;

	 }
  /* PG SDK - MAKE CALL TO SELECT A DIFFERENT PRESET GRAPH TYPE */
  SetGraphAttrSL (gpGraph,NULL,A_GRAPH_PRESET, &GraphTable[iGraph]);
  }

/*--------------------------------------------------------------------------*\
|            	  UpdateMenu: Update Checkmarks on main menu               	 |
\*--------------------------------------------------------------------------*/

void NEAR PASCAL UpdateMenu (HMENU hmenu, WORD *mVar, WORD wParam)
	{
	CheckMenuItem(hmenu,*mVar,MF_BYCOMMAND | MF_UNCHECKED);
	*mVar = wParam;
	CheckMenuItem(hmenu,*mVar,MF_BYCOMMAND | MF_CHECKED);
	}



/*--------------------------------------------------------------------------*\
|            	       Edit Title Font Size: EditTitleProc 	          		 |
|  This function processes the messages from the TITLE_SIZE Dialog Box      |
\*--------------------------------------------------------------------------*/

BOOL FAR PASCAL EditTitleProc (HWND hdlg,	WORD wMsg,
									  WORD wParam, LONG lParam)
	{
	char	TempBuf [MaxStringSz];
	HWND	hCtl;
	int 	vFontSize,dFontSize;

	switch (wMsg)
		{

		case WM_INITDIALOG:

			/*
			**PG SDK - Get the current virtual font size of the title
			*/
		  	GetGraphAttrSI(gpGraph,gpSelItem,A_FONTSIZE_VC, &vFontSize);

			/*
			**PG SDK - Convert from virtual to device coordinates
			*/
			dFontSize = vdScaleHeight (gpDrawEnv, vFontSize);
			
  	      wsprintf (TempBuf, "%d", dFontSize);
			hCtl = GetDlgItem (hdlg, ID_FONTSIZE);
			SendMessage (hCtl,
						   WM_SETTEXT,
						   MaxStringSz,
					   	(LONG) (LPSTR) TempBuf);
		  	return TRUE;
		  	break;

		case WM_COMMAND:
			switch (wParam)
				{
				case ID_CANCEL:
					EndDialog (hdlg, ID_CANCEL);
					break;

				case ID_OK:

					hCtl = GetDlgItem (hdlg, ID_FONTSIZE);
					SendMessage (hCtl,
								 	WM_GETTEXT,
						 			MaxStringSz,
						 			(LONG) (LPSTR) TempBuf);
					dFontSize = atoi (TempBuf);

					/*
					**PG SDK - Convert from device to virtual coordinates
					*/
					vFontSize = dvScaleHeight (gpDrawEnv, dFontSize);

					/*
					**PG SDK - Set the current virtual font size of the title
					*/
				  	SetGraphAttrSI(gpGraph,gpSelItem,A_FONTSIZE_VC, &vFontSize);

					EndDialog (hdlg, ID_OK);
					break;

				default:
					return FALSE;
					break;
				}

		default:
			return FALSE;
		}
	}

/*--------------------------------------------------------------------------*\
|            	  XOR_List
\*--------------------------------------------------------------------------*/

INT16 NEAR XOR_List (HWND hWnd, SelListPtr pSelList, DrawEnvPtr pDrawEnv)
	{
	HDC hdc;
	INT16 ret = 0;
	RECT  r2;
   SelItemPtr		pSelItem;

	hdc = GetDC (hWnd);
   DESetPortInfo(pDrawEnv, hdc, DE_PORT_NORMAL);
   DrawBegin(pDrawEnv);
		ret =  Select_DrawXorList(pDrawEnv, pSelList);
   DrawEnd(pDrawEnv);
	ReleaseDC (hWnd,hdc);

	return (ret);
	}

/*--------------------------------------------------------------------------*\
|            	  LOCAL_GetStringCallback.						              		 |
| Gets asked by PG SDK for a particular piece of legend text. Returns the 	 |
| correct string by looking into the StringData array.                      |   
| The gs constants (gsTITLE,gsSUBTITLE) are enumerated in PG SDK.H			 |
\*--------------------------------------------------------------------------*/

INT16 FAR PASCAL  
LOCAL_GetStringCallback(
	INT16						nWhich,							/* Which legend?. */
	char FAR *			   lpBuffer,						/* Put answer here */
	INT16						nDimBuffer,						/* Max.size of answer */
	INT32						lClientData						/* client data */
)
{
switch (nWhich)
  {
  case gsTITLE:
    lstrcpy (lpBuffer,StringData[0]);	/* RETURN THE TITLE OF THE GRAPH */
	 break;
  case gsSUBTITLE:							/* RETURN THE SUBTITLE OF THE GRAPH */
    lstrcpy (lpBuffer,StringData[1]);
	 break;
  case gsFOOTNOTE:							/* RETURN THE GRAPH FOOTONOTE */
    lstrcpy (lpBuffer,StringData[28]);
	 break;
  case gsY1AXISTITLE:						/* RETURN THE Y1 AXIS TITLE */
  case gsSERIESTITLE:						/* RETURN THE SERIES TITLE */
    lstrcpy (lpBuffer,StringData[27]);
	 break;
  case gsXAXISTITLE:							/* RETURN THE X AXIS TITLE */
  case gsGROUPSTITLE:						/* RETURN THE GROUP TITLE */
    lstrcpy (lpBuffer,StringData[26]);
	 break;
  default:										/* PUT "XXXX" IN ANY OTHER REQUEST */
    lstrcpy (lpBuffer,"XXXX");
  }
return TRUE;
}


INT16 FAR PASCAL 
LOCAL_GetLabelCallback(
	INT16						nCol,				/* Set to -1 when traversing Row headers */
	INT16						nRow,				/* Set to -1 when traversing Col headers */ 
	char FAR *		   	lpBuffer,		/* Put answer here. */
	INT16						nDimBuffer,		/* Max.size of answer. */
	INT32						lClientData		/* client data value */
)
{
int i;

if (b8000Test)
	nCol %= 12;

if (nCol == -1) 	/* THIS MEANS WE'RE TRAVERSING ROW HEADERS */
  i = 2 + nRow;
else
  if (nRow == -1)	/* THIS MEANS WE'RE TRAVERSING COL HEADERS */
    i = 14 + nCol; /* OTHERWISE WE'RE TRAVERSING COLUMN HEADERS */
  else
    i = 28;			/* ANY OTHER REQUEST GETS THE FOOTNOTE STRING */

lstrcpy (lpBuffer,StringData[i]);	/* RETURN THE CORRECT HEADER */

return TRUE;
}


/*--------------------------------------------------------------------------*\
|            	  LOCAL_GetDataCallback.						              		    |
| Gets asked by PG SDK for a piece of numeric data corresponding to a			 |
| particular row & column offset.  Returns the 	                            |
| correct value by looking into the NumData array.                          |   
\*--------------------------------------------------------------------------*/

INT16 FAR PASCAL 
LOCAL_GetDataCallback(
	INT16						nDataPt,							/* Row number of requested value. */
	INT16						nSeries,							/* Column number of requested value. */
	REAL64 FAR *		   prVal,							/* Put answer here   */
	INT32						lClientData						/* client data value */
)
{
if (b8000Test)
	nSeries %= 12;
*prVal = (REAL64) NumData [nDataPt][nSeries];      /* RETURN THE VALUE */
return TRUE;
}


/*--------------------------------------------------------------------------*\
|            	  LOCAL_GetDataCallback.						          		    |
| Utility function that formats a numeric value of type REAL64 into a		 |
| string. Not used by any of the graphs in this program.							 |
\*--------------------------------------------------------------------------*/

INT16 FAR PASCAL 
LOCAL_RealToStrCallback(
	REAL64					rVal,								/* Value to be formatted. */
	char FAR *			lpszResult,							/* Caller provided buffer for string assigment. */
	INT16						nDimBuffer,						/* Buffer length. */
	INT16						nFmtCode,						/* Format conversion identifier. */
	INT32						lClientData						/* client data value */
)
{
wsprintf(lpszResult,"Hello %d",(int) rVal);	 		/* JUST DO SIMPLE INT FORMAT */
return TRUE;
}

/*--------------------------------------------------------------------------*\
|            	  LOCAL_SetPageCallback.						           		    |
| Not actually used by current PG SDK, but needed for expansion.  For now,    |
| just return FALSE 																			 |
\*--------------------------------------------------------------------------*/

INT16 FAR PASCAL 
LOCAL_SetPageCallback(
	INT16						nPage,								/* New current page. */
	INT32						lClientData						/* client data value */
)
{
return FALSE;
}

/************************************************************************
* 	InitDataCallBacks
*
*	DESCRIPTION:
*		This function connects the above CallBack functions with a 
*		particular graph.
*		
*	RETURNS:
*		FALSE if any of the callback functions are set to NULL.
*
************************************************************************/

BOOL PUBLIC InitDataCallBacks(HANDLE hInst, GraphPtr pGraph)
{
	GraphDataInfo		graphData;
	
	/*
	** PG SDK - Look up Data information connected to this graph
   */
	GetGraphDataInfo(pGraph, &graphData);
	
	/*
	** If the data information doesn't exist, create thunks as necessary
	*/
	if (!graphData.lpfnGetData)
	   { 
#if 0
		graphData.lpfnGetString    = (LPFNGetStringCallBack)    MakeProcInstance((FARPROC) LOCAL_GetStringCallback, hInst);
		graphData.lpfnGetLabel     = (LPFNGetLabelCallBack)     MakeProcInstance((FARPROC) LOCAL_GetLabelCallback,  hInst);
		graphData.lpfnGetData      = (LPFNGetDataCallBack)      MakeProcInstance((FARPROC) LOCAL_GetDataCallback,   hInst);
		graphData.lpfnSetPage      = (LPFNSetPageCallBack)      MakeProcInstance((FARPROC) LOCAL_SetPageCallback,   hInst);
		graphData.lpfnRealToString = (LPFNRealToStringCallBack) MakeProcInstance((FARPROC) LOCAL_RealToStrCallback, hInst);
#else
		graphData.lpfnGetString    = (LPFNGetStringCallBack)    LOCAL_GetStringCallback;
		graphData.lpfnGetLabel     = (LPFNGetLabelCallBack)     LOCAL_GetLabelCallback;
		graphData.lpfnGetData      = (LPFNGetDataCallBack)      LOCAL_GetDataCallback;
		graphData.lpfnSetPage      = (LPFNSetPageCallBack)      LOCAL_SetPageCallback;
		graphData.lpfnRealToString = (LPFNRealToStringCallBack) LOCAL_RealToStrCallback;
#endif
	   }
   
	/*
	** always set datalook-related info
	*/
	graphData.nPages      = 1;	 	/* THIS SHOULD ALWAYS BE SET TO 1 */
	if (b8000Test)
		{
  	graphData.nRows       = 3;	 /* SET TO NUMBER OF ROWS TO GRAPH */
	  graphData.nCols       = 1200;/* SET TO NUMBER OF COLUMNS TO GRAPH */
		}
	else
		{
  	graphData.nRows       = 3;	/* SET TO NUMBER OF ROWS TO GRAPH */
	  graphData.nCols       = 4;	/* SET TO NUMBER OF COLUMNS TO GRAPH */
		}

		/* PUT HANDLE TO THIS GRAPH INTO A FIELD THAT IS PASSED TO EVERY
		   DATA CALLBACK FUNCTION.  THIS LETS THE FUNCTION KNOW WHICH GRAPH
			IS DOING THE CALLING. */
	graphData.lClientData = (INT32) pGraph;	

	/* 
	** PG SDK - Register the callback functions with the PG SDK library 
	*/
	return SetGraphDataInfo(pGraph, &graphData);
}


/************************************************************************
* 	FiniDataCallBacks
*
*	DESCRIPTION:
*		This function dis-connects the above CallBack functions with a 
*		particular graph.
*		
*	RETURNS:
*		nothing.
*
************************************************************************/
VOID PUBLIC FiniDataCallBacks(GraphPtr pGraph)
{
	GraphDataInfo		graphData;
	
	GetGraphDataInfo(pGraph, &graphData);

	if (graphData.lpfnGetString) 
	  {
#if 0
		FreeProcInstance( graphData.lpfnGetString    );
		FreeProcInstance( graphData.lpfnGetLabel     );
		FreeProcInstance( graphData.lpfnGetData      );
		FreeProcInstance( graphData.lpfnSetPage      );
		FreeProcInstance( graphData.lpfnRealToString );
#else

#endif
	  }
	
}


/************************************************************************
*
*		Window Procedure: Draw the chart FULL SCREEN
*
************************************************************************/

long FAR PASCAL FullGraphWndProc (HWND hwnd, 	WORD wMsg,
											 WORD wParam,	LONG lParam)

{
static DrawEnvPtr      pDrawEnv;
static Rect rS;

	switch (wMsg)

		{
		case WM_CREATE:
		   pDrawEnv = AllocDrawEnvPtr(NULL, DE_PORT_NULL);
			break;

		case WM_DESTROY:
		   FreeDrawEnvPtr(pDrawEnv);
			ReleaseCapture();
			break;

		case WM_KEYDOWN:
 		   ShowWindow(hwnd, SW_HIDE);
			break;

 		case WM_LBUTTONDOWN:
 			{
 			POINT pt;
 			POINTS pts;
			BOOLEAN bFoundItem;

 		  	pts = MAKEPOINTS (lParam);	/* Get the Mouse Pt. */
			pt.x = pts.x;
			pt.y = pts.y;
 		  	dvPoint(pDrawEnv,&pt);		/*PG SDK - Convert to Virt. Coord's. */
			bFoundItem = FALSE;
   	   XOR_List(hwnd,gpList,pDrawEnv); 	 /*PG SDK - TURN XOR HANDLES ON */
	 	   Select_ClearList (gpList);  /*PG SDK - Clear our master list */	  
			do{
		     bFoundItem = FindNextDetNode (gpGraph, &pt, gpDetNode,bFoundItem);
			  if (bFoundItem)
			  	 gpSelItem = Select_AddItem(gpGraph,gpList,gpDetNode);	  
		     } while (bFoundItem);
	      Select_CalcHandlesList (pDrawEnv,gpList);
   	   XOR_List(hwnd,gpList,pDrawEnv);			/*PG SDK - TURN XOR HANDLES ON */
		   }
			break;

		case WM_PAINT:
		  {
			PAINTSTRUCT ps;
			HDC hdc;

			hdc = BeginPaint (hwnd, &ps);
				rS.top   = 0;
				rS.left  = 0;
				rS.right  = GetSystemMetrics(SM_CXSCREEN); /* the width of the screen */
			   rS.bottom = GetSystemMetrics(SM_CYSCREEN); /* the height of the screen */

			   DESetPortInfo(pDrawEnv, hdc, DE_PORT_NORMAL);
			   DESetDestRect(pDrawEnv, &rS);

			   DrawBegin(pDrawEnv);
			     DrawTheGraph(pDrawEnv, gpGraph, TRUE, TRUE, TRUE);
			   DrawEnd(pDrawEnv);

		      Select_RebuildList (gpGraph,gpList);

		      Select_CalcHandlesList (pDrawEnv,gpList);

		   EndPaint (hwnd, &ps);
		  }
		  break;

		default:
			return(DefWindowProc(hwnd,wMsg,wParam,lParam));
			break;
		}
	 return 0L;
}


/*--------------------------------------------------------------------------*\
|            	       Edit Data Dialog Procedure: EditDlgProc         		 |
|  This function processes the messages from the EDIT_DATA Dialog Box       |
\*--------------------------------------------------------------------------*/

BOOL FAR PASCAL EditDlgProc (HWND hdlg,	WORD wMsg,
									  WORD wParam, LONG lParam)
	{
	char	TempBuf [MaxStringSz];
	HWND	hCtl;
	int 	i,j,idx;

	switch (wMsg)
		{
		case WM_INITDIALOG:

				for (i=0; i<9; i++)
				  {
				  hCtl = GetDlgItem (hdlg, StringID[i]);
					if (i > 5)
					  idx = i+8;			/* Fixup since SAMP14 has a big data set */
					else
					  idx = i;

				  SendMessage (hCtl,
								   WM_SETTEXT,
								   MaxStringSz,
								   (LONG) (LPSTR) StringData[idx]);
				  };

				for (i=0; i<MaxEditRow; i++)
				  for (j=0; j<MaxEditCol; j++)
				    {
			  	    wsprintf (TempBuf, "%d", NumData[i][j]);
				    hCtl = GetDlgItem (hdlg, NumID[i][j]);
				    SendMessage (hCtl,
								 WM_SETTEXT,
								 MaxStringSz,
								 (LONG) (LPSTR) TempBuf);
				    };
				return TRUE;
				break;

		case WM_COMMAND:
			switch (wParam)
				{
				case ID_CANCEL:
					EndDialog (hdlg, ID_CANCEL);
					break;

				case ID_OK:

					for (i=0; i<9; i++)
				  	  {
				     hCtl = GetDlgItem (hdlg, StringID[i]);
							if (i > 5)
							  idx = i+8;			/* Fixup since SAMP14 has a big data set */
							else
							  idx = i;
				  	  SendMessage (hCtl,
								   WM_GETTEXT,
								   MaxStringSz,
								   (LONG) (LPSTR) StringData[idx]);
				 	  };

					MaxVal = -16000;

					for (i=0; i<MaxEditRow; i++)
				  		for (j=0; j<MaxEditCol; j++)
				    		{
				    		hCtl = GetDlgItem (hdlg, NumID[i][j]);
				    		SendMessage (hCtl,
										 	WM_GETTEXT,
								 			MaxStringSz,
								 			(LONG) (LPSTR) TempBuf);
						  	NumData[i][j] = atoi (TempBuf);

							if (MaxVal < NumData[i][j]) /* SEARCH FOR MAXVAL */
							  MaxVal = NumData[i][j];

				   	   };
					EndDialog (hdlg, ID_OK);
					break;

				default:
					return FALSE;
					break;
				}

		default:
			return FALSE;
		}
	}

